PROGRAM PSPtoCOL;
{
        PaintShopPro palette convertor v1.0

        Save your PSP palette as a JASC-PALETTE file, and then run this.

}
{}
USES CRT;
{}
CONST InFile  : string = '';
      Outfile : string = '';

VAR   f1   : text;
      f2   : file;
      s    : string;
      s2   : string;
      k    : integer;
      i    : byte;
      r,g,b : byte;
{}
PROCEDURE _ShowInfo;
BEGIN
  writeln;
  writeln('USAGE:');
  writeln('    PSP2COL <INFILE> <OUTFILE>');
  writeln;
  halt;
END;
{}
BEGIN
  writeln('PSP2COL palette convertor');
  writeln('Converts JASC-PALETTE files (paintshoppro) to raw palette data.');

  if paramcount<2 then _ShowInfo;
  InFile:=paramstr(1);
  OutFile:=paramstr(2);

  assign(f1,infile); {$i-} reset(f1); {$i+}
  if ioresult<>0 then begin
     writeln(Infile,' not found.');
     halt;
  end;
  assign(f2,outfile); {$i-} rewrite(f2,1); {$i+}
  if ioresult<>0 then begin
     writeln(outfile,' could not be created.');
     halt;
  end;

  { Check on JASC-PAL ID }
  readln(f1,s);
  if s<>'JASC-PAL' then begin
     writeln(infile,' is not a valid JASC-PAL file.');
     halt;
  end;
  readln(f1,s); { dont know what this value means, so just skip it! }

  { Check on 256 colors tag }
  readln(f1,s);
  if s<>'256' then begin
     writeln(infile,' is not a valid 256 color PAL.');
     halt;
  end;

  { Do the wild thing }
  writeln('converting ['+infile+'] to ['+outfile+']');

  for i:=0 to 255 do begin
      readln(f1,s); s:=s+' ';
      { read RED value }
      s2:=copy(s,1,pos(' ',s)-1);
      s:=copy(s,pos(' ',s)+1,length(s));
      val(s2,r,k);
      if k<>0 then begin
         writeln('Error occured while reading data.');
         halt;
      end;
      { read GREEN value }
      s2:=copy(s,1,pos(' ',s)-1);
      s:=copy(s,pos(' ',s)+1,length(s));
      val(s2,g,k);
      if k<>0 then begin
         writeln('Error occured while reading data.');
         halt;
      end;
      { read BLUE value }
      s2:=copy(s,1,pos(' ',s)-1);
      s:=copy(s,pos(' ',s)+1,length(s));
      val(s2,b,k);
      if k<>0 then begin
         writeln('Error occured while reading data.');
         halt;
      end;
      { save the RAW data }
      blockwrite(f2,r,1);
      blockwrite(f2,g,1);
      blockwrite(f2,b,1);
  end;

  writeln('Done.');
  close(f2);
  close(f1);

END.