PROGRAM MapConv;
{
        Converts old SFX-maps to the new format...

}

USES CRT,SUPERFX;

{$IFDEF MSDOS}
   {$M 16384,0,5000}      { now use MEMALLOC/DALLOC instead of GETMEM/FREEMEM}
{$ELSE}
   {$M 65520,0,655360}    { just use GETMEM/FREEMEM }
{$ENDIF}



CONST   MAPID2       : string = 'SUPERFX';  { ID to save in MAP file }
        MAPID        : string = 'SUPERFXv1';
{}
VAR     file1,file2  : file;
        name1,name2  : string;
{}
CONST  DFPFile     : string = '';
       BlockFile   : string = '';
       blockDFP    : boolean = false;
       ParaFile    : string = '';
       paraDFP     : boolean = false;
       PalFile     : string = '';
       palDFP      : boolean = false;
       ColorFile   : string = '';
       ColDFP      : boolean = false;

{}
{
        Load a map file, created with MAPED

        Expects: LIB=TRUE if we want to load from a DFP file,
                 and the filename to use
        Returns: TRUE if succesfull else halt_error contains the error string
}
FUNCTION LoadMap(lib:boolean;filename:String):boolean;
TYPE IMapType = record
          F_Frame : byte;
          BitFlag : byte;
     end;
VAR LoadID    : string;
    code      : byte;
    x,y       : word;
    mx,my     : word;
    temp      : TLight;
BEGIN
  Halt_Proc:='LoadMap';

  if LIB then begin                     { use library? }
     code:=lib_Reset(filename);         { get the file }
     IF code<>0 then begin              { if code<>0 we got a error }

        LoadMap:=false;                 { no Map can be loaded }
        Halt_Error:='Couldn''t spawn map '+filename;
        exit;

     END;
  end else begin
       assign(lib_file,filename);
       {$I-}
            reset(lib_file,1);    { open file }
       {$I+}
       if ioresult<>0 then begin
          LoadMap:=false;
          halt_error:='Couldn''t spawn map '+filename;
          exit;
       end;
       key_start:=0;
       key_size:=filesize(lib_file);
  end;


  MapFile:=Filename;
  MapLib:=true;
  { First check on the ID of the file }
  blockread(lib_file,LoadID[1],length(MapID2));
  LoadID[0]:=char(length(MapId2));
  if LoadID<>MapID2 then begin

     LoadMap:=false;
     Halt_Error:='Couldn''t spawn MAP file, non valid';
     close(lib_file);
     exit;

  end;

  if map<>nil then begin
    {$IFDEF MSDOS}
      DAlloc(map);
    {$ELSE}
      FreeMem(map,(mapheight*mapwidth)*sizeof(MapType)+1000);
    {$ENDIF}
  end;
  EraseLightAll;


  { read width+height of the map }
  blockread(lib_file,MapWidth,sizeof(MapWidth));
  blockread(lib_file,MapHeight,sizeof(mapheight));

  {$IFDEF MSDOS}
     MemAlloc(map,(mapheight+1)*(mapwidth+1)*sizeof(maptype)+1000);
  {$ELSE}
     GetMem(map,(mapheight+1)*(mapwidth+1)*sizeof(maptype)+1000);
  {$ENDIF}


  if (map=NIL) then begin
     close(lib_file);
     LoadMap:=false;
     Halt_error:='out of memory';
     exit;
  end;
  { read start position(s) of player }
  blockread(lib_file,PlayerStartX,sizeof(PlayerStartX));
  blockread(lib_file,PlayerStartY,sizeof(PlayerStartY));

  { read main map data }
  mx:=0;
  for x:=0 to Mapwidth do begin
    my:=0;
    for y:=0 to Mapheight do begin
      blockread(lib_file,mem[seg(map^):ofs(map^)+((my*(mapwidth+1))+mx)*sizeof(MapType)],sizeof(IMapType));
      inc(my);
    end;
    inc(mx);
  end;
  maptitle:='';
  if not eof(lib_file) then begin
     blockread(lib_file,x,1);
     if x=255 then begin
      y:=filepos(lib_file);
      blockread(lib_file,usecopper,sizeof(usecopper));
      y:=filepos(lib_file);
      blockread(lib_file,useLayer,sizeof(uselayer));
      y:=filepos(lib_file);
      blockread(lib_file,FullLayer,sizeof(fulllayer));
      y:=filepos(lib_file);
      blockread(lib_file,forcehight,sizeof(forcehight));
      blockread(lib_file,copperrevers,sizeof(copperrevers));
      blockread(lib_file,multiplespeeds,sizeof(multiplespeeds));
      blockread(lib_file,coppertop,sizeof(coppertop));
      blockread(lib_file,copperbottom,sizeof(copperbottom));
      blockread(lib_file,copperhight,sizeof(copperhight));
      blockread(lib_file,layernr,sizeof(layernr));
      blockread(lib_file,maptitle[1],30);
      maptitle[0]:=#30;
   end;
  end;
  if not eof(lib_File) then begin       { Read LIGHT-SOURCING }
     blockread(lib_file,x,1);
     if x=255 then begin
      blockread(Lib_File,LSourceA,sizeof(LSourceA));
      for x:=1 to LSourceA do begin
        Blockread(lib_file,temp.x1,sizeof(temp.x1));
        Blockread(lib_file,temp.y1,sizeof(temp.y1));
        Blockread(lib_file,temp.x2,sizeof(temp.x2));
        Blockread(lib_file,temp.y2,sizeof(temp.y2));
        Blockread(lib_file,temp.LightFlag,sizeof(temp.LightFlag));
        Blockread(lib_file,temp.StartBright,sizeof(temp.StartBright));
        Blockread(lib_file,temp.SubMap,sizeof(temp.SubMap));

         with temp do
           AddLight(x1,y1,x2,y2,startbright,submap,lightflag);
      end;
     end;
  end;
  close(lib_file);

  { init variables }
  mapx:=0;
  mapy:=0;
  Map_Calculate;

  LoadMap:=True;

  initcopper;
END;


{}
{
        Save the map file specified in the FILENAME variable

        Expects: Nothing
        Returns: Nothing
}
FUNCTION SaveMap(filename:string):boolean;
VAR f : file;
    zin : string;
    temp      : PLight;
BEGIN
 SaveMap:=false;

 assign(f,filename); rewrite(f,1);
    blockwrite(f,MapId[1],length(mapid));
    {---- write mapwidth and mapheight ----}
    blockwrite(f,mapwidth,sizeof(mapwidth));
    blockwrite(f,mapheight,sizeof(mapheight));
    {---- write start position(s) ----}
    blockwrite(f,PlayerStartX,sizeof(PlayerStartX));
    blockwrite(f,PlayerStartY,sizeof(PlayerStartY));
    {---- write the map DATA ----}
    for x:=0 to Mapwidth do begin
      for y:=0 to Mapheight do begin
        blockwrite(f,mem[seg(map^):ofs(map^)+((y*(mapwidth+1))+x)*sizeof(MapType)],sizeof(MapType));
      end;
    end;

    x:=255;
    blockwrite(f,x,1);
    {---- Write the extra DATA ----}
    blockwrite(f,usecopper,sizeof(usecopper));
    blockwrite(f,useLayer,sizeof(uselayer));
    blockwrite(f,FullLayer,sizeof(fulllayer));
    blockwrite(f,forcehight,sizeof(forcehight));
    blockwrite(f,copperrevers,sizeof(copperrevers));
    blockwrite(f,multiplespeeds,sizeof(multiplespeeds));
    blockwrite(f,coppertop,sizeof(coppertop));
    blockwrite(f,copperbottom,sizeof(copperbottom));
    blockwrite(f,copperhight,sizeof(copperhight));
    blockwrite(f,layernr,sizeof(layernr));
    blockwrite(f,maptitle[1],30);

    {---- WRITE LIGHT-SOURCES ----}
    temp:=FirstLight;
    x:=255;
    blockwrite(f,x,1);
    blockwrite(f,LSourceA,sizeof(LSourceA));
    while temp<>Nil do begin
        blockwrite(f,temp^.x1,sizeof(temp^.x1));
        blockwrite(f,temp^.y1,sizeof(temp^.y1));
        blockwrite(f,temp^.x2,sizeof(temp^.x2));
        blockwrite(f,temp^.y2,sizeof(temp^.y2));
        blockwrite(f,temp^.LightFlag,sizeof(temp^.LightFlag));
        blockwrite(f,temp^.StartBright,sizeof(temp^.StartBright));
        blockwrite(f,temp^.SubMap,sizeof(temp^.SubMap));
        Temp:=temp^.next;
    end;

    {---- Save tile, palette,etc... information ----}
       blockwrite(f,DFPfile,length(dfpfile)+1);
       blockwrite(f,blockDFP,1);
       blockwrite(f,blockfile,length(blockfile)+1);
       blockwrite(f,paraDFP,1);
       blockwrite(f,parafile,length(parafile)+1);
       blockwrite(f,palDFP,1);
       blockwrite(f,palfile,length(palfile)+1);

    {---- Show SUMA mark in the file ----}
    zin:='--[ Map created with SUMA ]--';
    blockwrite(f,zin[1],length(zin)-1);
 close(f);
 SaveMap:=true;
END;
{}

BEGIN
  writeln('MAP update v1.0');
  writeln;
  if (paramcount<2) or (paramstr(1)='/?') or (paramstr(1)='-?') or
     (paramstr(1)='?') then begin
       writeln('Just specify the OLD map name, and the NEW map name');
       halt;
  end;

  name1:=paramstr(1);
  name2:=paramstr(2);

  if not loadmap(false,name1) then begin
         writeln('OLD map file not found');
         halt;
  end;

  savemap(name2);
  writeln('Done.');
  writeln('Map ('+name2+') saved.');
  writeln('Now load it into SUMA, and select the correct graphic-files.');
  writeln('Then save it, and you can use it in the SuperFX engine.');
END.