UNIT PlatPlay;
{
******************************************************************************

    PlayformPlayer  - programming by P.Bestebroer

    Unit was written for the SuperFX Engine, it creates a player-object
    that can be used for platform games....

    Platform games are games like JazzJackrabbit, Mario Bros, etc...

    --- Totally FreeWare ---

******************************************************************************
}
{


    Player Ojbect - for Platform Games


}


{}
  INTERFACE
{}
USES SuperFX,SFX_Vars;


CONST PlayDemo     : boolean = false;   { TRUE when you wish to PLAY a demo  }
      RecordDemo   : Boolean = False;   { TRUE when you record a demo        }
      DemoDone     : boolean = False;   { TRUE when PLAYING has finished     }


{}
TYPE TPlayerPlatForm   =  object
      DownPressed        : boolean;     { TRUE if pressed down to jump below }
      Xposition          : word;        { X position on the map in pixels }
      Yposition          : word;        { Y position on the map in pixels }
      Flipped            : boolean;     { Using mirrored images? }
      ground             : boolean;     { player walking on ground? }
      GroundFall         : boolean;     { if hit ground }
      Yspeed,Xspeed      : real;        { X and Y speed }

      shooting           : boolean;     { True if FIRE was pressed }

      score              : longint;     { take a guess?! }
      ScoreTXT           : string[9];   { the score is 9 digits }

      CurrentIMG         : byte; { Current animation frame }
        PROCEDURE Init;          { initialise the position, and variables }
        PROCEDURE Detection;     { detection of map-blocks (ground,wall,etc) }

        PROCEDURE Movement; {(tleft,tright,tup,tdown,tfire:boolean);}

        PROCEDURE AddScore(points:word); { add points to the score }
        PROCEDURE ShowScore(x,y:word);   { show the score at X,Y position }
     END;
{}

VAR  PlayerImages : array[0..25] of SpriteTyp;{ the sprite-data of the player}
     Player       : TplayerPlatform;          { a complete PLAYER! }

{}
IMPLEMENTATION
{}
{
        Initialise the Player variables, and the map-position

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerPlatform.Init;
BEGIN
    Xposition:=PlayerStartX shl TileShiftFactor;
    Yposition:=PlayerStartY shl TileShiftFactor;
    Flipped:=false;
    Ground:=false;
    GroundFall:=false;
    score:=000000000;
    ScoreTXT:='000000000';
    Xspeed:=0;
    Yspeed:=0;
    CurrentImg:=1;
    ASM
       mov ax,player.Xposition
       sub ax,160
       mov mapx,ax
       mov bx,player.Yposition
       sub bx,100
       mov mapY,bx
       Call Map_Calculate
    end;
    {

        See for ground below

    }
    with PLAYER do begin
         CASE mapPos((xposition shr TileShiftFactor)+1,yposition shr TileShiftFactor,mapBitFlag) of
         1..2 : BEGIN
                 Yposition:=Yposition shr TileShiftFactor;
                 inc(Yposition);
                 Yposition:=Yposition shl TileShiftFactor;
                 dec(Yposition,mem[seg(PlayerImages[0].data^):ofs(PlayerImages[0].data^)+1]);
                END;
         end;
    end;
END;

{}
{
        Add points to the score (score value, and scoreTEXT will be updated)

        Expects: Amount of points to increase the score with
        Returns: Nothing
}
PROCEDURE TPlayerPlatform.AddScore(points:word);
BEGIN
 inc(score,points);                     { increase score counter             }
 str(score,scoreTXT);                   { set it into a string only once     }
 fillchar(scoreTXT[1],9-length(scoreTXT),'0');   { add some zeros infront    }
 scoreTXT[0]:=char(9);                  { make sure it's only 9 characters   }
END;
{}
{
        Show the score of the player

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerPlatform.ShowScore(x,y:word);
BEGIN
 WTEXT(x,y,scoreTXT,1);    { simply put the score on screen }
END;
{}
{
        Do detection on the player hitting background objects

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TplayerPlatform.Detection;
VAR ty2,ty3,tx2,tx3   : word;
    x,y               : word;
    ctop              : boolean;
    cbot              : boolean;
    cright            : boolean;
    cleft             : boolean;
    cslope            : boolean;
    wi,hi             : byte;
    xt,yt,
    mapt              : integer;
    dataptr           : pointer;
    bitflag,f_Frame   : byte;
BEGIN
 ASM
  mov ax,player.yposition
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,player.xposition
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax

  mov cslope,false
  mov ctop,false
  mov cbot,false
  mov cleft,false
  mov cright,false
  mov cleft,false
 END;

 { Get width and height of player image }
 wi:=mem[seg(PlayerImages[currentIMG].data^):ofs(PlayerImages[currentIMG].data^)];
 hi:=mem[seg(PlayerImages[currentIMG].data^):ofs(PlayerImages[currentIMG].data^)+1];

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
   {==========================================================================
        Now get the blocks above,below,left and on the right side of the
        player
   ==========================================================================}
       BitFlag:=mapPos(x,y,mapBitflag);
       f_frame:=mapPos(x,y,mapF_frame);
        yt:=y shl TileShiftFactor;
        {=====================================================================
            See if this block is not just empty-air
        =====================================================================}
        { Some testing now... }
        IF BITFLAG<>0 THEN BEGIN
           {==================================================================
              Slope testing
           ==================================================================}
           if (yspeed>=0.0) and (collision( xt,yt,
                          mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)],
                          mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1],
                          xposition+15,yposition,1,hi))
                          then begin
                             CASE BITFLAG of
                              4 : begin   { slope like  \  }
                                    Yposition:=1+yt-hi+( (( (Xposition+15)-xt) shl 1)+1) shr 1;
                                    Yspeed:=0;
                                    CBot:=true;
                                    ground:=true;
                                  end;
                              5 : begin   { slope like  / }
                                    Yposition:=1+yt-hi+32-( (( (Xposition+15)-xt) shl 1)+1) shr 1;
                                    CBot:=true;
                                    Yspeed:=0;
                                    ground:=true;
                                  end;
                             END; { end case }
           end;

           {==================================================================
              See player position (block behind the player)
           ==================================================================}
           if (collision( xt,yt,
                          mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)],
                          mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1],
                          xposition,yposition+1,wi,hi))
                          then begin
                             CASE BITFLAG of
                             { ********************
                                 Secret IDentifier
                             **********************}
                               1: begin
                               end;
                             end; { case blocktype }
           end;

           {==================================================================
              See Top of player
           ==================================================================}
           IF NOT CTOP then
           if (collision( xt+5,
                          yt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-5,
                          mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)]-10,5,
                          xposition,yposition,wi,10))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                                  1 : begin
                                         yposition:=1+yt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1];
                                         yspeed:=0.2;
                                         ground:=false;
                                         ctop:=true;
                                      end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Bottom of player
           ==================================================================}
           IF NOT cbot then
           if (yspeed>0.0) and  (collision( xt+5,yt-1,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)]-10,7,
                           xposition,yposition+hi-5,wi,5))
                           then begin
                             CASE BITFLAG of
                             { **************
                                 Walk able
                             ****************}
                                  1,6: begin
                                          yposition:=yt-hi;
                                          Yspeed:=0;
                                          ground:=true;
                                          cbot:=true;
                                         end;
                                  2  : begin
                                         if not DownPressed then begin
                                            yposition:=yt-hi;
                                            Yspeed:=0;
                                            ground:=true;
                                            cbot:=true;
                                         end;
                                       end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Right Side of the player
           ==================================================================}
           if not cright then
           if (xspeed>0) and (collision(xt,yt+5,5,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-10,
                         xposition+wi,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                   Massive Block
              ********************}
                1 : begin
                     xposition:=xt-wi;
                     xspeed:=0;
                     cright:=true;
                    end;
              end; { case blocktype }
           end;
           {==================================================================
              See Left Side of the player
           ==================================================================}
           if not cleft then
           if (xspeed<0) and
              (collision(xt,yt+5,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)],
                         mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-10,
                         xposition,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                  Massive Block
              ********************}
                1 : begin
                     xposition:=xt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)];
                     xspeed:=0;
                     cleft:=true;
                    end;
              end; { case blocktype }
           end; { end left side }
    { --------------------------------------------------------------------- }
    END; { end collision_detection }
  END; { Y counter }
 END; { X counter }
END;
{}
{
        Do the player movements

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerPlatform.Movement;
VAR Tleft,TRight,TDown,Tup,TFire : boolean;
BEGIN
   Shooting:=False;

   if PlayDemo then begin
      _PlayDemo;
      If DEMplay=false then DemoDone:=true;
   end;

   Tleft:=JoystickLeft;
   Tright:=JoystickRight;
   TUp:=JoystickUp;
   TDown:=JoystickDown;
   TFire:=JoystickA;

   Ground:=false;
   Detection;

   if RecordDemo then _RecordDemo;

   if not GROUND then begin
      if yspeed<7 then yspeed:=yspeed+0.3;
   end else DownPressed:=false;

   WITH PLAYER DO BEGIN
        IF Tleft then begin
                 if not Flipped then Flipped:=true;
                 if xspeed>-2 then xspeed:=xspeed-0.2;
                 if ground then begin
                     if currentimg>5 then currentimg:=0;
                     currentIMG:=playerimages[currentimg].a_Frame;
                 end;
        end else IF Tright then begin
                 if FLIPPED then Flipped:=false;
                 if xspeed<2 then xspeed:=xspeed+0.2;
                 if ground then begin
                    if currentimg>5 then currentimg:=0;
                    currentIMG:=playerimages[currentimg].a_Frame;
                 end;
        end else begin
                 if xspeed>0.0 then xspeed:=xspeed-0.2
                 else
                   if xspeed<0.0 then xspeed:=xspeed+0.2
                 else xspeed:=0;
               CurrentIMG:=3;
        end;

        IF (round(xspeed)=0) and (round(Yspeed)=0) then begin
           CurrentIMG:=0;
{
           if Flipped then begin
              if mapPos((xposition shr TileShiftFactor)+1,(yposition shr TileShiftFactor)+1,mapBitFlag)=0 then inc(CurrentImg);
           end else begin
              if (mapPos((xposition shr TileShiftFactor)+1,(yposition shr TileShiftFactor)+1,mapBitFlag)=0) and
                 (xposition and 31>15) then inc(CurrentImg);
           end;
}
        end else
           if round(yspeed)<>0 then currentImg:=1;

        IF (TUp) then begin
           if (GROUND) then begin
              yspeed:=-4.6;
              GroundFall:=true;
           end;
        END;

        IF TDown then DownPressed:=true else
           if yspeed>4 then DownPressed:=false;

        Xposition:=Xposition+round(Xspeed);
        if (xposition-mapx)>294 then begin
           if xspeed<0 then xposition:=0 else xposition:=294+mapx;
           xspeed:=0;
        end;
        if (xposition)<0 then begin
           xposition:=0;
           xspeed:=0;
        end;

        Yposition:=Yposition+round(Yspeed);
        if Yposition>6400 then begin
           yposition:=0;
           yspeed:=0;
        end;
        asm
         mov ax,player.Xposition
         sub ax,155
         mov mapx,ax
         mov bx,player.Yposition
         sub bx,95
         mov mapY,bx
         Call Map_Calculate
        end;
        AddIMAGE( Player.Xposition-MAPX,Player.Yposition-MAPY,
                  PlayerImages[CurrentImg].data,Flipped,false);
   END;
END;


BEGIN
END.