UNIT TopPlay;
{
******************************************************************************

    TopDownPlayer  - programming by P.Bestebroer

    Unit was written for the SuperFX Engine, it creates a player-object
    that can be used for top-down games....

    Top-Down games are games like gauntlet, micro-machines, etc...


    --- Totally FreeWare ---

******************************************************************************
}
{


    Player Ojbect - for TopDown Games


}


{}
  INTERFACE
{}
USES SuperFX,SFX_Vars;


CONST PlayDemo     : boolean = false;   { TRUE when you wish to PLAY a demo  }
      RecordDemo   : Boolean = False;   { TRUE when you record a demo        }
      DemoDone     : boolean = False;   { TRUE when PLAYING has finished     }


{}
TYPE TPlayerTopDown   =  object
      Xposition          : integer;     { xposition for drawing              }
      Yposition          : integer;     { Yposition for drawing              }
      FireCount          : byte;        { counter before refiering           }

      Shooting           : boolean;     { TRUE if FIREkey was pressed        }

      Yspeed,Xspeed      : real;        { X and Y speed in REAL format       }
      YDir,XDir          : shortint;    { Direction in wich player is facing }
      CurrentIMG         : byte;        { Current animation frame            }
      AddImg             : byte;        { Add Amount for walking animation   }
      AddCount           : shortint;    { Add counter for animation-speed    }
      AddTimer           : byte;        { Add timer for animation-speed      }

      score              : longint;     { take a guess?!                     }
      ScoreTXT           : string[9];   { the score is 9 digits              }


        PROCEDURE Init;          { initialise the position, and variables }
        PROCEDURE Detection;     { detection of map-blocks (ground,wall,etc) }

        PROCEDURE Movement;      { Call this for handling movement           }

        PROCEDURE AddScore(points:word); { add points to the score }
        PROCEDURE ShowScore(x,y:word);   { show the score at X,Y position }
     end;

{}

VAR  PlayerImages : array[0..25] of SpriteTyp;{ the sprite-data of the player}
     Player       : TplayerTopDown;           { a complete PLAYER! }

{}
IMPLEMENTATION
{}
{
        Initialise the Player variables, and the map-position

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerTopDown.Init;
BEGIN
        Xposition:=PlayerStartX shl TileShiftFactor; { Get START X           }
        Yposition:=PlayerStartY shl TileShiftFactor; { Get START Y           }
        FireCount:=0;                                { Shooting timer        }
        Shooting:=False;                             { TRUE when firekey     }
        Xspeed:=0;                                   { Horizontal Speed      }
        Yspeed:=0;                                   { Vertical Speed        }
        Ydir:=1;                                     { Current direction     }
        Xdir:=0;                                     { Current Direction     }
        CurrentImg:=12;                              { Current SPRITE IMAGE  }
        AddImg:=1;                                   { For animation         }
        AddCount:=1;                                 { For animation         }
        AddTimer:=4;                                 { For animation         }


        score:=000000000;
        ScoreTXT:='000000000';

        ASM
         mov ax,Xposition
         sub ax,160
         mov mapx,ax
         mov bx,Yposition
         sub bx,100
         mov mapY,bx
         Call Map_Calculate
        END;
END;
{}
{
        Add points to the score (score value, and scoreTEXT will be updated)

        Expects: Amount of points to increase the score with
        Returns: Nothing
}
PROCEDURE TPlayerTopDown.AddScore(points:word);
BEGIN
 inc(score,points);                     { increase score counter             }
 str(score,scoreTXT);                   { set it into a string only once     }
 while length(scoreTXT)<9 do scoreTXT:='0'+scoreTXT;
 scoreTXT[0]:=char(9);                  { make sure it's only 9 characters   }
END;
{}
{
        Show the score of the player

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TPlayerTopDown.ShowScore(x,y:word);
BEGIN
 WTEXT(x,y,scoreTXT,1);    { simply put the score on screen }
END;
{}
{
        Do detection on the player hitting background objects

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE TplayerTopDown.Detection;
VAR ty2,ty3,tx2,tx3   : word;
    x,y               : word;
    cbehind           : boolean;
    ctop              : boolean;
    cbot              : boolean;
    cright            : boolean;
    cleft             : boolean;
    wi,hi             : byte;
    xt,yt,
    mapt              : integer;
    dataptr           : pointer;
    bitflag,f_Frame   : byte;
BEGIN
 ASM
  mov ax,player.yposition
  shr ax,TileshiftFactor
  cmp ax,0
  jng @nodecreaseY
  dec ax
 @nodecreaseY:
  mov ty2,ax
  add ax,2
  mov ty3,ax
  mov ax,player.xposition
  shr ax,TileShiftFactor
  cmp ax,0
  jng @nodecreaseX
  dec ax
 @nodecreaseX:
  mov tx2,ax
  add ax,2
  mov tx3,ax

  mov cbehind,false
  mov ctop,false
  mov cbot,false
  mov cleft,false
  mov cright,false
  mov cleft,false
 END;

 { Get width and height of player image }
 wi:=mem[ seg(PlayerImages[PlayerImages[currentIMG].c_Frame].data^):
          ofs(PlayerImages[PlayerImages[currentIMG].c_Frame].data^)];
 hi:=mem[ seg(PlayerImages[PlayerImages[currentIMG].c_Frame].data^):
          ofs(PlayerImages[PlayerImages[currentIMG].c_frame].data^)+1];

 FOR x:=tx2 to tx3 do begin
   xt:=x shl TileShiftFactor; { calculate X shl 5 only onces per vertical Row! }
   FOR y:=ty2 to ty3 do begin
   {==========================================================================
        Now get the blocks above,below,left and on the right side of the
        player
   ==========================================================================}
       BitFlag:=mapPos(x,y,mapBitflag);
       F_frame:=mapPos(x,y,mapF_Frame);
        yt:=y shl TileShiftFactor;
        {=====================================================================
            See if this block is not just empty-air
        =====================================================================}
        { Some testing now... }
        IF BITFLAG<>0 THEN BEGIN
           {==================================================================
              See behind player
           ==================================================================}
           IF NOT CBEHIND then
           if (collision( xt+8,yt+8,16,16,
                          xposition,yposition,wi,hi))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                               1 : BEGIN
                               end;
                             end; { case blocktype }
           end;

           {==================================================================
              See Top of player
           ==================================================================}
           IF NOT CTOP then
           if (yspeed<0.0) and (collision( xt+5,
                          yt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-3,
                          mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)]-10,5,
                          xposition,yposition,wi,10))
                          then begin
                             CASE BITFLAG of
                             { *****************
                                 Massive Block
                             ******************}
                                  1..2 : begin
                                         yposition:=yt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1];
                                         yspeed:=0;
                                         ctop:=true;
                                      end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Bottom of player
           ==================================================================}
           IF NOT cbot then
           if (yspeed>0.0) and  (collision( xt+5,yt-1,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)]-10,7,
                           xposition,yposition+hi-5,wi,5))
                           then begin
                             CASE BITFLAG of
                             { **************
                                 Walk able
                             ****************}
                                  1..2  : begin
                                          yposition:=yt-hi;
                                          Yspeed:=0;
                                          cbot:=true;
                                         end;
                             end; { case blocktype }
           end;
           {==================================================================
              See Right Side of the player
           ==================================================================}
           if not cright then
           if (xspeed>0.0) and (collision(xt,yt+5,5,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-10,
                         xposition+wi,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                   Massive Block
              ********************}
                1..2 : begin
                     xposition:=xt-wi;
                     xspeed:=0;
                     cright:=true;
                    end;
              end; { case blocktype }
           end;
           {==================================================================
              See Left Side of the player
           ==================================================================}
           if not cleft then
           if (xspeed<0) and
              (collision(xt,yt+5,mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)],
                         mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)+1]-10,
                         xposition,yposition,1,hi)) then begin
              CASE BITFLAG of
              {*******************
                  Massive Block
              ********************}
                1..2 : begin
                     xposition:=xt+mem[seg(tiles[f_Frame].data^):ofs(tiles[f_Frame].data^)];
                     xspeed:=0;
                     cleft:=true;
                    end;
              end; { case blocktype }
           end; { end left side }
    { --------------------------------------------------------------------- }
    END; { end collision_detection }
  END; { Y counter }
 END; { X counter }
END;
{}
{
        Do the player movements

        Expects: Nothing
        Returns: Nothing
}

PROCEDURE TPlayerTopDown.Movement;
VAR Tleft,Tright,Tup,Tdown,Tfire : boolean;
BEGIN
   Shooting:=false;
   if PlayDemo then begin
      _PlayDemo;
      If DEMplay=false then DemoDone:=true;
   end;

   TLeft:=JoystickLeft;
   TRight:=JoystickRight;
   TUp:=JoystickUp;
   TDown:=JoystickDown;
   TFire:=JoystickA;

   {=-=-=-=   Do the wall detections   =-=-=-=-=-=}
   Detection;


   if RecordDemo then _RecordDemo; {(Tleft,Tright,Tup,TDown,TFire);}

   {=-=-=-=     Horizontal movements   =-=-=-=-=-=}
   IF Tleft then begin
         xspeed:=-0.6;
   end else IF Tright then begin
        xspeed:=0.6;
   end else begin
        xspeed:=0.0;
   end;
   {=-=-=-=-=     Vertical movements    =-=-=-=-=}
   IF Tup then begin
          {if currentIMG<>4 then currentIMG:=4;}
          yspeed:=-0.6;
   end else IF Tdown then begin
          {if currentIMG<>8 then currentIMG:=8;}
          yspeed:=0.6;
   end else begin
       yspeed:=0.0;
   end;


   if yspeed<0.0 then begin
      if xspeed=0.0 then CurrentImg:=0
         else if xspeed>0.0 then CurrentImg:=3
              else Currentimg:=21;
   end else
       if yspeed>0.0 then begin
          if xspeed>0.0 then CurrentImg:=9
             else if xspeed=0.0 then CurrentImg:=12
                  else CurrentImg:=15;
   end else if xspeed>0.0 then CurrentImg:=6
               else if xspeed<0.0 then CurrentImg:=18;

   case CurrentIMG of
     0 : begin Ydir:=-1; Xdir:=0; end;
     3 : begin Ydir:=-1; Xdir:=1; end;
     6 : begin Ydir:=0; Xdir:=1; end;
     9 : begin Ydir:=1; Xdir:=1; end;
    12 : begin Ydir:=1; Xdir:=0; end;
    15 : begin Ydir:=1; Xdir:=-1; end;
    18 : begin Ydir:=0; Xdir:=-1; end;
    21 : begin Ydir:=-1; Xdir:=-1; end;
   end;

   if (Xspeed<>0.0) or (Yspeed<>0.0) then
      if AddTimer>0 then dec(AddTimer) else begin
         AddTimer:=10;
         inc(AddImg,AddCount);
         if (AddImg=2) or (AddImg=0) then AddCount:=-AddCount;
   end;

   if Firecount>0 then dec(firecount) else begin
      if TFire then begin
         FireCount:=13;
         Shooting:=TRUE;
      end;
   end;

   Xposition:=Xposition+round(XspeeD);
   Yposition:=Yposition+round(YspeeD);

   {=-=-=-=-=    Calculate map positions    =-=-=-=-=}

   if (Xposition-155<>Mapx) or (Yposition-95<>MapY) then begin
     ASM
       mov ax,player.Xposition
       sub ax,155
       mov mapx,ax
       mov bx,player.Yposition
       sub bx,95
       mov mapY,bx
       Call Map_Calculate
     end;
   end;

   {=-=-=-=-=    Add player to image list    =-=-=-=-=}

   AddIMAGE( Xposition-MAPX,Yposition-MAPY,
             PlayerImages[CurrentIMG+AddImg].data,false,false);

END;


BEGIN
END.