UNIT SuperFX;
{.$DEFINE SHOWSYSTEMINFO}         { SuperFX init text on screen YES/NO         }

{$DEFINE DEBUG}                 { for debuging mode                         }
{.$DEFINE DEBUG_RETRACE}         { for viewing retrace-time left             }

{$DEFINE PLUGIN_SHOWEVENTS}     { this will display DOOM/QUAKE like messages }
{$DEFINE PLUGIN_GCODE}          { make the parser available }
{$DEFINE PLUGIN_DEMO}           { make the demo-record/playing available     }
{.$DEFINE PLUGIN_RUNTIME}        { for runtime-debugging procedures           }

{
        SuperFX (pentium)
        PROTECTED/REAL mode version

        Coding by P.Bestebroer
        Copyright 1996,1997 by Just4Fun productions

        See the SUPERFX.DOC file for more information.
                ===========

        If you got some money you want to spend on this, please do, I've got
        to make a living...  for contacting me :

        E-Mail   : just4fun@zeelandnet.nl
        Internet : http://people.zeelandnet.nl/rpb/

        Mail     : Just4Fun Productions
                   A.Edenlaan 28
                   4463 JC GOES
                   Holland
{}
{$R-} {No range checking}
{$S-} {No stack overflow checking}
{$I-} {No IO checking}
{$Q-} {No overflow checking}
{$G+} {Enable 286 instructions}
{$F+} {Force Far calls}
{}
{*****************************************************************************
   NOTE: Include the next few lines in you're own program aswell !
{*****************************************************************************}
{$IFDEF MSDOS}
   {$M 16384,0,5000}      { now use MEMALLOC/DALLOC instead of GETMEM/FREEMEM}
{$ELSE}
   {$M 65520,0,655360}    { just use GETMEM/FREEMEM }
{$ENDIF}
{*****************************************************************************
                                 Now the INTERFACE!!!
{*****************************************************************************}
INTERFACE
{}
USES CRT,DOS,SFX_VARS;
{}
CONST FXVersion = $200;            { unit version }
{$IFDEF DEBUG}{$DEFINE DEBUGGING}{$ENDIF}
{$IFDEF PLUGIN_RUNTIME}{$DEFINE DEBUGGING}{$ENDIF}
{
                     Some variables to define the map
{}
{=-=-=-=-=-=-=- Computer Calculated Values -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
CONST XtilesAmount    : word = 0;  { will be calculated by LOADMAP }
      YtilesAmount    : word = 0;  { will be calcualted by LOADMAP }
      MapWidth        : word = 0;  { located in MAP file }
      MapHeight       : word = 0;  { located in MAP file }
      PlayerStartX    : word = 0;  { located in MAP file }
      PlayerStartY    : word = 0;  { located in MAP file }
      MapX            : integer = 0;  { Depends on player X position }
      MapY            : integer = 0;  { Depends on player Y position }
      MapTitle        : string[32] = '?';
      MapFile         : string[32] = '';
      MapLIB          : boolean = false;
      Animated        : boolean = false;{ any animated tiles in map? }

VAR   LeftX           : word;      { Left block when drawing map   }
      TopY            : word;      { top block when drawing map    }
      RightX          : word;      { right block when drawing map  }
      BotY            : word;      { bottom block when drawing map }

{=-=-=-=-=-=-=- Constant Values    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
CONST MapId           = 'SUPERFX'; { MAP file ID }
{
        The type of the map blocks

        - F_Frame is the first frame of the block
        - BitFlag specifies things like: block player, block bullets, etc...
{}
TYPE MapType       = record
          F_Frame : byte;
          BitFlag : byte;       { Standard numbers of BITFLAG are:
                                           0 - NOTHING (thin air)
                                           1 - Solid rock (wall,ground...)
                                           2 - Only landable on
                                           3 - Infront of sprites
                                }
     END;

CONST mapF_Frame = 0;
      mapBitFlag = 1;

VAR  Map                 : Pointer;                    { pointer to map-memory}

     tile_n    : string[12];  { These Values are set when loading map files }
     tile_l    : boolean;
     para_n    : string[12];
     para_l    : boolean;
     pal_n     : string[12];
     pal_l     : boolean;
{
                            Screen Wave Variables
{}
TYPE TLineData = record
        YDest      : word;   { destination screen Y position }
        LineLength : word;   { length of line to be drawn }
        YSource    : word;   { source screen Y position }
     END;

VAR  LineData    : array[0..180] of TLineData; { for the sinus-wave effect }

{=-=-=-=-=-=-=-=-=- WAVE values to use from you're program -=-=-=-=-=-=-=-=-=}
    FXWave          : boolean;               { TRUE if FX is done }

{=-=-=-=-=-=-=-=-=-=-= WAVE values not change-able -=-=-=-=-=-=-=-=-=-=-=-=-=}
    FXSinusPosition : word;                  { pointer in the sinus-table }
    FXLoop          : byte;                  { amount of times to loop }
    FXOutCount      : byte;                  { Counting down the wave }
    FXStart         : boolean;               { Starting FX? if yes, this will
                                               clean the screen first }
    WaveXLines      : word;                  { Counter used in WAVEFX }
    WaveSinStart    : word;                  { Counter used in WAVEFX }

VAR FLIPtable  : array[0..199] of word;
{
                               Copper values
{}
CONST  UseCopper       : boolean = true;        { TRUE if you want to use it  }
       CopperTop       : byte = 1;              { top color for the copper FX }
       CopperBottom    : byte = 17;             { bottom color                }
       CopperHight     : word = 0;              { hight of color-bars         }
       BytesPerBar     : word = 0;
       ForceHight      : boolean = false;       { force hight yourself        }
       CopperRevers    : boolean = true;        { if TRUE copperskyDOWN will be
                                                  used }
{
                              Parallax layer variables
{}
CONST  UseLayer        : boolean = false;       { Use a parallax layer?      }
       FullLayer       : boolean = false;       { Complete back-ground layer }
       MultipleSpeeds  : boolean = false;       { use 4 speeds in layer      }
       LayerCopper     : boolean = false;
{
                              Checkerd Board variables
{}
CONST ViewerDist = 200;   { Distance Of Viewer From Screen                   }
      BoardSpeed = 1;
VAR   Tile    : array[0..7,0..7] of byte; { Checkered tile                   }
      Board_Ptr : pointer;
      Board_Seg : word;
      Board_Ofs : word;
      Board_Time: byte;
{
                                 Sprite Variables
{}
Type SpriteTyp=Record                   { for all the shapes to be put in }
       data       : pointer;            { pointer to graphic data }
       c_frame    : byte;               { Current frame }

       T_Frame    : byte;               { Frame changing countdown }
       S_Frame    : byte;               { Frame changing speed }

       A_Frame    : byte;               { next frame in cycle     }
       P_Frame    : byte;               { previous frame in cycle }
       BitFlags   : byte;               { Bit        Flags
                                           0       - Cyclic animation
                                           1       - Needs MASKING color 0

                                        }
     End;

CONST SizeSpriteType = SizeOf(SpriteTyp);

Type ImageTyp=Record                    { for all the shapes to be put in }
       data       : pointer;            { pointer to graphic data }
       BitFlags   : byte;               { Bit        Flags
                                           0       - Cyclic animation
                                           1       - Needs MASKING color 0
                                        }
     End;

     PActive       = ^TActiveSprite;    { the active images in the screenFRAME}
     TActiveSprite = record
        IMG        : pointer;           { Pointer to image-data   }
        Xpos,Ypos  : integer;           { X+Y position on SCREEN  }
        Flipped    : boolean;           { flipped in X direction? }
        Blink      : boolean;           { draw in one color?      }
        prev       : PActive;           { pointer to previous in list }
        next       : PActive;           { pointer to next in list }
     end;

     PShade       = ^TShade;            { the shade-images }
     TShade       = record
        IMG       : pointer;            { pointer to image-data           }
        xpos,ypos : integer;            { X+Y position on screen          }
        prev      : PShade;             { pointer to previous in list     }
        next      : PShade;             { pointer to next in list         }
     end;

VAR  FirstActive : PActive;             { pointer to first visible-sprite }
     LastActive  : PActive;             { pointer to last visible-sprite  }
     FirstShade  : PShade;              { pointer to first shade-sprite   }
     LastShade   : PShade;              { pointer to last shade-sprite    }
{
                            Keyboard variables
{}
Const  EscKey = 1;      { these are just some constants... }

       Down   :Byte = 80;     { movement keys, and fire keys }
       Up     :Byte = 72;     { are the arrow keys, and the }
       Left   :Byte = 75;     { control+alt keys... }
       Right  :Byte = 77;
       fire1  :Byte = 29;       { set to CTRL }
       fire2  :Byte = 56;       { set to ALT }
       fire3  :Byte = 0;        { set to !!INVALID!! }
       fire4  :Byte = 0;        { set to !!INVALID!! }

       CTRL   :Byte = 29;
       ALT    :Byte = 56;

       key_0  = 11;
       key_1  = 2;
       key_2  = 3;
       key_3  = 4;
       key_4  = 5;
       key_5  = 6;
       key_6  = 7;
       key_7  = 8;
       key_8  = 9;
       key_9  = 10;

{
                        Joystick/Gamepad variables
{}
CONST JoystickValue = 2;
      KeyboardValue = 1;

      ControlType : byte = KeyBoardValue;{ 1-keyboard 2-joystick,read from CFG}
      ControlForced : boolean = false;
      KeysWait      : byte = 4;

VAR JOYinstalled  : boolean;    { true if joystick 0 present at unit startup }

VAR X,Y           : word;       { stick position                             }
    JoystickLeft  : boolean;    { if left pushed                             }
    JoystickRight : Boolean;    { if right pushed                            }
    JoystickUp    : Boolean;    { ...                                        }
    JoystickDown  : Boolean;    { ..                                         }
    JoystickA     : Boolean;    { button 1 pressed                           }
    JoystickB     : Boolean;    { button 2 pressed                           }
    JoystickC     : Boolean;    { button 3 pressed                           }
    JoystickD     : Boolean;    { button 4 pressed                           }

    JoyThings     : array[1..8] of boolean;
    JoyPic        : array[1..2] of SpriteTyp;

CONST JoyLeft   : byte = 1;     { these are set by the setup..               }
      JoyRight  : byte = 2;     { they specify wich of the 8 directions/     }
      JoyDown   : byte = 3;     { buttons, does what.                        }
      JoyUp     : byte = 4;     { it then set's the buttons,directions TRUE  }
      JoyFire   : byte = 5;     { or FALSE                                   }
      JoyFire2  : byte = 6;
      JoyFire3  : byte = 7;
      JoyFire4  : byte = 8;


CONST Cal_L:word=$FFFF;         { contains calibration extent of 'center'    }
      Cal_T:word=$FFFF;
      Cal_R:word=0;
      Cal_B:word=0;
{
                Standard Graphic variables for the map, and parallax
{}
CONST TEXTSEG           : word = $a000;     { segment for drawing text on    }
      screen_echo       : boolean = true;
      vga_echo          : boolean = false;
      DEBUG             : boolean = False;
      EndingScreen      : string[12]  = '';

VAR tiles               : array[0..255] of SpriteTyp; { ground tiles         }
    layertile           : array[0..5] of Pointer;     { LayerImage           }
    LayerNR             : byte;
    TilesInFile         : byte;                       { amount of background
                                                        tiles in total       }
    DebugFile           : text;

CONST CharsetLoaded     : boolean = false;
VAR Charset             : array[1..CharSETS,32..95] of pointer; { a multi-colored font}


    _USERBIND         : procedure(num:Byte;command:String);
    _USERDOKEYS       : procedure(keyvalue:Byte);
{$IFDEF PLUGIN_GCODE}
    _USERFUNCTIONS    : FUNCTION(subComm,Variable:String):boolean;
    searchend         : boolean;
    ConsoleCode       : string; { used for reading a line of the parse-file          }
    ConsoleON         : boolean;
{$ENDIF}

{$IFDEF PLUGIN_SHOWEVENTS}
  CONST MaxEvent        = 4;
        eventnext       : byte = 0;

  VAR eventtext         : array[1..MaxEvent] of string[80];
      eventtime         : array[1..MaxEvent] of byte;
{$ENDIF}

{$IFDEF PLUGIN_DEMO}
  VAR DEMrecord   : boolean;               { recording demo?                   }
      DEMplay     : boolean;               { playing a demo?                   }
      DEMfile     : file;                  { filename of the .DEM file         }
{$ENDIF}

{$IFDEF PLUGIN_RUNTIME}
  VAR _RUNTIMEShowVars    : boolean;
{$ENDIF}
{
                               Virtual screen variables
{}
VAR Vpage_seg         : word;      { segment of virtual page }
    Vpage_Ofs         : word;      { offset of virtual page  }
    Vpage_Ptr         : pointer;   { pointer to virtual page }


CONST LowDetail       : boolean = false;
{
                               FLI variables
{}
CONST  Clock_Scale  = 14608 DIV 70;
       BufSize      = 65528;

TYPE PFliPlayer = ^TFliPlayer;
     TFliPlayer = OBJECT
       CONSTRUCTOR Init;
       DESTRUCTOR  Done;                      VIRTUAL;
       PROCEDURE   Play(UseLIB:boolean;Filename : String);   VIRTUAL;
       PRIVATE
          Buffer   : Pointer;
     END;

TYPE MainHeaderRec = RECORD
          FileSize : LongInt;              { file size of FLI }
          ID       : Word;                 { ID of fli file }
          Frames   : Word;                 { amount of frames }
          width    : word;                 { screen width of FLI }
          height   : word;                 { screen height of FLI }
          depth    : word;                 { depth of a pixel }
          flags    : word;                 { must be 0 }
          Speed    : Word;
          next     : word;
          frit     : word;
          extra    : ARRAY[1..106] OF Char;{for new versions}
     END;

     FrameHeaderRec = RECORD
          Size     : LongInt;
          ID       : Word;     { always $F1FA }
          Chunks   : Word;
          extra    : ARRAY[1..8] OF Char; {for new versions}
     END;
VAR  FLIHEIGHT   : word;
{
                           Color/LIGHT variables
{}
VAR  Pal : array[0..255] of record  { This is to store the palette }
         RedLevel   : byte;         { the RED value of the current color }
         GreenLevel : byte;         { the GREEN value of the current color }
         BlueLevel  : byte;         { and the BLUE value of the current color}
     END;

TYPE PLIGHT = ^TLight;
     TLight = record
        x1,y1,
        x2,y2     : integer;        { define the box-positions               }
        lightFLAG : byte;           { define light - type
                                      0 = just light, no change in brightness
                                      1 = random flickering light
                                      2 = bright-pulsating, continously
                                      3 = dark-pulsating, continously
                                      4 = bright-pulsating, once
                                      5 = dark-pulsating, once

        }
        startBright: word;          { start value of light                   }
        SubMap    : boolean;        { Substract MAPX and MAPY positions?     }

        curBright : word;           { current brightness of light            }
        BrAdd     : shortint;       { Bright -adding counter (-1, 0 or 1)    }
        prev,next : PLight;         { pointer to previous/next light in list }
     end;

VAR  ColorMap  : array[0..255,0..31] of byte;{ for the light-sourcing        }
     firstLight     : PLight;
     lastLight      : PLight;
     LSourceA       : word;  { Amount of lights in map }
     lightbyte      : byte;
{
                               GADGET variables
{}
VAR LoadImages  : ImageTyp;
    LoadOLD     : pointer;
    LICON_ON    : boolean;
{
                      Important EXIT and KEYBOARD variables
{}
CONST Halt_Proc    : string[25]= '';
      Halt_Error   : string[80]= '';      { on exit, display an error message  }
      KeyName : array[1..83] of string[10] = (
           'Esc','1','2','3','4','5','6','7','8','9','0','_','=','BckSpace',
           'Tab','Q','W','E','R','T','Y','U','I','O','P','[',']','Return',
           'Ctrl','A','S','D','F','G','H','J','K','L',';','"','`','Left Shift',
           '\','Z','X','C','V','B','N','M',',','.','/','Right Shift','*',
           'AlT','Space','Caps Lock','F1','F2','F3','F4','F5','F6','F7','F8',
           'F9','F10','Num Lock','Scroll Lock','Home','Up','Pg Up','-','Left',
           '5','Right','+','End','Down','Pg Down','Ins','Del');



VAR   key             : array[1..127] of boolean; { to store the key-presses }
      Functionkeys    : array[1..83] of byte;
      ExitSave        : pointer;        { pointer to switch between INTs     }
      anypressed      : boolean;        { see if any key was pressed         }
      OldInt09        : pointer;        { old keyboard interupt              }

      oldexit         : pointer;        { pointer to old exit procedure      }

CONST {Vertival Retrace Timer setup...
	 Set timeout to 0 to auto-sync to vblank
	 Another value will make n interrupts per frame. Use TIMESLACK to
	 give interrupt some time to process. Eg. TIMEOUT=1, TIMESLACE=-300}
	TIMEOUT : word = 5; 	 { number of interrupts pr frame     }
	TIMESLACK : integer = -20;    { interrupt timer slack}
	EXECBIOSTIMER : boolean = TRUE; {still execute bios timer interrupt?}

VAR     TimerCount  : integer;
        TimeSet     : word;
	retraces    : word;              { vertical retrace counter }
	total_retraces : word;           { total of retraces }
	timerproc : procedure;           { pointer to user interrupt }
	Int08Save : procedure;           { store old interrupt-pointers }
        bioscount : word;
        TimerInstalled : boolean;        { is the timer installed? }

        TimeDemo       : boolean;
        OPsystem       : byte;

        {$IFDEF DEBUGGING }
          FrameCount     : longint;
          FramePerSecond : longint;
CONST     StartTimer     : longint = 0;
          EndTimer       : longint = 0;

VAR       maxSprites      : longint;
          totalMaxSprites : longint;
        {$ENDIF}
{
                        DFP library file using variables
{}
CONST LIB_NAME  : string  ='';                  { name of LIBRARY file       }
      NEW_ID    : string  ='DFPv2';             { ID of library              }
      BLOCKSIZE = 60000;                        { blocksize to copy          }
      KEY_START : longint = 0;                  { start of current "FILE"    }
      KEY_SIZE  : longint = 0;                  { size of current "FILE"     }

VAR   LIB_FILE  : file;                         { The library file           }
{
                                FX variables
{}
TYPE PFx       = ^TFx;
     TFx       = record
        xpos,ypos : integer;
        f_Frame,                         { First frame of the animation      }
        a_Frame,                         { amount of frames in the anim      }
        c_frame,                         { current frame in the anim         }
        t_frame,                         { time before frame-changing        }
        s_Frame     : byte;              { standard time before changing     }
        bitflag     : byte;              { cyclic animation?                 }
        LSprite     : boolean;           { Draw as a Light-Sprite?           }
        prev        : Pfx;               { previous frame in linked list     }
        next        : Pfx;               { next frame in linked list         }
     end;

VAR  FirstFX        : Pfx;               { pointer to first FX in list       }
     LastFX         : Pfx;               { pointer to last FX in list        }
     FXS            : array[0..50] of SpriteTyp; { FX sprites                }

{
                         SNOW constants & variables
{}
CONST  Flakes = 80;      { higher = more flakes }
       Fastest= 300;      { try smaller numbers for slower flakes}

Type FlakeyRec = Record
       Snowx   : byte;
       Snowy   : Byte;
       p       : word;
     end;

VAR   r  : Word;
      CurFlake  : word;
      s         : word;
      pf        : Word;
      Flake     : Array[0..flakes] of flakeyrec;
{
                       Progress bar variables
{}
TYPE  tProgressBar = record
        x1,y1,x2,y2  : word;  { Box to use }
        title        : string[24];{ title to put above box }
        col          : byte;  { color of filled bar }
        TotStep      : byte;  { total amount of steps }
        CurStep      : byte;  { current amount of steps done }
        Width        : byte;  { width of one "unit" }
        image        : pointer;
      end;

CONST red            = 1;
      Yellow         = 2;
      White          = 3;
      Blue           = 4;
      Green          = 5;
      Grey           = 6;

{
              And now, for the procedures and functions....:
{}
{*****************************************************************************
   SuperFX Initialise procedures
{*****************************************************************************}
PROCEDURE ActivateDebug;              { initialise debug.txt file }
PROCEDURE InitVGAmode;                { initialise VGA mode }
PROCEDURE SetTXTmode;                 { go back into TEXT mode }
PROCEDURE RestoreTimerInterrupt;      { automaticly called thru SHUTSUPERFX  }
PROCEDURE TWRITE(x,y:word;text:string;col1,col2:byte); { used for init}


PROCEDURE VGAwriteln(txt:String);
PROCEDURE VGAclrscr;
PROCEDURE VGAtextcolor(col:Byte);
PROCEDURE VGAtextbackground(col:Byte);

FUNCTION LoadCFG(CFGfile:String):boolean;

PROCEDURE ShowBaseMemory;
{*****************************************************************************
  Joystick Procedures
{*****************************************************************************}
PROCEDURE SwirlCalibrate;    { Swirl calibrate                           }
PROCEDURE CenterCalibrate;   { center calibrate, no user interaction     }
PROCEDURE GetJoy;            { set JOYSTICK booleans                     }
PROCEDURE SAMPLE;            { sample joystick things                    }
PROCEDURE InitJoy;           { Do a swirl calib, by the user             }

PROCEDURE DoKeys;
{*****************************************************************************
   Shut Down Procedure
{*****************************************************************************}
PROCEDURE ShutSuperFX;                { erase tiles,map,virtual screen,etc   }
PROCEDURE DeAllocXAS(var storing:Array of SpriteTyp); { DEALLOCATE images    }

{*****************************************************************************
    Library procedures
{*****************************************************************************}
FUNCTION USEFILE(name:String):boolean; {Set name of LIBRARY file}
FUNCTION LIB_RESET(name: string):byte; {reset Library file to specified "KEY"}

{*****************************************************************************
    Map procedures
{*****************************************************************************}
FUNCTION LoadMap(lib:boolean;filename:String):boolean; { Load in a MAP file }
PROCEDURE map_calculate;               { Calculate Map boundaries    }
PROCEDURE SetmapXY;                    { Set MAPX and MAPY variables }
PROCEDURE UpdateMap;                   { Update the map on screen    }

FUNCTION MapPos(x,y:integer;mapval:word):byte; { check on map position    }
PROCEDURE SetMapPos(x,y:integer;mapval:word;value:byte);
PROCEDURE DeAllocMap;                  { deallocates the map                 }
PROCEDURE NewMap;                      { creates a new map                   }

{*****************************************************************************
   Image procedures (ie.: all images on screen in current frame)
{*****************************************************************************}
FUNCTION AddIMAGE( Xpos2,Ypos2     : integer;    { Add image to ACTIVE list  }
                   IMGPOINT        : pointer;
                   Flipped2,Blink2 : boolean):boolean;
PROCEDURE doImages;
FUNCTION AddShade( Xpos2,Ypos2     : integer;    { Add image to ACTIVE list  }
                   IMGPOINT        : pointer):boolean;
PROCEDURE doShades;

PROCEDURE AnimateArray(var Asprites:array of spritetyp;nr:byte);
FUNCTION LoadPCXHigh(lib:boolean;filename:String):boolean;
FUNCTION LoadPCX(lib:Boolean; filename:String):boolean;


{*****************************************************************************
    Virtual screen procedures
{*****************************************************************************}
PROCEDURE ShowBitmap;         { normal show of the virtual page              }
PROCEDURE FlipScreenY;        { flipped view in Y direction                  }
PROCEDURE MirrorSplit;        { top lines are mirrored, the rest is normal   }
PROCEDURE ClearScreen;        { clear the virtual page                       }
PROCEDURE ClearVisible;       { clear the actual screen                      }
PROCEDURE Displace;           { put screen on other coordinates              }
PROCEDURE Zoom(MidX,MidY,size:word); { zoom in on the screen                 }
PROCEDURE Flip(value:integer); { for screen flipping/scaling                 }

PROCEDURE SCREENSHOT(filename:String); { Take a screenshot                   }
{*****************************************************************************
    FLI showing procedures
{*****************************************************************************}
PROCEDURE AAPlay(UseLib:boolean;Filename : String); { Play a FLI file once }
{*****************************************************************************
    LIGHT Shading procedures
{*****************************************************************************}
FUNCTION LoadColorMap(lib:boolean;filename:String):boolean;
PROCEDURE DrawLightBox(dx1,dy1,dx2,dy2:integer;Dbright:word);
FUNCTION AddLight(  xx1,yy1,xx2,yy2 : integer;
                    bright  : word;
                    SubMap2 : boolean;
                    LType   : byte): boolean;
FUNCTION EraseLight(Temp:PLight):boolean;
FUNCTION EraseLightALL:boolean;
PROCEDURE DoLights;


{*****************************************************************************
    Screen Wave procedures
{*****************************************************************************}
PROCEDURE InitWave(WaveAmount:Byte);  { Initialise the WAVE effect           }
PROCEDURE StopWAVE;                   { Stop the current WAVE                }
PROCEDURE WaveFX;                     { Draw in a WAVE (replaces SHOWBITMAP) }
{*****************************************************************************
   Checker Board procedures
{*****************************************************************************}
FUNCTION InitBoard(cr1,cg1,cb1,cr2,cg2,cb2:byte):boolean;
Procedure UpdateBoard;                { This makes the checkerd board        }
{*****************************************************************************
   Sky copper effect + parallax layer
{*****************************************************************************}
PROCEDURE InitCopper;                 { Initialise the Copper Bars           }
PROCEDURE CopperSkyUp;                { Draw Copper sky "incrementing" colors}
PROCEDURE CopperSkyDown;              { Draw Copper sky "decrementing" colors}

{*****************************************************************************
   Animation effects handling. (explosions, smoke, etc...)
{*****************************************************************************}
FUNCTION AddFX( Xpos2,Ypos2:integer;F_Frame2:byte;
                LSprite2:boolean):boolean; { ADD FX to linkedlist }
PROCEDURE DoFX;                       { do the FX (called by UPDATEMAP)      }

{*****************************************************************************
   FAST! game-sprite putting...
{*****************************************************************************}
PROCEDURE Sprite;                     { Draw masking and clipped sprited }
PROCEDURE SpriteNoMask;               { Draw clipped sprite }
PROCEDURE SpriteBLINK;                { Draw Highlighted,masked,clipped sprite}
PROCEDURE XFlipSprite;                { Flip sprite in X (masking+clipping) }
PROCEDURE XFlipSpriteBLINK;           { SpriteBlink&XFlipSprite at once }
PROCEDURE ScaleShape(var DataPtr; x1:word;y1:byte;x2:word;y2:byte);
PROCEDURE ShadeSprite(x,y : integer; data:pointer);

FUNCTION GetSpriteX(sprite:spritetyp):byte;
FUNCTION GetSpriteY(sprite:spritetyp):byte;

FUNCTION GetXAS(lib:boolean; filename:string; var storing:array of spritetyp):Byte;
FUNCTION GetImages(lib:boolean; filename:String; var storing:Array of Imagetyp):byte;
FUNCTION LoadLayerImage(lib:boolean; filename:string; image:byte):boolean;

FUNCTION LOADICON(lib:boolean; filename:string):boolean;
{*****************************************************************************
    Square detection procedure, between 2 (square) positions
{*****************************************************************************}
FUNCTION collision(x1,y1,w1,h1, x2,y2,w2,h2 :integer):boolean;

{*****************************************************************************
    Charset procedures
{*****************************************************************************}
FUNCTION LoadCharset(lib:boolean;filename:string;charsetNR:byte):boolean;
PROCEDURE SetTextSegment(newseg:word);
PROCEDURE WText(Xpos,Ypos:Word;text:String;charsetNR:byte);

{*****************************************************************************
    Do some palette stuff
{*****************************************************************************}
FUNCTION Loadpal(lib:boolean;name:string):boolean; { load the palette }
PROCEDURE SetPal;                                      { Set the palette  }
FUNCTION ClosestColor(R, G, B : Byte) : Byte;
PROCEDURE FadeOut(col1,col2:byte);                     { Fade out to black }
PROCEDURE FadeIn(col1,col2:Byte);                      { Fade the palette in }
PROCEDURE GreyPal(col1,col2:byte);                     { Set palette to GREY }
PROCEDURE FadetoGrey(col1,col2:Byte);                  { Fade the palette in }
PROCEDURE BlackPal;                                    { Make palette black }

{*****************************************************************************
  Miscellaneous procedures
{*****************************************************************************}
PROCEDURE Retrace;              { Wait for vertical-retrace (using interrupt)}

{*****************************************************************************
  SNOW PROCEDURES
{*****************************************************************************}
Procedure Perturb;
Procedure Init_snow;
Procedure SNow(Snow_Speed,Orient:integer);


{*****************************************************************************
  GADGET PROCEDURES
{*****************************************************************************}
PROCEDURE LOADON;
PROCEDURE LOADOFF;

{*****************************************************************************
  Memory procedures
{*****************************************************************************}
{$IFDEF MSDOS}
  FUNCTION GetMem(VAR Ptr; Size : Word) : Word;
  FUNCTION FreeMem(VAR Ptr; Size :Word) : Word;
{$ENDIF}

{$IFDEF DEBUGGING}
 PROCEDURE _ResetFPS;
{$ENDIF}
{*****************************************************************************
  PLUGIN PROCEDURES
{*****************************************************************************}
{$IFDEF PLUGIN_GCODE}
  FUNCTION GetPARAMstring(txt:String;num:byte):string;
  FUNCTION GetPARAMvalue(txt:String;num:byte):integer;

  FUNCTION _ParseFile(filename:String):Boolean;
  PROCEDURE _Console_Pop;
{$ENDIF}
{$IFDEF PLUGIN_SHOWEVENTS}
  PROCEDURE _AddEvent(txt:String);
  PROCEDURE _ShowEvents;
{$ENDIF}
{$IFDEF PLUGIN_DEMO}
  FUNCTION _NewDemo(filename:string):boolean; { Start a new recording session}
  FUNCTION _OpenDemo(filename:string):boolean;{ Start a demo for playing     }
  PROCEDURE _EndDemo;                  { Close current demo            }

  PROCEDURE _RecordDemo;               { record keys }
  PROCEDURE _PlayDemo;                 { get demokeys}
{$ENDIF}
{$IFDEF PLUGIN_RUNTIME}
  PROCEDURE _SFX_REGISTERS;
{$ENDIF}
{
              .... well, here it comes... the actual code ....
{}
IMPLEMENTATION
{
  Don't erase any of the LOGO part, I've worked hard on this unit, and this
  is the sign of my work... so please leave it in (and dont change it!)
{}
PROCEDURE LOGO;         EXTERNAL; {$l logo.obj}
CONST     LogoPTR     : pointer = @Logo;

TYPE      FontType = array[32..95] of byte;
PROCEDURE SystemCharset; EXTERNAL; {$L syschr.obj}

VAR       CursX     : word;     { For VGAwriteln }
          CursY     : word;     { For VGAwriteln }
          TxtCol    : byte;     { for VGAwriteln (text color ) }
          BCKCol    : byte;     { for VGAwriteln (background color) }
          SCRNLINES : array[0..24] of string[80];
          SCRNCOLORS: array[0..1,0..24] of byte;


PROCEDURE NewExit; FAR; FORWARD;
{$IFDEF DEBUGGING}

  PROCEDURE _NextFrame; FAR; FORWARD;
{$ENDIF}
{
       Allocate memory using DOS
       (I've got this from the SWAG files, but I forget who made it...)

       Expects: Same values as the PASCAL GETMEM procedure.
       Returns: 0 if no error occured, else the normal DOS memory errors
{}
{$IFDEF MSDOS}
FUNCTION GetMem(VAR Ptr; Size : Word) : Word;
BEGIN
    INLINE(
      $8B / $46 / <Size /         {            mov         ax,[bp+<Size]}
      $B9 / $04 / $00 /           {            mov         cx,4}
      $D3 / $E8 /                 {            shr         ax,cl}
      $40 /                       {            inc         ax}
      $89 / $C3 /                 {            mov         bx,ax}
      $B4 / $48 /                 {            mov         ah,$48}
      $CD / $21 /                 {            int         $21             ;Allocate memory}
      $72 / $07 /                 {            jc          AllocErr        ;If any errors ....}
      $C7 / $46 / $FE / $00 / $00 / {NoErrors:   mov word    [bp-2],0        ;Return 0 for successful allocation}
      $EB / $05 /                 {            jmp short   Exit}
      $89 / $46 / $FE /           {AllocErr:   mov         [bp-2],ax       ;Return error code}
      $31 / $C0 /                 {            xor         ax,ax           ;Store a NIL value into the ptr}
      $C4 / $7E / <Ptr /          {Exit:       les         di,[bp+<Ptr]    ;Address of pointer into es:di}
      $50 /                       {            push        ax              ;Save the Segment part}
      $31 / $C0 /                 {            xor         ax,ax           ;Offset is always 0}
      $FC /                       {            cld                         ;Make sure direction is upward}
      $AB /                       {            stosw                       ;Store offset of memory block}
      $58 /                       {            pop         ax              ;Get back segment part}
      $AB);                       {            stosw                       ;Store segment of memory block}
END;
{
       Deallocate memory allocated with MEMALLOC
       (also from the SWAG, and surprise,surprise, made by the same person)

       Expects: Same values as the PASCAL GETMEM procedure.
       Returns: 0 if no error occured, else the normal DOS memory errors
{}
FUNCTION Freemem(VAR Ptr; size:Word) : Word;
BEGIN
  IF Pointer(Ptr) <> NIL THEN BEGIN
      INLINE(
        $B4 / $49 /               {            mov         ah,$49}
        $C4 / $7E / <Ptr /        {            les         di,[bp+<Ptr]}
        $26 / $C4 / $3D /         {        es: les         di,[di]}
        $CD / $21 /               {            int         $21}
        $72 / $02 /               {            jc          Exit}
        $31 / $C0 /               {NoError:    xor         ax,ax}
        $89 / $46 / $FE);         {Exit:       mov         [bp-2],ax}
      Pointer(Ptr) := NIL;
    END;
END;
{$ENDIF}
{
        Set text and background color procedures for VGA write

        Expects: Color value (0-15)
        Returns: Nothing
{}
PROCEDURE VGAtextcolor(col:Byte);
BEGIN
 TXTcol:=col+220;
END;

PROCEDURE VGAtextBackground(col:Byte);
BEGIN
 BCKcol:=col+220;
END;
{
        Clear the VGA dos screen

        Expects: Nothing
        Returns: Nothing
{}
PROCEDURE VGAclrscr;
BEGIN
 ASM
   MOV DX,DS                    { remember DS }

   MOV ES,sega000               { get screen SEGMENT }
   xor di,di                    { set screen offset to 0 }
   xor si,si                    { set virtual offset to 0 }
   MOV DS,vpage_seg             { get virtual segment }

   MOV CX,16000                 { draw 64000/4 double words }

   DB $66;
   REP MOVSW                    { draw all bytes }

   MOV DS,DX                    { get DS back }
 END;
 for CursY:=0 to 24 do SCRNLINES[CursY]:='';
 CursX:=0; CursY:=0;
END;
{
        Write text, using internal font

        Expects: X,Y, and text to write
        Returns: Nothing
{}
PROCEDURE VGAwrite(x,y:word;txt:String);
VAR i      : word;
    nx     : word;
    x2,y2  : word;
    CharCode   : word;
    TC,BC      : byte;
BEGIN

 nx:=X;
 TC:=TxtCol;
 BC:=BckCol;

 for i:=1 to length(Txt) do                    { go thru every character }
   if (ord(txt[i])<>0) then begin
   charcode:=ord(txt[i]);
   if charcode>95 then dec(charcode,32);
   dec(charcode,32);
   for x2:=0 to 3 do begin
       for y2:=0 to 7 do begin
          if mem[seg(systemcharset):ofs(systemcharset)+(charcode*32)+3+(y2*4)+x2]<>0 then
            mem[sega000:((y+y2)*320)+NX+x2]:=TxtCol
          else
           if BCKcol<>220 then mem[sega000:((y+y2)*320)+NX+x2]:=BCKCol;
       end;
   end;
   inc(nx,4);
 end else inc(nx,4);    { go to next character position }
END;

{
        Write text on screen using the graphics charset
        Called by VGAWRITELN, so use VGAwriteln to write on screen

        Expects: X+Y position on screen, and the text
        Returns: Nothing

        NOTE: No clipping is performed on the screen edges!!!
}
PROCEDURE VgaWriteit(txt:String);
VAR i      : word;
    x,y    : word;
    nx     : word;
    CharCode   : word;
    TC,BC      : byte;
BEGIN
 nx:=CursX;
 TC:=TxtCol;
 BC:=BckCol;

 for i:=1 to length(Txt) do                    { go thru every character }
   if (ord(txt[i])<>0) then begin
   charcode:=ord(txt[i]);
   if charcode>95 then dec(charcode,32);
   dec(charcode,32);
   for x:=0 to 3 do begin
       for y:=0 to 7 do begin
          if mem[seg(systemcharset):ofs(systemcharset)+(charcode*32)+3+(y*4)+x]<>0 then
            mem[sega000:((cursy+y)*320)+NX+x]:=TxtCol
          else
           if BC<>220 then mem[sega000:((cursy+y)*320)+NX+x]:=BCKCol;
       end;
   end;
   inc(nx,4);
 end else inc(nx,4);    { go to next character position }
END;


PROCEDURE VGAwriteln(txt:String);
VAR i : byte;
    TEMPds : word;
    width  : word;
BEGIN
  VGAwriteit(txt);

  inc(CursY,8);

  if CursY>=200 then begin
     for CursY:=1 to 24 do begin
         SCRNCOLORS[0,CursY-1]:=SCRNColors[0,CursY];
         SCRNCOLORS[1,CursY-1]:=SCRNColors[1,CursY];
         SCRNLINES[CursY-1]:=SCRNLINES[CursY];
     end;
     SCRNColors[0,24]:=TXTcol;
     SCRNColors[1,24]:=BCKcol;
     SCRNLines[24]:=txt;
     {=-=- Scroll screen up -=-=}
     ASM
      MOV DX,DS                    { remember DS }

      MOV ES,sega000               { get screen SEGMENT }
      xor di,di                    { set screen offset to 0 }
      xor si,si                    { set virtual offset to 0 }
      MOV DS,vpage_seg             { get virtual segment }

      MOV CX,16000                 { draw 64000/4 double words }

      DB $66;
      REP MOVSW                    { draw all bytes }

      MOV DS,DX                    { get DS back }
     END;

     CursY:=0;
     for i:=0 to 24 do begin
         TXTcol:=SCRNcolors[0,i];
         BCKcol:=SCRNcolors[1,i];
         VGAwriteIt(SCRNLines[i]);
         inc(cursy,8);
     end;
 end else begin
     SCRNLines[CursY shr 3]:=txt;
     SCRNColors[0,CursY shr 3]:=TXTcol;
     SCRNColors[1,CursY shr 3]:=BCKcol;
 end;
END;
{
        Initialise the progress bar

        Expects: Corner BOX positions.
        Returns: Nothing
{}
PROCEDURE _InitProgressBar(x1,y1,x2,y2:word; col:Byte; TotStep:byte; title:String;var TheBar: tProgressBar);
VAR x,y : word;
    Scol : byte;
BEGIN
 Scol:=ClosestColor(63,63,63);
 {=-=- store old screen data -=-=}

 getmem(TheBar.image,(x2-x1+2)*(y2-y1+2));
 for x:=x1 to x2 do begin
     for y:=y1 to y2 do begin
      mem[seg(thebar.image^):ofs(thebar.image^)+( (y-y1)*(x2-x1) )+(x-x1)]:=
        mem[sega000:(y*320)+x];
     end;
 end;

 for x:=x1 to x2 do begin
     mem[sega000:(y1*320)+x]:=Scol;
     mem[sega000:(y2*320)+x]:=Scol;
 end;
 for y:=y1 to y2 do begin
     mem[sega000:(y*320)+x1]:=Scol;
     mem[sega000:(y*320)+x2]:=Scol;
 end;

 TheBar.x1:=x1;
 TheBar.y1:=y1;
 TheBar.x2:=x2;
 TheBar.y2:=y2;

 CASE col of
   1 : TheBar.col:=closestColor(63,10,5);       { red }
   2 : TheBar.col:=closestColor(63,50,0);       { yellow }
   3 : TheBar.col:=closestColor(63,63,63);      { white }
   4 : TheBar.col:=closestColor(0,0,63);      { blue }
   5 : TheBar.col:=closestColor(40,40,40);      { grey }
 end;

 TheBar.TotStep:=TotStep;
 TheBar.CurStep:=0;
 TheBar.width:=((x2-x1)-2) div TotStep;
 TheBar.Title:=Title;
END;
{
        Update a progress bar

        Expects: Nothing
        Returns: Nothing
{}
PROCEDURE UpdateProgressBar(var TheBar: tProgressBar);
VAR x     : word;
    y     : word;
    CalcX : integer;
BEGIN
 with TheBar do begin
  inc(CurStep);
  CalcX:=x1+((CurStep-1)*width)+1;
  if CurStep=TotStep then width:=x2-CalcX-1;

  for x:=CalcX to CalcX+Width do begin
    for y:=y1+1 to y2-1 do begin
       mem[sega000:(y*320)+x]:=Col;
    end;
  end;

  x:=TxtCol;
  TxtCol:=TheBar.col;
{  VgaWrite(x1+((x2-x1) shr 1)-((length(title)*4) shr 1),y1-8,Title);}
  TxtCol:=x;
 end;
END;
{
        Remove a progress bar

        Expects: Nothing
        Returns: Nothing
{}
PROCEDURE RemoveProgressBar(var TheBar: tProgressBar);
VAR x,y : word;
BEGIN
 {=-=- restore old screen data -=-=}
 for x:=thebar.x1 to thebar.x2 do begin
     for y:=thebar.y1 to thebar.y2 do begin
      mem[sega000:(y*320)+x]:=
      mem[seg(thebar.image^):ofs(thebar.image^)+( (y-thebar.y1)*(thebar.x2-thebar.x1))+(x-thebar.x1)];
        
     end;
 end;

 freemem(TheBar.image,(thebar.x2-thebar.x1)*(thebar.y2-thebar.y1));
END;

{
        Initialise the DOS palette

        Expects: Nothing
        Returns: Nothing
{}
PROCEDURE _InitDosPalette;

  procedure SetCol(i,r,g,b:byte);
  begin
    port[$03c8]:=i;
    port[$03c9]:=r;
    port[$03c9]:=g;
    port[$03c9]:=b;
  end;

BEGIN
  Setcol(220,0,0,0);
  Setcol(221,0,0,34);
  SetCol(222,0,34,0);
  SetCol(223,0,14,34);
  SetCol(224,34,0,0);
  SetCol(225,30,0,34);
  SetCol(226,40,35,5);
  SetCol(227,44,44,44);
  SetCol(228,20,20,20);
  SetCol(229,0,25,55);
  SetCol(230,5,63,5);
  SetCol(231,0,34,63);
  SetCol(232,63,10,0);
  SetCol(233,44,10,48);
  SetCol(234,63,50,10);
  SetCol(235,63,63,63);
END;
{}
{
        Initialise the VGA mode

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE InitVGAmode;
BEGIN
  ExitProc:=@NewExit;{ Let's put in our OWN exit procedure     }
  ASM
   mov ax,$13        { set mode to VGA mode (13h) }
   int 10h           { call BIOS interrupt }
   call BlackPal     { Set palette to black }
   Call ClearScreen  { Clear the screen }
  END;
  VGA_Echo:=true;
END;

{}
{
      Set LOADICON in top right corner

      Expects: Nothing
      Returns: Nothing
}
PROCEDURE LOADON;
VAR x,y : word;
BEGIN
 if (LoadImages.data=NIL) or (LICON_on=True) then exit;

 LIcon_ON:=True;
{=-=-= SAVE OLD SCREEN PART =-=-=}

  for x:=295 to 319 do begin
      for y:=0 to 23 do begin
          mem[seg(LoadOLD^):ofs(LoadOLD^)+(y*24)+(x-293)]:=
           mem[sega000:(Y*320)+x];
      end;
  end;

 Retrace;
 {=-=-= PUT NEW IMAGE ON SCREEN =-=-=}
 for x:=295 to 319 do begin
     for y:=0 to 22 do begin
         if mem[seg(LoadImages.data^):ofs(LoadImages.data^)+(Y*24)+x-293]<>0
         then mem[sega000:(Y*320)+x]:=mem[seg(LoadImages.data^):ofs(LoadImages.data^)+(Y*24)+x-293];
     end;
 end;

END;
{}
{
      Set LOADICON in top right corner OFF

      Expects: Nothing
      Returns: Nothing
}
PROCEDURE LOADOFF;
VAR x,y : word;
BEGIN
 if (LoadImages.data=NIL) or (LICon_On=False) then exit;
{=-=-= SAVE OLD SCREEN PART =-=-=}
 if LoadOLD<>NIL then begin
 Retrace;
       for x:=295 to 319 do begin
           for y:=0 to 23 do begin
               mem[sega000:(Y*320)+x]:=
                mem[seg(LoadOLD^):ofs(LoadOLD^)+(y*24)+(x-293)];
           end;
       end;
 end;
 LIcon_On:=False;
END;

{}
{
      Load the configuration ( using the SETUP program wich came with the
      SuperFX Engine)

      Expects: Nothing
      Returns: Nothing
}
FUNCTION LoadCFG(CFGfile:String):boolean;
VAR f  :  file;
    temp : byte;
    SoundCardV : byte;          { These are used when you want to  }
    PortV      : byte;          { Include a Sound unit...          }
    IRQV       : byte;          { They were originally designed to }
    DMAV       : byte;          { use the BWSB unit, it works      }
    SAMPLEV    : byte;          { great with this engine!          }
BEGIN
  if DEBUG then begin
     write(DebugFile,'LOADING CFG       :');
  end;

  Halt_Proc:='LoadCFG';
  LoadCFG:=false;
  assign(f,CFGFile);
  {$I-}
    reset(f,1);
  {$I+}
   if ioresult<>0 then exit;

      if ControlForced then begin
         if not eof(f) then blockread(f,temp,1);
      end else begin
         if not eof(f) then blockread(f,controlType,1);
      end;

      if not eof(f) then blockread(f,SoundCardV,1);
      if not eof(f) then blockread(f,PortV,1);
      if not eof(f) then blockread(f,IRQV,1);
      if not eof(f) then blockread(f,DMAV,1);
      if not eof(f) then blockread(f,SAMPLEV,1);

      {
        These values are directly read into the KEY array, so you can
        program using the "keys" LEFT,RIGHT,UP,DOWN, and the configuration
        will simple change these constants to the correct key-value
      }
      if not eof(f) then blockread(f,LEFT,1);
      if not eof(f) then blockread(f,RIGHT,1);
      if not eof(f) then blockread(f,DOWN,1);
      if not eof(f) then blockread(f,UP,1);
      if not eof(f) then blockread(f,FIRE1,1);

      if not eof(f) then blockread(f,JoyLeft,1);
      if not eof(f) then blockread(f,JoyRight,1);
      if not eof(f) then blockread(f,JoyDown,1);
      if not eof(f) then blockread(f,JoyUp,1);
      if not eof(f) then blockread(f,JoyFire,1);
  close(f);
  LoadCFG:=true;
  if DEBUG then begin
     writeln(DebugFile,'ok');
  end;

END;

{}
{
        Initialise the TXT mode

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE SetTXTmode;
BEGIN
 ASM
   mov ax,$03        { set mode to TEXT mode (3h) }
   int 10h           { call BIOS interrupt }
 END;
 window(1,1,80,25);
END;
{}
{
        Initialise the bitmap

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE InitBitmap;
    PROCEDURE GetPtrData(pt:pointer; VAR Segm, Offs:word); Assembler;
    ASM
       LES DI,PT            { Point ES:DI to where PT is in memory }
       MOV AX,ES            { Set AX to hold segment }
       MOV BX,DI            { BX to hold offset }

       LES DI,Segm          { Now write directly to variable Segm }
       MOV [ES:DI],AX
       LES DI,Offs          { And variable Offs }
       MOV [ES:DI],BX
    END;
BEGIN
  if DEBUG then begin
     write(debugfile,'Initialising Bitmap :');
  end;

 Halt_Proc:='InitBitmap';
     GetMem(VPage_PTR,64535);

  if VPage_PTR=NIL then begin
     Halt_Error:='Couldn''t allocate memory for virtual screen.';
     halt;
  end;

  GetPtrData(VPage_PTR,vpage_seg,vpage_ofs);
  ClearScreen;

  if DEBUG then begin
     writeln(debugfile,'ok');
  end;
END;
{}
{
       Restore the old keyboard interupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE RestoreInt09 ;
BEGIN
  SetIntVec( $09, OldInt09 ) ;
END;
{}
{
       Put in the new keyboard interrupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE NewInt09; INTERRUPT; ASSEMBLER;
ASM
  STI

  xor ch,ch             { set CH to 0, we're using bytes here! }

  mov dx,$60            { set DX to port $60 (keyboard port) }
  in al,dx              { get byte from keyboard }
  mov cl,al             { put it in CL for usage }
  and cl,$7f            { and CL with 127 (MOD 128) }

  mov bx,offset key     { get offset of the KEY array of booleans }
  dec bx
  add bx,cx             { add keyfound to BX }
  mov si,bx             { put calculated offset in DS:[SI] }

  shr al,7              { divide AL with 128 }
  xor al,1
  mov [si],al           { put TRUE or FALSE in array position of keyfound }
  mov anypressed,al     { set ANYPRESSED to TRUE or FALSE }
  mov dx,$61
  in al,dx              { get byte from the port }
  mov cl,al
  or al,$80
  out dx,al
  mov al,cl
  out dx,al

  mov ax,$20
  mov dx,$20
  out dx,ax

  CLI
END;
{}
{
       Initialise the keyboard interupt

       Expects: Nothing
       Returns: Nothing
}
PROCEDURE InitInt09;
VAR n : byte;
BEGIN
  GetIntVec( 9, OldInt09 ) ;
  SetIntVec( 09, addr( NewInt09 ) ) ;
  For N := 1 to 127 do Key[ N ] := False ;
END;
{}
{
        Reset the library file to the start of the correct "FILE DATA"

        Expects: Name of file to search for in the library
        Returns: A error code wich is :  0  : no error
                                         1  : No file name specified
                                         2  : No key specified
                                         3  : Key to long, maximum of 8 characters
                                         4  : Not a valid library file
                                         5  : "KEY" not found
}
FUNCTION LIB_RESET(name: string):byte;
VAR i          : integer;       {used as a counter}
    j          : integer;       {used as a second counter}
    match      : boolean;       {found a key ?}
    key        : string;        {Used to store the "directory" key}
    ID         : string[5];     {File ID, for checking the LIB file}
    ENTRY      : longint;       {amount of entries in the "directory"}
BEGIN
  Lib_Reset:=0;                 { no error as yet }
  if Lib_Name=''           then begin LIB_RESET:=1; exit; end; {no library name}
  if name=''               then begin LIB_RESET:=2; exit; end; {no key specified}
  if length(name)>12       then begin LIB_RESET:=3; exit; end; {key to long}
  while length(name)<12 do name:=name+' ';{ make sure the key is 8 characters }
  for i:=1 to length(name) do name[i]:=upcase(name[i]);

  assign(LIB_FILE , LIB_NAME); reset(LIB_FILE,1);     {Open lib file}
  blockread(LIB_FILE , ID[1], 5);                     {Read the ID}
  id[0]:=#5;
  if id<>new_id then begin                            {Wrong ID}
       close(lib_file);                               {Close the file}
       LIB_RESET:=4;                                  {not a VALID file}
       exit;                                          {Exit this routine}
  end;
  blockread(LIB_FILE , ENTRY, sizeof(entry));         {How many entries?}
  i:=1;
  repeat
      blockread(LIB_FILE ,key[1], 12);                {Let's see if we}
      blockread(LIB_FILE, key_start, sizeof(key_start));{can find the correct}
      blockread(LIB_FILE, key_size,  sizeof(key_size)); {key...}
      key[0]:=#12;                                      {Length of the string}
      match:=true;
      if key<>name then match:=false;                  {wrong key}
      inc(i);                                          {go to next key}
    until (i>entry) or match;
    if match then begin                                {Key found!}
       seek(LIB_FILE,key_start);                       {Get positions}
    end else begin                                     {Key not found}
        close(LIB_FILE);                               {close the file}
        LIB_RESET:=5;                                  {exit with an error}
    end;
END;
{}
{
        This is to display the base memory at the current time

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE ShowBaseMemory;
BEGIN
{$IFDEF DPMI}
  str(memavail div 1024,halt_Error);
  VGAWriteln('BaseMemory [PMODE]:'+halt_error+' kb');
  halt_error:='';
{$ELSE}
 key_start:=0;
 asm
  mov ah,$48
  mov bx,$ffff
  int 21h
  mov word ptr key_start,bx
 end;
 key_start:=key_start shl 4;
 str(key_start div 1024,halt_Error);
 VGAWriteln('BaseMemory [REAL]:'+Halt_error+' kb');
 halt_error:='';
{$ENDIF}
END;
{}
{
        Set the file name of the LIBRARY file to use

        Expects: name of the library file
        Returns: TRUE if file exists, else FALSE
}
FUNCTION USEFILE(name:string):boolean;
VAR f : file;
BEGIN
 Halt_Proc:='UseFile';
 if name='' then begin
    UseFile:=false;
    exit;
 end;
 assign(f,name);                { open the file }
 {$I-}                          { set IO checking off }
  reset(f,1);                   { reset it }
 {$I+}                          { get IO checking back online }
 if ioresult<>0 then begin
    VGAtextcolor(7); VGAtextbackground(0);
    VGAwriteln('DATA pak not found');
    Halt_Error:='unable to open file '+name; { Oops, no file found }
    USEFILE:=false;                          { UseFile is false }
 end else begin
    Usefile:=true;
    lib_name:=name;                           { set LIB_NAME correct }
    close(f);                                 { close the file }
 end;
END;
{}
{
        Load a map file, created with MAPED

        Expects: LIB=TRUE if we want to load from a DFP file,
                 and the filename to use
        Returns: TRUE if succesfull else halt_error contains the error string
}
FUNCTION LoadMap(lib:boolean;filename:String):boolean;
TYPE IMapType = record
          F_Frame : byte;
          BitFlag : byte;
     end;
VAR LoadID    : string;
    code      : byte;
    x,y       : word;
    mx,my     : word;
    temp      : TLight;

    OLDdfp    : string;
    NEWdfp    : string;

    SubBar    : tProgressBar;
BEGIN
 _InitProgressBar(120,175,200,180,yellow,11,'LOADING MAP',SubBar);

  UpdateProgressBar(SubBar);


  if DEBUG then begin
     writeln(DebugFile,'LOADING MAP FILE  :');
     writeln(DebugFile,'--------------------------------');
  end;

  if filename='' then exit;
  Halt_Proc:='LoadMap';
  LOADON;

  if LIB then begin                     { use library? }
     code:=lib_Reset(filename);         { get the file }
     IF code<>0 then begin              { if code<>0 we got a error }

        LoadMap:=false;                 { no Map can be loaded }
        Halt_Error:='Couldn''t spawn map '+filename;
        LOADOFF;
        exit;
     END;
  end else begin
       assign(lib_file,filename);
       {$I-}
            reset(lib_file,1);    { open file }
       {$I+}
       if ioresult<>0 then begin
          LoadMap:=false;
          halt_error:='Couldn''t spawn map '+filename;
          LOADOFF;
          exit;
       end;
       key_start:=0;
       key_size:=filesize(lib_file);
  end;


  MapFile:=Filename;
  MapLib:=lib;

  { First check on the ID of the file }
  blockread(lib_file,LoadID[1],length(MapID));
  LoadID[0]:=char(length(MapId));
  if LoadID<>MapID then begin
     LoadMap:=false;
     Halt_Error:='Couldn''t spawn MAP file, non valid';
     close(lib_file);
     LOADOFF;
     exit;
  end;
  { Now check on the version number }
  blockread(lib_file,LoadId[1],2);
  LoadId[0]:=#2;
  if LoadID<>'v1' then begin
     LoadMap:=false;
     Halt_Error:='Map is from older SuperFX version';
     close(lib_file);
     LOADOFF;
     exit;
  end;

  if map<>nil then begin
      FreeMem(map,(mapheight*mapwidth)*sizeof(MapType)+1000);
  end;
  EraseLightAll;
  Halt_Proc:='LoadMap';


  { read width+height of the map }
  blockread(lib_file,MapWidth,sizeof(MapWidth));
  blockread(lib_file,MapHeight,sizeof(mapheight));

  if DEBUG then begin
     writeln(DebugFile,'MapWidth :',mapWidth);
     writeln(DebugFile,'MapHeight:',mapHeight);
  end;


     GetMem(map,(mapheight+1)*(mapwidth+1)*sizeof(maptype)+1000);


  if (map=NIL) then begin
     close(lib_file);
     LoadMap:=false;
     Halt_error:='out of memory';
     LOADOFF;
     exit;
  end;

  UpdateProgressBar(SubBar);

  { read start position(s) of player }
  blockread(lib_file,PlayerStartX,sizeof(PlayerStartX));
  blockread(lib_file,PlayerStartY,sizeof(PlayerStartY));
  if DEBUG then begin
     writeln(DebugFile,'Player StartX :',PlayerStartX);
     writeln(DebugFile,'Player StartY :',PlayerStartY);
  end;

  UpdateProgressBar(SubBar);

  { read main map data }
  mx:=0;
  for x:=0 to Mapwidth do begin
    my:=0;
    for y:=0 to Mapheight do begin
      blockread(lib_file,mem[seg(map^):ofs(map^)+((my*(mapwidth+1))+mx)*sizeof(MapType)],sizeof(IMapType));
      inc(my);
    end;
    inc(mx);
  end;

  UpdateProgressBar(SubBar);

  maptitle:='';
  if not eof(lib_file) then begin
     blockread(lib_file,x,1);
     if x=255 then begin
      y:=filepos(lib_file);
      blockread(lib_file,usecopper,sizeof(usecopper));
      y:=filepos(lib_file);
      blockread(lib_file,useLayer,sizeof(uselayer));
      y:=filepos(lib_file);
      blockread(lib_file,FullLayer,sizeof(fulllayer));
      y:=filepos(lib_file);
      blockread(lib_file,forcehight,sizeof(forcehight));
      blockread(lib_file,copperrevers,sizeof(copperrevers));
      blockread(lib_file,multiplespeeds,sizeof(multiplespeeds));
      blockread(lib_file,coppertop,sizeof(coppertop));
      blockread(lib_file,copperbottom,sizeof(copperbottom));
      blockread(lib_file,copperhight,sizeof(copperhight));
      blockread(lib_file,layernr,sizeof(layernr));
      blockread(lib_file,maptitle[1],30);
      maptitle[0]:=#30;
      while (maptitle[length(maptitle)]=' ') and (length(maptitle)>0) do maptitle:=copy(maptitle,1,length(maptitle)-1);
   end;
  end;

  UpdateProgressBar(SubBar);

     blockread(lib_file,x,1);
     if x=255 then begin
      blockread(Lib_File,LSourceA,sizeof(LSourceA));
      for x:=1 to LSourceA do begin
        Blockread(lib_file,temp.x1,sizeof(temp.x1));
        Blockread(lib_file,temp.y1,sizeof(temp.y1));
        Blockread(lib_file,temp.x2,sizeof(temp.x2));
        Blockread(lib_file,temp.y2,sizeof(temp.y2));
        Blockread(lib_file,temp.LightFlag,sizeof(temp.LightFlag));
        Blockread(lib_file,temp.StartBright,sizeof(temp.StartBright));
        Blockread(lib_file,temp.SubMap,sizeof(temp.SubMap));
         with temp do
           AddLight(x1,y1,x2,y2,startbright,submap,lightflag);
      end;
     end;
  {=-=-=-=- Read Tile information, etc... =-=-=-=-=-=}
  UpdateProgressBar(SubBar);

  blockread(lib_file,x,1);
  blockread(lib_file,NewDFP[1],x);

  NewDFP[0]:=char(x);
  OldDFP:=lib_name;
  if not UseFile(NewDFP) then NewDFP:=OldDFP;

  UpdateProgressBar(SubBar);
  { READ TILE NAME }
  blockread(lib_file,tile_l,1);      { read USELIB byte }
  blockread(lib_file,x,1);
  blockread(lib_file,tile_n[1],x);   tile_n[0]:=char(x);

  { READ PARALLAX NAME }
  blockread(lib_file,para_l,1);      { read USELIB byte }
  blockread(lib_file,x,1);
  blockread(lib_file,para_n[1],x);   para_n[0]:=char(x);


  { READ PALETTE NAME }
  blockread(lib_file,pal_l,1);      { read USELIB byte }
  blockread(lib_file,x,1);
  blockread(lib_file,pal_n[1],x);   pal_n[0]:=char(x);
  LOADOFF;
  close(lib_file);

  UpdateProgressBar(SubBar);

  if para_n<>'' then
     LoadLayerImage(para_l,para_n,1);

  UpdateProgressBar(SubBar);

  if tile_n<>'' then
     GetXas(tile_l,tile_n,tiles);

  UpdateProgressBar(SubBar);
  if pal_n<>'' then
     LoadPal(pal_l,pal_n);

  { init variables }

  UseFile(OldDFP);
  mapx:=0;
  mapy:=0;
  Map_Calculate;

  LoadMap:=True;

  UpdateProgressBar(SubBar);

  initcopper;
  RemoveProgressBar(SubBar);
END;
{}
{
        Set the Map Coordinates

        Expects: AX to point to X position of player
                 BX to point to Y position of player
        Returns: Nothing
}
PROCEDURE SetmapXY; ASSEMBLER;
ASM
  sub ax,155    { substract 155 pixels (position player almost in center) }
  sub bx,95     { substract 95 pixels (position player almost in center) }
  cmp ax,0      { see if AX>=0 }
  jge @NoSweatX { Yep, so don't worry }
  xor ax,ax     { else it should be 0, map starts at (0,0) }
 @NoSweatX:
  cmp bx,0      { see if BX>=0 }
  jge @NoSweatY { Yep, so don't worry }
  xor bx,bx     { else it should be 0, map starts at (0,0) }
 @NoSweatY:
  mov mapX,ax   { set MAPX to new value }
  mov mapY,bx   { set MAPY to new value }
END;
{}
{
        Calculate the leftX,rightX, topY and botY values to draw the
        correct map tiles.

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE map_calculate; Assembler;
ASM
  mov ax,mapx                   { get map X offset }
  cmp ax,0                      { check with 0 }
  jge @NoSweatX                 { it's not lower then 0, so skip next }
  xor ax,ax                     { set it back to 0 }
  mov mapx,ax                   { and store it to MAPX }
 @NoSweatX:
  mov cx,MapWidth               { get WIDTH of the map }
  sub cx,XTilesAmount           { substract the tiles that are on screen }
  cmp cx,0                      { see if it's still larger then 0 }
  jge @DontWorryX               { yep, so don't worry }
  xor cx,cx                     { oops, it was negative, so set it to 0 }
 @DontWorryX:
  shl cx,TileShiftFactor        { and multiply with tile-size }
  cmp ax,cx                     { see if AX is lower or equal to BX }
  jle  @NoSweatX2               { yes it is, so we're not out of bounds... }
  mov ax,cx                     { else make sure AX won't be larger then the}
  mov mapx,cx                   { map X value }
 @NoSweatX2:
  shr ax,TileShiftFactor        { divide it with block size }
  mov LeftX,ax                  { store calculated value in LEFTX }
  add ax,XtilesAmount           { add TilesAmount on screen }
  mov RightX,ax                 { and store the value in RIGHTX }

  mov bx,200                    { screen size, for speeding up the process }
  mov cx,MapHeight              { get HEIGHT of the map }
  shl cx,TileShiftFactor        { multiply with tile size }
  mov ax,cx                     { get calculated value in CX }
  sub cx,mapy                   { substract mapy }
  cmp cx,bx                     { see if difference still larger then 200 }
  jge @NoThing                  { yes it is, so we're not out of bounds }
  sub ax,bx                     { oops, mapscrolled to far }
  mov mapy,ax                   { set new value to mapy }
 @NoThing:
  mov ax,mapy                   { get map Y offset }
  cmp ax,0                      { check with 0 }
  jge @NoSweatY                 { it's not lower then 0, so skip next }
  xor ax,ax                     { set it back to 0 }
  mov mapy,ax                   { and store it to MAPY }
 @NoSweatY:
  shr ax,TileShiftFactor        { divide it with block size }
  mov TopY,ax                   { store calculated value in TOPY }
  add ax,YTilesAmount
  mov BotY,ax                   { and store the value in BOTY }

END;
{}
{
        Animates and array of sprites (XAS arrays only!)

        Expects: The array of the sprites, and the amount of images in
                 the array.
        Returns: Nothing

}
PROCEDURE AnimateArray(var Asprites:array of spritetyp;nr:byte); ASSEMBLER;
ASM
   les di,Asprites
   mov si,di             { get tiles array }
{=-=-=-=-=-=-=-=-= Sprite Loop =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
   xor cl,cl            { start at sprite #0 }
 @SpriteLoop:
   or [si+spritetyp.a_Frame],0
   jz @NoReAnim
   or [si+spritetyp.t_Frame],0 { get T_FRAME }
   jz @SetNewValues     { if it's 0 then set new values }
   dec [si+spritetyp.t_frame]           { and set it back }
   jmp @NoReAnim        { no reset of the animation }
 @SetNewValues:
   mov al,[si+spritetyp.s_frame]        { get S_FRAME }
   mov [si+spritetyp.t_frame],al        { set T_FRAME }

   les di,Asprites
   xor ah,ah
   mov bx,sizeSpriteType
   mov al,[si+spritetyp.c_frame]
   mul bx
   add di,ax
   xor ah,ah
   mov al,[di+spritetyp.a_Frame]
   mov [si+spritetyp.c_Frame],al
 @NoReAnim:
   add si,SizeSpriteType          { go to next tile-data }
   inc cl               { increase image counter }
   cmp cl,nr
   jl @SpriteLoop
END;

{}
{
        Bind a key to a certain command

        Expects: number of the key, and the command
        Returns: Nothing
}
PROCEDURE _BIND(num:byte; command:String);
VAR done : boolean;
BEGIN
  done:=false;
  {=-=-=- Look at procedure DOKEYS for the code of all procedures =-=-=-=}
  if command='HALT' then begin
     FunctionKeys[num]:=1; { HALT CODE }
     done:=true;
  end;
  if command='SCREENSHOT' then begin
     FunctionKeys[num]:=2; { SCREENSHOT code }
     done:=true;
  end;
  if command='DETAIL' then begin
     FunctionKeys[num]:=3;     { Detail switch code }
     done:=true;
  end;
  {$IFDEF PLUGIN_RUNTIME}
  if command='REGISTERS' then begin
     FunctionKeys[num]:=4;
     done:=true;
  end;
  {$ENDIF}

  if command='KEY_UP' then begin up:=num; done:=true; end;
  if command='KEY_DOWN' then begin down:=num; done:=true; end;
  if command='KEY_LEFT' then begin left:=num; done:=true; end;
  if command='KEY_RIGHT' then begin right:=num; done:=true; end;
  if command='KEY_FIRE1' then begin  fire1:=num; done:=true; end;
  if command='KEY_FIRE2' then begin  fire2:=num; done:=true; end;
  if command='KEY_FIRE3' then begin  fire3:=num; done:=true; end;
  if command='KEY_FIRE4' then begin  fire4:=num; done:=true; end;
  if not Done then
     if assigned(_UserBind) then _UserBind(num,command);
END;
{}
{
        This will handle the special function keys when pressed

        Expects: Nothing
        Returns: Nothing
}

PROCEDURE DoKeys;
VAR kpressed : byte;
    done     : boolean;
BEGIN
  Case ControlType of
   KeyboardValue : begin
                 if key[left] then JoystickLeft:=true else JoystickLEft:=false;
                 if key[right] then JoystickRight:=true else JoystickRight:=false;
                 if key[up] then JoystickUp:=true else JoystickUp:=false;
                 if key[down] then JoystickDown:=true else JoystickDown:=false;
                 if key[fire1] then JoystickA:=true else JoystickA:=false;
                 if key[fire2] then JoystickB:=true else JoystickB:=false;
                 if key[fire3] then JoystickC:=true else JoystickC:=false;
                 if key[fire4] then JoystickD:=true else JoystickD:=false;
   end;
  END;


  if keysWait>0 then BEGIN dec(KeysWait); exit; END;
  kpressed:=1;
  while (key[kpressed]=false) and (kpressed<84) do inc(kpressed);

  if kpressed=84 then exit;

  done:=false;
  KeysWait:=10;

  case FunctionKeys[kpressed] of
    1 : begin
         halt_proc:='Halt request';
         halt_Error:='User pressed HALT key';
         halt;
         done:=true;
    end;
    2 :  begin ScreenShot('screen'); done:=true; end;
    3 :  begin
           LowDetail:=not LowDetail;
           {$IFDEF PLUGIN_SHOWEVENTS}
            if LowDetail then
                _AddEvent('LOW DETAIL')
            else
                _AddEvent('HIGH DETAIL');
           {$ENDIF}
           done:=true;
    end;
    {$IFDEF PLUGIN_RUNTIME}
      4 : _RUNTIMEShowVars:=not _RUNTIMEShowVars;   { Show Registers }
    {$ENDIF}
  end;

  if not DONE then
     if assigned(_UserDoKeys) then _UserDoKeys(KPressed);
END;
{}
{
        Draw the map

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE UpdateMap; Assembler;
VAR   xpos,ypos : word;
      X         : word;
      count     : byte;
      tempBX    : word;
      tempREG   : word;

      XSize, YSize, SIOff : Integer;
      OrigW               : word;
      OrigH               : word;
      X2,Y                 : integer;

ASM
   and animated,1         { is there any animated block in the tiles? }
   jz @NoAnimationsNeeded { no, so leave the animation alone!      }
{=-=-=-=-=-=-=-=-=- First let's animate the tiles -=-=-=-=-=-=-=-=-=-=-=-=-=-}
   mov si,offset tiles  { get tiles array }
{=-=-=-=-=-=-=-=-= Sprite Loop =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
   xor cl,cl            { start at sprite #0 }
 @SpriteLoop:
   or [si+spritetyp.a_Frame],0
   jz @NoReAnim
   or [si+spritetyp.t_Frame],0 { get T_FRAME }
   jz @SetNewValues     { if it's 0 then set new values }
   dec [si+spritetyp.t_frame]           { and set it back }
   jmp @NoReAnim        { no reset of the animation }
 @SetNewValues:
   mov al,[si+spritetyp.s_frame]        { get S_FRAME }
   mov [si+spritetyp.t_frame],al        { set T_FRAME }

   mov di,offset tiles                  { get offset of tiles }
   xor ah,ah
   mov bx,sizeSpriteType                { get size of the spritetyp }
   mov al,[si+spritetyp.c_frame]        { get the C_FRAME }
   mul bx                               { multiply with the spritesize }
   add di,ax                            { add to tile-offset }
   mov ah,[si+spritetyp.c_Frame]        { get current_Frame }
   mov al,[di+spritetyp.a_Frame]        { get NEXT frame number }
   mov [si+spritetyp.c_Frame],al        { put it in current-frame }
   mov [di+spritetyp.p_Frame],ah        { put c_FRAME in P_FRAME of next tile}
 @NoReAnim:
   add si,SizeSpriteType          { go to next tile-data }
   inc cl               { increase image counter }
   cmp cl,TilesInFile
   jng @SpriteLoop
{=-=-=-=-=-=-=-=- now draw the map graphics -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
  @NoAnimationsNeeded:

  and LowDetail,1
  jz @NormalDetail

   xor ch,ch
   mov cl,lightbyte
   mov al,1
   sub al,cl
   mov lightbyte,al
   cmp LightByte,1
   jne @NoRedrawingPlease

 @NormalDetail:

      and usecopper,1        { use a copper sky? }
      jz  @NoCopperCall      { no, so don't draw it }
      and copperRevers,1     { reverse the copper color count? }
      jz @CallUpProc         { no, so draw normal color order  }
      call CopperSkyDown     { yes, so draw it }
      jmp @NoCopperCall
   @CallUpProc:
      call CopperSkyUp
   @NoCopperCall:
      and useLayer,1         { use a parallax layer? }
      jz @NoLayerCall        { no, so don't draw it
{=-=-=-=-=-=-=-=- First Create the parallax-layer -=-=-=-=-=-=-=-=-=-=-=-=-=-}
     mov ax,mapx       { get MapX position }
     and ax,127        { MOD with 2 times the layer-image width (64) }
     shr ax,1          { divide with 2 (layer moves at half-speed) }
     neg ax            { make it negative (0-X_offset) }
     mov XPOS,ax       { remember X position }

     mov bx,120        { initial start of single layer row Y position }

     and FullLayer,1    { Using a full layer? }
     jz  @VLoop         { no, so let Y position stay at 120 }
     xor bh,bh          { init the layer-tile counter  }
     mov LayerNR,bh     { set it to 0                  }
     mov bx,192         { set Y counter to 192         }

    @VLoop:
      mov ax,XPOS       { get X starting position back }
      xor ch,ch
      mov cl,6          { 0-6 blocks to set in HORIZONTAL position }
    @SetLayer:
      mov X,AX              { Remember X offset }

      mov si,offset layertile { get offset of layer- tiles data }
      xor ah,ah
      mov al,LayerNR          { get the number of the layer-tile }
      shl al,2                { using pointers, so offset*4      }
      add si,ax               { add tile-offset and layer-tile   }
      les di,[ds:si]          { get image-data pointer           }

      mov AX,X              { get X offset again     }
      mov count,cl          { remember BLOCK counter }
      mov YPOS,bx           { remember Y position    }

 {=-=- NO MASK IMAGES -=-=}
   mov X2,ax
   mov Y,bx
   xor ah,ah
   mov al,es:[di]
   mov OrigW,ax
   mov al,es:[di+1]
   mov OrigH,ax

   mov TEMPREG,DS
   {'Cache' MinY and MaxY}
   xor dx,dx
{   mov cx, 199}
   cmp ax, 319
   jg @NMDonePAR
   cmp bx, 199
   jg @NMDonePAR
   add ax, origW
   dec ax
   cmp ax, 0
   jl @NMDonePAR {AX -> X2}
   add bx, origH
   dec bx
   cmp bx, dx
   jl @NMDonePAR {BX -> Y2}
   mov si, di
   add si, 2 {SI points to start of image data}
   mov ax, origH
   mov YSize, ax
   {Clip lower Y region}
   cmp bx, 199
   jle @NM1PAR
   sub bx, 199
   sub YSize, bx
  @NM1PAR:
   {Clip upper Y region}
   mov bx, Y
   cmp bx, 0 { dx }
   jge @NM2PAR {Y2 is on screen}
   xor cx,cx  { mov cx,dx }
   sub cx, bx
   add Y, cx
   sub YSize, cx
   mov ax, origW
   imul cx
   add si, ax
  @NM2PAR:
   {Now Y dimension is clipped, SI points to offset start of image, YSize is
    how many lines to draw}
   mov ax, origW
   mov XSize, ax
   mov bx, X2
   cmp bx, 0
   jl @NMXClipPAR
   add bx, ax
   dec bx
   cmp bx, 319
   jg @NMXClipPAR
{----------------------------------------------------------------------------}
   {This section has no SI add every line, XSize is simpy width of line}
   {Loops have register setup
    AX -> Row Size / SI displacement
    BX -> DI displacement
    CX -> REP
    DX -> Row counter
}
{----------------------------------------------------------------------------}
   mov ax, es
   mov es, vpage_seg
   mov bx, Y
   mov di, bx
   shl di, 8
   shl bx, 6
   add di, bx
   {
shl bx, 1
mov di, Word Ptr[YOfs + bx]
}
   add di, X2 {ES:DI points to screen, DS:SI points to start of image}
   mov ds, ax
   mov ax, XSize
   mov bx, 320
   sub bx, ax
   {The following loops will be used.
    a00. REP MOVSD with DI add every line
    a01. MOVSB, REP MOVSD with DI add every line
    a10. MOVSW, REP MOVSD with DI add every line
    a11. MOVSB, MOVSW, REP MOVSD with DI add every line
    b00. REP MOVSD with DI and SI add every line
    b01. MOVSB, REP MOVSD with DI and SI add every line
    b10. MOVSW, REP MOVSD with DI and SI add every line
    b11. MOVSB, MOVSW, REP MOVSD with DI and SI add every line
   }
   mov dx, YSize
   shr ax, 1
   jc @NMTest2PAR
   shr ax, 1
   jc @NMa10PAR
   jmp @NMa00PAR
  @NMTest2PAR:
   shr ax, 1
   jc @NMa11PAR
   @NMa00PAR:
    mov cx, ax
    rep; DB $66; movsw
    add di, bx
    dec dx
    jnz @NMa00PAR
    jmp @NMDonePAR
   @NMa01PAR:
     mov cx, ax
     movsb
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @NMa01PAR
     jmp @NMDonePAR
   @NMa10PAR:
     mov cx, ax
     movsw
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @NMa10PAR
     jmp @NMDonePAR
   @NMa11PAR:
     mov cx, ax
     movsb
     movsw
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @NMa11PAR
     jmp @NMDonePAR
{----------------------------------------------------------------------------}
 @NMXClipPAR:
   mov ax, 320
   sub ax, XSize {AX will keep track of DI displacement}
   xor cx, cx    {CX will keep track of SI displacement}
   mov dx, X2
   cmp dx, 0
   jge @NMClipRightPAR
   xor bx, bx
   sub bx, dx     {BX = X bytes in left}
   add si, bx
   add X2, bx
   add ax, bx
   add cx, bx
   sub XSize, bx
  @NMClipRightPAR:
   add dx, origW
   dec dx {X2}
   cmp dx, 319
   jle @NMStartPAR
   sub dx, 319    {DX = X bytes in right}
   sub XSize, dx
   add ax, dx
   add cx, dx
  @NMStartPAR:
   mov dx, es
   mov es, vpage_Seg
   mov bx, Y
   mov di, bx
   shl bx, 8
   shl di, 6
   add di, bx
   {
   shl bx, 1
   mov di, Word Ptr[YOfs + bx]
   }
   add di, X2 {ES:DI points to screen, DS:SI points to start of image}
   mov ds, dx
   mov bx, cx
   mov dx, YSize
   {AX -> SI displacement
    BX -> DI displacement
    CX -> REP
    DX -> Line counter
   }
   shr XSize, 1
   jc @NMb?1PAR
   shr XSize, 1
   jc @NMb10PAR
   jmp @NMb00PAR
  @NMb?1PAR:
    shr XSize, 1
    jc @NMb11PAR
    jmp @NMb01PAR
   @NMb00PAR:
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @NMb00PAR
     jmp @NMDonePAR
   @NMb01PAR:
     movsb
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @NMb01PAR
     jmp @NMDonePAR

   @NMb10PAR:
     movsw
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @NMb10PAR
     jmp @NMDonePAR

   @NMb11PAR:
     movsb
     movsw
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @NMb11PAR
 @NMDonePAR:
    mov DS,TEMPREG

    mov bx,YPOS           { get Y position back    }
    xor ch,ch
    mov cl,count          { get BLOCK counter back }
    mov ax,X              { get X offset back }
    add ax,64             { add 64 to X counter (layer-blocks are 64bytes)}
    dec cx                { decrease layer-line counter }
    jnz @SetLayer         { not done, then draw next }
    and FullLayer,1       { draw multiply lines of layer? }
    jz  @NoLayerCall      { No, so don't do next bit      }
    {
     Calculate values for next go
    }
    inc LayerNR           { increase layer-number for next line }
    mov cl,1
    and MultipleSpeeds,1  { using multiple speeds? }
    jz  @OneSpeed         { no, just one speed for complete background }
    mov cl,LayerNR        { get layerNR into CL }
    inc cl
  @OneSpeed:
    mov bx,64             { block width is 64   }
    shl bx,cl             { multiply with LayerNR }
    dec bx                { decrease by one, so we can do a AND with it }
    mov ax,mapx           { get MapX position }
    and ax,bx             { MOD with 2 times the layer-image width (64) }
    shr ax,cl             { divide with correct speed (2,4,8,16)        }
    neg ax                { make it negative (0-X_offset) }
    mov XPOS,ax           { remember X position }

    mov bx,YPOS           { get Yposition }
    sub bx,64             { increase Y position }
    cmp bx,0              { see if we're at the bottom }
    jge @Vloop            { no, so draw next line }
{=-=-=-=-=-=-=-=- Done the layer -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
  @NoLayerCall:
      mov ax,LeftX           { get X position }
      mov X,AX               { set X position }
      shl ax,TileShiftFactor { multiply with the correct value (tile size)}
      sub ax,mapx            { substract MapX }
      mov xpos,ax            { and copy it to XPOS value }


    @StartXLoop:
      mov ax,TopY            { get first Y position }
      mov BX,AX              { set Y position }
      shl ax,Tileshiftfactor { multiply with tilesize }
      sub ax,mapy            { substract MAPY }
      mov ypos,ax            { and put it in YPOS }

    @StartYLoop:
      mov cx,MapWidth      { get MAP WIDTH }
      inc cx               { add 1 for correction }
      mov ax,bx            { get Y position in map }
      mul cx               { multiply Y with MAPWIDTH }
      add ax,x             { add X position in map }
      shl ax,1             { multiply with 2 (sizeof MAPTYPE) }

      les si,map           { get segment+offset of MAP }
      add si,ax            { add calculated offset }
      mov al,[es:si]          { read MAP BASE FRAME }
      mov ah,[es:si+1]        { get BITFLAG }
      cmp ah,3             { check with "INFRONT" code }
      jge  @NoSpritePutting2 { It's infront of the player }

    { Using copper bar, if not, draw full blocks! }

      and LayerCopper,1      { use a copper sky or parallax? }
      jz @NoNeedToCheck      { no, so skip tile-0 checking/masking }

     { MASKED IMAGES check on frame=0 }
      or al,al             { see if it's the empty-background image }
      jz @NoSpritePutting2 { YES, so don't put it                   }

    @NoNeedToCheck:
      xor ah,ah
      mov si,offset tiles  { get offset of tiles-images }
      mov cx,SizeSpriteType{ size of SPRITETYPE = 11 }
      mul cx
      add si,ax            { add AX to tiles-offset }

      xor ah,ah
      mov al,[si+spritetyp.c_Frame]{ get C_FRAME pointing to new animation }
{=-=- For animation, we got to be at another sprite, so calculate it -=-=-=-=}
      mov si,offset tiles   { get offset of tiles-images }
      mov cx,SizeSpriteType { size of SPRITETYPE = 11 }
      mul cx
      add si,ax             { add AX (C_FRAME) to tiles-offset }
      mov al,[si+spritetyp.bitflags]         { get BitFlags }

      les di,[si]          { get seg+ofs of image-data }
      mov tempBX,BX        { remember Y counter }
      mov bx,ypos          { Y position of image }

      and al,2             { check if second bit is set }
      jnz @NoNeedToMask    { it's set, so use SPRITENOMASK (FASTER!!!) }
      and LayerCopper,1    { check if using a copper or parallax }
      jz  @NoNeedToMask    { it's not set, so no masking }
      mov ax,xpos          { X position of image }

    mov tempREG,DS

    {=-=- Masked sprite -=-=}
    mov X2,ax
    mov Y,bx

    xor ch,ch
    mov cl,es:[di]
    mov origW,cx
    mov cl,es:[di+1]
    mov origH,cx

    {'Cache' MinY and MaxY}
    { xor dx,dx }
    { mov cx, 199 }
    cmp ax, 319
    jg @Done
    cmp bx, 199 { cx}
    jg @Done
    {les di, Image}
    add ax, origW {es:[di]}
    dec ax
    cmp ax, 0
    jl @Done {AX -> X2}
    add bx, origH {es:[di+2]}
    dec bx
    cmp bx, 0 { dx }
    jl @Done {BX -> Y2}
    mov si, di
    add si, 2 {SI points to start of image data}
    mov ax, origH {es:[di+2]}
    mov YSize, ax
    {Clip lower Y region}
    cmp bx, 199 { cx }
    jle @1
    sub bx, 199 { cx }
    sub YSize, bx
   @1:
    {Clip upper Y region}
    mov bx, Y
    cmp bx, 0 { dx }
    jge @2 {Y2 is on screen}
    xor cx,cx { mov cx, dx }
    sub cx, bx
    add Y, cx
    sub YSize, cx
    mov ax, origW {es:[di] {Width}
    imul cx
    add si, ax
   @2:
   {Now Y dimension is clipped, SI points to offset start of image, YSize is
    how many lines to draw}
    mov ax, origW {es:[di]}
    mov XSize, ax
    mov bx, X2
    cmp bx, 0
    jl @XClip
    add bx, ax
    dec bx
    cmp bx, 319
    jg @XClip
{---- No XClipping-----------------------------------------------------------}
    mov ax, es
    mov es, vpage_seg
    mov bx, Y
    mov di,bx
    shl bx, 6
    shl di, 8
    add di, bx
    add di, X2

    mov ds, ax {ES:DI points to screen, DS:SI points to start of image}
    mov bx, 320
    sub bx, XSize
    mov dx, YSize
    shr XSize, 1
    jnc @aEvenLine
    jz @Single
    jmp @aOddLine
    {AX -> Color grab
     BX -> DI displacement
     CX -> Width counter
     DX -> Line counter}
   @aEvenLine:
     mov cx, XSize       {Ch chnng, new line}
   @aEvenPixel:
     mov ax, ds:[si]
     add si, 2
     test al, al
     jnz @aE?1
     test ah, ah
     jnz @aE10
    @aE00:
      add di, 2
      dec cx
      jnz @aEvenPixel
      add di, bx
      dec dx
      jnz @aEvenLine
      jmp @Done
   @aE10:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @aEvenPixel
      add di, bx
      dec dx
      jnz @aEvenLine
      jmp @Done
   @aE?1:
      test ah, ah
      jnz @aE11
   @aE01:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @aEvenPixel
      add di, bx
      dec dx
      jnz @aEvenLine
      jmp @Done
   @aE11:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @aEvenPixel
      add di, bx
      dec dx
      jnz @aEvenLine
      jmp @Done
  @aOddLine:
    mov cx, XSize       {Ch chnng, new line}
    mov al, ds:[si]
    inc si
    test al, al
    jz @Skip
    mov es:[di], al
  @Skip:
    inc di
  @aOddPixel:
     mov ax, ds:[si]
     add si, 2
     test al, al
     jnz @aO?1
     test ah, ah
     jnz @aO10
    @aO00:
      add di, 2
      dec cx
      jnz @aOddPixel
      add di, bx
      dec dx
      jnz @aOddLine
      jmp @Done
    @aO10:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @aOddPixel
      add di, bx
      dec dx
      jnz @aOddLine
      jmp @Done
    @aO?1:
      test ah, ah
      jnz @aO11
    @aO01:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @aOddPixel
      add di, bx
      dec dx
      jnz @aOddLine
      jmp @Done
    @aO11:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @aOddPixel
      add di, bx
      dec dx
      jnz @aOddLine
      jmp @Done
{----------------------------------------------------------------------------}
  @XClip:
   mov ax, 320
   sub ax, XSize
   xor cx, cx    {CX will keep track of SI displacement}
   mov dx, X2
   cmp dx, 0
   jge @ClipRight
   xor bx, bx
   sub bx, dx     {BX = X bytes in left}
   add si, bx
   add X2, bx
   add cx, bx
   sub XSize, bx
  @ClipRight:
   add dx, origW {es:[di]}
   dec dx {X2}
   cmp dx, 319
   jle @Start
   sub dx, 319    {DX = X bytes in right}
   sub XSize, dx
   add cx, dx
  @Start:
   mov SIOff, cx
   mov ax, es
   mov es, vpage_Seg
   mov bx, Y
   mov di, bx
   shl bx, 6
   shl di, 8
   add di, bx
   add di, X2 {ES:DI points to screen, DS:SI points to start of image}

   mov ds, ax
   mov bx, 320
   sub bx, XSize
   mov dx, YSize
   shr XSize, 1
   jnc @bEvenLine
   jz @SingleStart
   jmp @bOddLine
{
  AX -> Color grab
  BX -> DI displacement
  CX -> Width counter
  DX -> Line counter
}
  @bEvenLine:
     mov cx, XSize       {Ch chnng, new line}
   @bEvenPixel:
      mov ax, ds:[si]
      add si, 2
      test al, al
      jnz @bE?1
      test ah, ah
      jnz @bE10
     @bE00:
      add di, 2
      dec cx
      jnz @bEvenPixel
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLine
      jmp @Done
     @bE10:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @bEvenPixel
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLine
      jmp @Done
     @bE?1:
      test ah, ah
      jnz @bE11
     @bE01:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @bEvenPixel
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLine
      jmp @Done
     @bE11:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @bEvenPixel
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLine
      jmp @Done
  @bOddLine:
    mov cx, XSize       {Ch chnng, new line}
    mov al, ds:[si]
    inc si
    test al, al
    jz @bSkip
    mov es:[di], al
   @bSkip:
      inc di
     @bOddPixel:
       mov ax, ds:[si]
       add si, 2
       test al, al
       jnz @bO?1
       test ah, ah
       jnz @bO10
      @bO00:
       add di, 2
       dec cx
       jnz @bOddPixel
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLine
       jmp @Done
      @bO10:
       mov es:[di+1], ah
       add di, 2
       dec cx
       jnz @bOddPixel
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLine
       jmp @Done
      @bO?1:
       test ah, ah
       jnz @bO11
      @bO01:
       mov es:[di], al
       add di, 2
       dec cx
       jnz @bOddPixel
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLine
       jmp @Done
      @bO11:
       mov es:[di], ax
       add di, 2
       dec cx
       jnz @bOddPixel
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLine
       jmp @Done
  @SingleStart:
    mov bx, 320
  @Single:
    mov al, ds:[si]
    test al, al
    jz @SingleSkip
    mov es:[di], al
   @SingleSkip:
    inc si
    add di, bx
    dec dx
    jnz @Single
 @Done:
   mov DS,TEMPREG
   jmp @NoSpritePutting { done the image }

   @NoNeedToMask:
     mov ax,xpos          { X position of image }

 {=-=- NO MASK IMAGES -=-=}
   mov X2,ax
   mov Y,bx
   xor ah,ah
   mov al,es:[di]
   mov OrigW,ax
   mov al,es:[di+1]
   mov OrigH,ax

   mov TEMPREG,DS
   {'Cache' MinY and MaxY}
{   xor dx,dx
   mov cx, 199}
   cmp ax, 319
   jg @NMDone
   cmp bx, 199 { cx }
   jg @NMDone
   add ax, origW
   dec ax
   cmp ax, 0
   jl @NMDone {AX -> X2}
   add bx, origH
   dec bx
   cmp bx, 0 { dx }
   jl @NMDone {BX -> Y2}
   mov si, di
   add si, 2 {SI points to start of image data}
   mov ax, origH
   mov YSize, ax
   {Clip lower Y region}
   cmp bx, 199 { cx }
   jle @NM1
   sub bx, 199 { cx }
   sub YSize, bx
  @NM1:
   {Clip upper Y region}
   mov bx, Y
   cmp bx, 0 { dx }
   jge @NM2 {Y2 is on screen}
   xor cx,cx { mov cx, dx }
   sub cx, bx
   add Y, cx
   sub YSize, cx
   mov ax, origW
   imul cx
   add si, ax
  @NM2:
   {Now Y dimension is clipped, SI points to offset start of image, YSize is
    how many lines to draw}
   mov ax, origW
   mov XSize, ax
   mov bx, X2
   cmp bx, 0
   jl @NMXClip
   add bx, ax
   dec bx
   cmp bx, 319
   jg @NMXClip
{----------------------------------------------------------------------------}
   {This section has no SI add every line, XSize is simpy width of line}
   {Loops have register setup
    AX -> Row Size / SI displacement
    BX -> DI displacement
    CX -> REP
    DX -> Row counter
}
{----------------------------------------------------------------------------}
   mov ax, es
   mov es, vpage_seg
   mov bx, Y
   mov di, bx
   shl di, 8
   shl bx, 6
   add di, bx

   add di, X2 {ES:DI points to screen, DS:SI points to start of image}
   mov ds, ax
   mov ax, XSize
   mov bx, 320
   sub bx, ax
   {The following loops will be used.
    a00. REP MOVSD with DI add every line
    a01. MOVSB, REP MOVSD with DI add every line
    a10. MOVSW, REP MOVSD with DI add every line
    a11. MOVSB, MOVSW, REP MOVSD with DI add every line
    b00. REP MOVSD with DI and SI add every line
    b01. MOVSB, REP MOVSD with DI and SI add every line
    b10. MOVSW, REP MOVSD with DI and SI add every line
    b11. MOVSB, MOVSW, REP MOVSD with DI and SI add every line
   }
   mov dx, YSize
   shr ax, 1
   jc @NMTest2
   shr ax, 1
   jc @NMa10
   jmp @NMa00
  @NMTest2:
   shr ax, 1
   jc @NMa11
   @NMa00:
    mov cx, ax
    rep; DB $66; movsw
    add di, bx
    dec dx
    jnz @NMa00
    jmp @NMDone
   @NMa01:
     mov cx, ax
     movsb
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @NMa01
     jmp @NMDone
   @NMa10:
     mov cx, ax
     movsw
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @NMa10
     jmp @NMDone
   @NMa11:
     mov cx, ax
     movsb
     movsw
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @NMa11
     jmp @NMDone
{----------------------------------------------------------------------------}
 @NMXClip:
   mov ax, 320
   sub ax, XSize {AX will keep track of DI displacement}
   xor cx, cx    {CX will keep track of SI displacement}
   mov dx, X2
   cmp dx, 0
   jge @NMClipRight
   xor bx, bx
   sub bx, dx     {BX = X bytes in left}
   add si, bx
   add X2, bx
   add ax, bx
   add cx, bx
   sub XSize, bx
  @NMClipRight:
   add dx, origW
   dec dx {X2}
   cmp dx, 319
   jle @NMStart
   sub dx, 319    {DX = X bytes in right}
   sub XSize, dx
   add ax, dx
   add cx, dx
  @NMStart:
   mov dx, es
   mov es, vpage_Seg
   mov bx, Y
   mov di, bx
   shl bx, 8
   shl di, 6
   add di, bx

   add di, X2 {ES:DI points to screen, DS:SI points to start of image}
   mov ds, dx
   mov bx, cx
   mov dx, YSize
   {AX -> SI displacement
    BX -> DI displacement
    CX -> REP
    DX -> Line counter
   }
   shr XSize, 1
   jc @NMb?1
   shr XSize, 1
   jc @NMb10
   jmp @NMb00
  @NMb?1:
    shr XSize, 1
    jc @NMb11
    jmp @NMb01
   @NMb00:
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @NMb00
     jmp @NMDone
   @NMb01:
     movsb
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @NMb01
     jmp @NMDone

   @NMb10:
     movsw
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @NMb10
     jmp @NMDone

   @NMb11:
     movsb
     movsw
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @NMb11
 @NMDone:
    mov DS,TEMPREG

    @NoSpritePutting:
      mov BX,TempBX        { Get Y counter back }
    @NoSpritePutting2:
      add ypos,tilesize { add TILESIZE for next position }
      inc bx            { increase Y counter }
      cmp bx,boty       { check with bottom Y }
      jng @StartYLoop   { Not yet done Vertical, so draw next }

      add Xpos,tilesize { add TILESIZE for next position }
      mov ax,RightX     { get rightX }
      inc X             { increase X counter }
      cmp x,ax          { check with right X }
      jng @StartXLoop   { not yet done Horizontal, so draw next }

   @NoRedrawingPlease:
      call DoImages     { draw all sprite/image objects }
      call DoShades     { draw shadow and other light-sprites }
      call DoFx         { draw all special effects (explosions, etc...) }
      call DoLights     { draw all box-lights }

{=-=-=-=-=-=-=-=- Now do all blocks, infront of the images -=-=-=-=-=-=-=-=-=}
      mov ax,LeftX           { get X position }
      mov X,ax               { set X position }
      shl ax,TileShiftFactor { multiply with the correct value }
      sub ax,mapx            { substract MapX }
      mov xpos,ax            { and copy it to XPOS value }

    @StartXLoop_2:
      mov ax,TopY           { get first Y position }
      mov BX,AX             { set Y position }
      shl ax,Tileshiftfactor{ multiply with tilesize }
      sub ax,mapy           { substract MAPY }
      mov ypos,ax           { and put it in YPOS }

    @StartYLoop_2:
      mov cx,MapWidth   { get MAP WIDTH }
      inc cx               { add 1 for correction }
      mov ax,bx            { get Y position in map }
      mul cx               { multiply Y with MAPWIDTH }
      add ax,x             { add X position in map }
      shl ax,1             { multiply with 2 (sizeof MAPTYPE) }

      les si,map
      add si,ax            { add calculated offset }
      mov al,[es:si]          { read MAP BASE FRAME }
      mov ah,[es:si+1]        { get BITFLAG of block }
      cmp ah,3             { see if it's infront of the player }
      jl @NoSpritePutting2_2{ if not, don't draw it }

      xor ah,ah
      mov si,offset tiles  { get offset of tiles-images }
      mov cx,SizeSpriteType{ size of SPRITETYPE = 10 }
      mul cx
      add si,ax            { add AX to tiles-offset }

      xor ah,ah
      mov al,[si+spritetyp.c_Frame]        { get C_FRAME pointing to new animation }
{=-=- For animation, we got to be at another sprite, so calculate it -=-=-=-=}
      mov si,offset tiles   { get offset of tiles-images }
      mov cx,SizeSpriteType { Size of SPRITETYPE = 10 }
      mul cx
      add si,ax             { add AX (C_FRAME) to tiles-offset }
      mov al,[si+spritetyp.bitflags]         { get BitFlags }

    @NoAnimation_2:
      les di,[si]          { get seg+ofs of image-data }
      mov tempBX,BX        { remember Y counter }
      mov bx,ypos          { Y position of image }


      mov ax,xpos          { X position of image }
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}
    {=-=- Masked sprite -=-=}
    mov X2,ax
    mov Y,bx

    xor ch,ch
    mov cl,es:[di]
    mov origW,cx
    mov cl,es:[di+1]
    mov origH,cx

    {'Cache' MinY and MaxY}
{
    mov dx, 0
    mov cx, 199
}
    cmp ax, 319
    jg @DoneFRONT
    cmp bx, 199 { cx }
    jg @DoneFRONT
    add ax, origW {es:[di]}
    dec ax
    cmp ax, 0
    jl @DoneFRONT {AX -> X2}
    add bx, origH {es:[di+2]}
    dec bx
    cmp bx, 0 { dx }
    jl @DoneFRONT {BX -> Y2}
    mov si, di
    add si, 2 {SI points to start of image data}
    mov ax, origH {es:[di+2]}
    mov YSize, ax
    {Clip lower Y region}
    cmp bx, 199 { cx }
    jle @1FRONT
    sub bx, 199 { cx }
    sub YSize, bx
   @1FRONT:
    {Clip upper Y region}
    mov bx, Y
    cmp bx, 0 { dx }
    jge @2FRONT {Y2 is on screen}
    xor cx,cx { mov cx, dx }
    sub cx, bx
    add Y, cx
    sub YSize, cx
    mov ax, origW {es:[di] {Width}
    imul cx
    add si, ax
   @2FRONT:
   {Now Y dimension is clipped, SI points to offset start of image, YSize is
    how many lines to draw}
    mov ax, origW {es:[di]}
    mov XSize, ax
    mov bx, X2
    cmp bx, 0
    jl @XClipFRONT
    add bx, ax
    dec bx
    cmp bx, 319
    jg @XClipFRONT
{---- No XClipping-----------------------------------------------------------}
    mov ax, es
    mov es, vpage_seg
    mov bx, Y
    mov di,bx
    shl bx, 6
    shl di, 8
    add di, bx

    add di, X2
    mov ds, ax {ES:DI points to screen, DS:SI points to start of image}
    mov bx, 320
    sub bx, XSize
    mov dx, YSize
    shr XSize, 1
    jnc @aEvenLineFRONT
    jz @SingleFRONT
    jmp @aOddLineFRONT
    {AX -> Color grab
     BX -> DI displacement
     CX -> Width counter
     DX -> Line counter}
   @aEvenLineFRONT:
     mov cx, XSize       {Ch chnng, new line}
   @aEvenPixelFRONT:
     mov ax, ds:[si]
     add si, 2
     test al, al
     jnz @aE?1FRONT
     test ah, ah
     jnz @aE10FRONT
    @aE00FRONT:
      add di, 2
      dec cx
      jnz @aEvenPixelFRONT
      add di, bx
      dec dx
      jnz @aEvenLineFRONT
      jmp @DoneFRONT
   @aE10FRONT:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @aEvenPixelFRONT
      add di, bx
      dec dx
      jnz @aEvenLineFRONT
      jmp @DoneFRONT
   @aE?1FRONT:
      test ah, ah
      jnz @aE11FRONT
   @aE01FRONT:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @aEvenPixelFRONT
      add di, bx
      dec dx
      jnz @aEvenLineFRONT
      jmp @DoneFRONT
   @aE11FRONT:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @aEvenPixelFRONT
      add di, bx
      dec dx
      jnz @aEvenLineFRONT
      jmp @DoneFRONT
  @aOddLineFRONT:
   mov cx, XSize       {Ch chnng, new line}
   mov al, ds:[si]
   inc si
   test al, al
   jz @SkipFRONT
   mov es:[di], al
  @SkipFRONT:
   inc di
  @aOddPixelFRONT:
     mov ax, ds:[si]
     add si, 2
     test al, al
     jnz @aO?1FRONT
     test ah, ah
     jnz @aO10FRONT
    @aO00FRONT:
      add di, 2
      dec cx
      jnz @aOddPixelFRONT
      add di, bx
      dec dx
      jnz @aOddLineFRONT
      jmp @DoneFRONT
    @aO10FRONT:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @aOddPixelFRONT
      add di, bx
      dec dx
      jnz @aOddLineFRONT
      jmp @DoneFRONT
    @aO?1FRONT:
      test ah, ah
      jnz @aO11FRONT
    @aO01FRONT:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @aOddPixelFRONT
      add di, bx
      dec dx
      jnz @aOddLineFRONT
      jmp @DoneFRONT
    @aO11FRONT:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @aOddPixelFRONT
      add di, bx
      dec dx
      jnz @aOddLineFRONT
      jmp @DoneFRONT
{----------------------------------------------------------------------------}
  @XClipFRONT:
   mov ax, 320
   sub ax, XSize
   xor cx, cx    {CX will keep track of SI displacement}
   mov dx, X2
   cmp dx, 0
   jge @ClipRightFRONT
   xor bx,bx
   sub bx, dx     {BX = X bytes in left}
   add si, bx
   add X2, bx
   add cx, bx
   sub XSize, bx
  @ClipRightFRONT:
   add dx, origW {es:[di]}
   dec dx {X2}
   cmp dx, 319
   jle @StartFRONT
   sub dx, 319    {DX = X bytes in right}
   sub XSize, dx
   add cx, dx
  @StartFRONT:
   mov SIOff, cx
   mov ax, es
   mov es, vpage_Seg
   mov bx, Y
   mov di, bx
   shl bx, 6
   shl di, 8
   add di, bx

   add di, X2 {ES:DI points to screen, DS:SI points to start of image}
   mov ds, ax
   mov bx, 320
   sub bx, XSize
   mov dx, YSize
   shr XSize, 1
   jnc @bEvenLineFRONT
   jz @SingleStartFRONT
   jmp @bOddLineFRONT
{
  AX -> Color grab
  BX -> DI displacement
  CX -> Width counter
  DX -> Line counter}
  @bEvenLineFRONT:
     mov cx, XSize       {Ch chnng, new line}
   @bEvenPixelFRONT:
      mov ax, ds:[si]
      add si, 2
      test al, al
      jnz @bE?1FRONT
      test ah, ah
      jnz @bE10FRONT
     @bE00FRONT:
      add di, 2
      dec cx
      jnz @bEvenPixelFRONT
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLineFRONT
      jmp @DoneFRONT
     @bE10FRONT:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @bEvenPixelFRONT
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLineFRONT
      jmp @DoneFRONT
     @bE?1FRONT:
      test ah, ah
      jnz @bE11FRONT
     @bE01FRONT:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @bEvenPixelFRONT
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLineFRONT
      jmp @DoneFRONT
     @bE11FRONT:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @bEvenPixelFRONT
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLineFRONT
      jmp @DoneFRONT
  @bOddLineFRONT:
   mov cx, XSize       {Ch chnng, new line}
   mov al, ds:[si]
   inc si
   test al, al
   jz @bSkipFRONT
   mov es:[di], al
    @bSkipFRONT:
      inc di
     @bOddPixelFRONT:
       mov ax, ds:[si]
       add si, 2
       test al, al
       jnz @bO?1FRONT
       test ah, ah
       jnz @bO10FRONT
      @bO00FRONT:
       add di, 2
       dec cx
       jnz @bOddPixelFRONT
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLineFRONT
       jmp @DoneFRONT
      @bO10FRONT:
       mov es:[di+1], ah
       add di, 2
       dec cx
       jnz @bOddPixelFRONT
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLineFRONT
       jmp @DoneFRONT
      @bO?1FRONT:
       test ah, ah
       jnz @bO11FRONT
      @bO01FRONT:
       mov es:[di], al
       add di, 2
       dec cx
       jnz @bOddPixelFRONT
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLineFRONT
       jmp @DoneFRONT
      @bO11FRONT:
       mov es:[di], ax
       add di, 2
       dec cx
       jnz @bOddPixelFRONT
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLineFRONT
       jmp @DoneFRONT
  @SingleStartFRONT:
   mov bx, 320
  @SingleFRONT:
    mov al, ds:[si]
    test al, al
    jz @SingleSkipFRONT
    mov es:[di], al
   @SingleSkipFRONT:
    inc si
    add di, bx
    dec dx
    jnz @SingleFRONT
 @DoneFRONT:
   mov DS,TEMPREG

    @NoSpritePutting_2:
      mov BX,tempBX     { Get Y counter back }
    @NoSpritePutting2_2:
      add ypos,tilesize { add TILESIZE for next position }
      inc bx            { increase Y counter }
      cmp bx,boty       { check with bottom Y }
      jng @StartYLoop_2 { Not yet done Vertical, so draw next }

      add Xpos,tilesize { add TILESIZE for next position }
      mov ax,RightX     { get rightX }
      inc X             { increase X counter }
      cmp x,ax          { check with right X }
      jng @StartXLoop_2 { not yet done Horizontal, so draw next }

      call DOkeys       { Do the key-checking (created with BIND) }

      {$IFDEF PLUGIN_SHOWEVENTS}
         call _ShowEvents
      {$ENDIF}

      {$IFDEF DEBUGGING}
         call _NextFrame
      {$ENDIF}

      {$IFDEF PLUGIN_RUNTIME}
         and _RUNTIMEShowVars,1
         jz @DontShowVars
         call _SFX_REGISTERS
       @DontShowVars:
      {$ENDIF}
END;
{}
{
        Check on a certain block in the map

        Expects: X,Y positions, and mapVAL... mapval can be passed with
                 mapF_Frame or mapBitflag
        Returns: Value of the specified map-positions byte
}
FUNCTION MapPos(x,y:integer;mapval:word):byte; Assembler;
ASM
   les di,map
   mov ax,y
   mov cx,mapwidth
   inc cx
   imul cx
   add ax,x
   shl ax,1
   add ax,mapVal
   add di,ax
   xor ah,ah
   mov al,es:[di]
END;
{}
{
        Set the value of a certain block in the map

        Expects: X,Y positions, and mapVAL... mapval can be passed with
                 mapF_Frame or mapBitflag
                 and the new value to put there
        Returns: Nothing
}
PROCEDURE SetMapPos(x,y:integer;mapval:word;value:byte); Assembler;
ASM
   les di,map
   mov ax,y
   mov cx,mapwidth
   inc cx
   imul cx
   add ax,x
   shl ax,1
   add ax,mapVal
   add di,ax
   mov al,value
   mov es:[di],al
END;
{}
{
        DeAllocate the current map

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE DeAllocMAP;
BEGIN
  if map<>nil then begin
      FreeMem(map,(mapheight+1)*(mapwidth+1)*sizeof(MapType)+1000);
  end;
END;
{}
{
        Allocate a new map (deallocates old one if needed)

        Expects: Nothing  but set the MAPWIDTH and MAPHEIGHT values first
        Returns: Nothing
}
PROCEDURE NewMAP;
VAR x,y : integer;
BEGIN
  if map<>nil then begin
      FreeMem(map,(mapheight+1)*(mapwidth+1)*sizeof(MapType)+1000);
  end;
     GetMem(map,(mapheight+1)*(mapwidth+1)*sizeof(maptype)+1000);
  for x:=0 to Mapwidth do begin
      for y:=0 to Mapheight do begin
          SetMapPos(x,y,mapF_frame,0);
          SetMapPos(x,y,mapBitFlag,0);
      end;
  end;

END;


{}
{

        Add an on-screen image to the list

        Expects: X and Y position, pointer to image-data
        Returns: True if succesfully added the bullet

}
FUNCTION AddIMAGE( Xpos2,Ypos2     : integer;
                   IMGPOINT        : pointer;
                   Flipped2,Blink2 : boolean):boolean;
VAR  Temp     : PActive;
     i        : word;
     add      : word;
BEGIN
 AddIMAGE:=false;

 if memavail<sizeof(temp^) then exit;
 new(Temp);
 if Temp=NIL then exit;

 if FirstACTIVE=NIL  then begin
    LastACTIVE:=Temp;
    FirstACTIVE:=Temp;
    with FirstACTIVE^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 end else begin
     LastACTIVE^.next :=temp;
     Temp^.prev       :=LastACTIVE;
     LastACTIVE       :=Temp;
     Temp^.next       :=NIL;
 end;


 With TEMP^ do begin
  xpos   :=xpos2;
  ypos   :=ypos2;
  IMG    :=IMGPOINT;
  Flipped:=Flipped2;
  Blink  :=Blink2;
 end;

 AddImage:=true;

 {$IFDEF DEBUGGING}
   inc(MaxSprites);
 {$ENDIF}
END;
{}
{

        Erase an IMAGE from the linked-list

        Expects: pointer to PACTIVE object that needs to be ERASED!
        Returns: True if succesfull

}
FUNCTION EraseIMAGE(Temp:PACTIVE):boolean;
VAR  nextIMG  : PACTIVE;
     prevIMG  : PACTIVE;
     i        : integer;
     msize    : word;
BEGIN
  EraseIMAGE:=false;
  if Temp=NIL then exit;

  prevIMG:=Temp^.prev;
  nextIMG:=Temp^.next;

  if prevIMG=NIL then begin
     FirstACTIVE:=nextIMG;
  end else PrevIMG^.next:=nextIMG;

  if nextIMG=NIL then begin
     LastACTIVE:=prevIMG;
  end else NextIMG^.prev:=prevIMG;

  dispose(Temp);
  EraseImage:=true;
END;
{}
{
        Draw all images for current frame

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE doImages;
VAR temp      : PActive;
    nextIMG   : PActive;
    done      : boolean;

    nextIMG2  : PACTIVE;
    prevIMG2  : PACTIVE;
     i        : integer;
     msize    : word;
BEGIN
 temp:=FirstACTIVE;
 while temp<>Nil do begin
        done:=false;
        nextIMG:=temp^.next;
         ASM
             mov DX,DS             { remember DS }
             lds si,temp
             mov ax,ds:[si+tactivesprite.xpos]      { get Xposition }
             mov bx,ds:[si+tactivesprite.ypos]      { get Yposition }
             mov cl,ds:[si+tactivesprite.flipped]      { get FLIPPED   }
             mov ch,ds:[si+tactivesprite.blink]      { get BLINK     }
             les di,ds:[si]        { get pointer to IMAGE data }
             mov DS,DX             { get DS back   }
             and cl,1              { is it flipped? }
             jz  @NotFlipped       { no. }
             and ch,1              { is it blinked? }
             jz  @NoFlipBlink      { no. }
             call XFlipSpriteBlink { call flip+blink }
             jmp @DoneSprite       { done the sprite }
            @NoFlipBlink:
             call XFlipSprite      { flip the sprite }
             jmp @DoneSprite       { done the sprite }
            @NotFlipped:
             and ch,1              { is it blinked? }
             jz  @NoBlink          { no, it's normal! }
             call SpriteBlink      { call blinked }
             jmp @DoneSprite       { done the sprite }
            @NoBlink:
             call Sprite           { call the sprite }
            @DoneSprite:
         END;

         {=-=- Erase the image from the linked-list -=-=}
         prevIMG2:=Temp^.prev;
         nextIMG2:=Temp^.next;

         if prevIMG2=NIL then begin
            FirstACTIVE:=nextIMG2;
         end else PrevIMG2^.next:=nextIMG2;
         if nextIMG2=NIL then begin
            LastACTIVE:=prevIMG2;
         end else NextIMG2^.prev:=prevIMG2;

         dispose(Temp);
         temp:=nextIMG;
   end;
END;
{}
{

        Add an on-screen shade-sprites  to the list

        Expects: X and Y position, pointer to image-data
        Returns: True if succesfully added the bullet

}
FUNCTION AddShade( Xpos2,Ypos2     : integer;
                   IMGPOINT        : pointer):boolean;
VAR  Temp     : PShade;
     i        : word;
     add      : word;
BEGIN
 AddShade:=false;

 if memavail<sizeof(temp^) then exit;
 new(Temp);
 if Temp=NIL then exit;

 if FirstShade=NIL  then begin
    LastShade:=Temp;
    FirstShade:=Temp;
    with FirstShade^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 end else begin
     LastShade^.next :=temp;
     Temp^.prev       :=LastShade;
     LastShade       :=Temp;
     Temp^.next       :=NIL;
 end;


 With TEMP^ do begin
  xpos   :=xpos2;
  ypos   :=ypos2;
  IMG    :=IMGPOINT;
 end;

 {$IFDEF DEBUGGING}
    inc(maxSprites);
 {$ENDIF}

 AddShade:=true;
END;
{}
{

        Erase a SHADE-SPRITE from the linked-list

        Expects: pointer to PSHADE object that needs to be ERASED!
        Returns: True if succesfull

}
{}
{
        Draw all SHADE-sprites for current frame

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE doShades;
VAR temp      : PShade;
    nextIMG   : PShade;
    done      : boolean;

    prevIMG  : PShade;

BEGIN
 temp:=FirstShade;
 while temp<>Nil do begin
        done:=false;
        nextIMG:=temp^.next;
        ShadeSprite(temp^.xpos,temp^.ypos,temp^.img);

        prevIMG:=Temp^.prev;
        nextIMG:=Temp^.next;

        if prevIMG=NIL then begin
           FirstShade:=nextIMG;
        end else PrevIMG^.next:=nextIMG;

        if nextIMG=NIL then begin
           LastShade:=prevIMG;
        end else NextIMG^.prev:=prevIMG;

        dispose(Temp);
        temp:=nextIMG;
   end;
END;

{}
{

        Initialises the SinusTable

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE InitSinus;
VAR i,j : integer;
    val : integer;
BEGIN
 j:=220;                          { don't change the start position!!! }
 for i:=0 to 180 do begin
  val:=round(sin((pi*j)/180)*30);
  with linedata[i] do begin
       if val>0 then begin
          YDest:=val;
          Ysource:=0;
          LineLength:=200-Val;
       end else begin
          YDest:=0;
          YSource:=-Val;
          lineLength:=200+val;
       end;
  end;
  inc(j,2);
  if j>360 then dec(j,360);
 end;

END;
{}
{
        Initialise the WAVE effect

        Expects: Amount of wave-times
        Returns: Nothing
}
PROCEDURE InitWave(WaveAmount:Byte);
BEGIN
 FXSinusPosition := 0;          { start at beginning of sinus table }
 FXWave          := TRUE;       { Using WAVE is TRUE }
 FXLoop          := WaveAmount; { Amount of times to go thru sinus table }
 FXOutCount      := 80;         { Time before stopping the wave }
 FXStart         := true;       { First time in wave-cycle? }
END;
{}
{
        Stop the current WAVE effect

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE StopWave; Assembler;
ASM
  mov fxoutcount,79
  xor al,al
  mov fxloop,al
END;
{}
{
        Show some cool FX... eat this supernintendo, without a FX chip!!!

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE WaveFX; Assembler;
VAR LineOffset : word;
ASM
   call retrace

   and FXStart,1                { starting the FX ? }
   jz  @NotInStartingFase       { nope, so skip next bit }
   DB $66; xor ax,ax            { set EAX to 0 }
   mov es,sega000               { set screen segment }
   mov di,53760                 { set screen offset to bottom few lines }
   mov cx,2560                  { set CX to the amount of bytes/4 }
   DB $66; rep STOSW            { store double-words }
   mov FXStart,false            { starting FX is now false }

 @NotInStartingFase:

  { SET THE BOTTOM and the TOP of the VPAGE to black (to erase old lines) }
   DB $66                        { double word mode }
   xor ax,ax                     { set AX to 0 }
   mov es,vpage_seg              { set screen segment }
   xor di,di                     { set screen offset }
   mov DX,DS                     { remember DS }
   mov ds,vpage_seg              { get screen segment }
   mov si,63680                  { get bottom screen offset }
   mov cx,80                     { store 320 div 4 bytes }
 @BlacknessLoop:
   DB $66;  STOSW                { store top line }
   DB $66;  mov ds:[si],ax       { store bottom line }
   add si,4                      { add 4 to offset 2 }
   loop @Blacknessloop           { loop until CX=0   }
   mov DS,DX                     { get DS back       }

   mov es,sega000                { get screen segment }
 { GET START POSITION IN SINUS TABLE }
   mov bx,FXSinusPosition        { get main sinus-start position }
   mov WaveSinStart,bx           { store it in a temp variable }
   xor ax,ax                     { set AX to 0 }
   mov WaveXlines,ax             { set X counter to 0 }

  { CALCULATE START of LINEDATA table }
   mov si,bx                    { get table offset value }
   mov cx,si                    { get table offset in CX aswell }
   shl cx,1                     { multiply with 2 }
   shl si,2                     { and with 4 ( that's 6 = linedata size ) }
   add si,cx                    { add them together }
   add si,offset LineData       { add offset to SI }

  @MainXLoop:
   mov lineoffset,si            { remember lineoffset }
   mov bx,[si]                  { get YDestination value }
   mov cx,[si+2]                { get LineLength }
   mov dx,[si+4]                { get YSource value }

 { INITIALISE DRAWING POSITIONS, AND VARIABLES }
   mov di,bx            { for multiplying get YDEST in DI aswell }
   shl bx,8             { multiply with 128... }
   shl di,6             { ...and with 64, so thats BX * 320 }
   add di,bx            { add calculated offset to screen offset }

   mov ax,WaveXlines    { get X position }
   shl ax,3             { we draw 8 bytes at once, so multiply X*8 }
   add di,ax            { add X offset to screen offset }

   mov si,dx               { get Source Y start position }
   shl si,8                { multiply with 128... }
   shl dx,6                { ... and with 64, so thats BX * 320 }
   add si,dx               { add together }
   add si,ax               { add precalculate value to AX }

   mov DX,DS            { remember DS }
   mov ds,vpage_seg     { get image segment }

 { GO AND DRAW THE CURRENT VERTICAL LINE (8 bytes thick) }

 @VLoop:
   DB $66; MOVSW        { double words }
   DB $66; MOVSW        { double words }

   mov ax,312           { for faster adding of DI and SI }
   add di,ax            { go to next line }
   add si,ax            { go to next line }
   loop @Vloop          { loop until CX=0 }
   mov DS,DX            { get DS back }

 { GO INITALISE FOR THE NEXT LINE }
   mov si,Lineoffset    { get line table offset }

   mov bx,WaveSinStart  { get WaveSinStart value }
   xor ah,ah            { set AH to 0 }
   mov al,FXOutCount    { get "count-down byte" into AL }
   cmp al,40            { see if we done all pixels (320 div 8) }
   jne @Not80           { nope, so skip next bit }
   inc bx               { increase Sinustable... }
   add si,6             { add 6 (length of linedata type) }
   jmp @Done80          { jump to done }
 @Not80:
   cmp ax,WaveXlines    { check FXOUTCOUNT with X position }
   jl @Done80           { if less, don't change }
   inc bx               { increase Sinustable... }
   add si,6             { add 6 (length of linedata type) }
 @Done80:
   cmp bx,180           { see if we done all the 180 values }
   jl  @NoDecreaseStart { if less, don't change it }
   sub bx,180           { else set it back to start of sinus }
   mov si,offset LineData { reset line data pointer }
 @NoDecreaseStart:
   mov WaveSinStart,bx  { Set WaveSINstart back again }

   inc WaveXLines       { go to next vertical line }
   cmp WaveXLines,39    { done all 40 (320 div 8, using double-words!) }
   jle @MainXloop       { if less or equal, draw next }

 { DRAWING DONE, INITIALISE FOR NEXT TIME THIS IS CALLED }
   mov ax,FXSinusPosition
   inc ax                 { add 1 to the sinus start position... }
   cmp FXOutCount,80      { see if we are busy stopping }
   je  @SkipReset         { nope, so skip it }
   dec FXOutCount         { yes, so decrease until 0 }
   jnz @SkipReset         { if not 0, no reset }
   mov FXWave,false       { else this FX is done... }
 @SkipReset:
   cmp ax,180                   { see if we did all the values }
   jl  @NoChange1               { no, so don't reset it }
   sub ax,180                   { yes, so set to start of sinus }
   cmp fxloop,0                 { see if FX loop is 0 }
   je  @NoChange2               { yes it is }
   dec fxloop                   { not it ain't so decrease it }
   jmp @NoChange1               { skip CHANGE2 part }
 @NoChange2:
   xor bx,bx                    { set BX to 0 }
   mov fxloop,bl                { set FXLoop to 0 }
   mov fxoutcount,79            { set FXOUTCOUNT to 79 }
 @NoChange1:
   mov fxsinusposition,ax       { set FXSinusPosition to 0 }
END;
{}
{
       Initialise the colors, and the tile board for the Checkerd Board

       Expects: The RED,GREEN and BLUE values of the 2 colors
       Returns: True if initialised
}
FUNCTION InitBoard(cr1,cg1,cb1,cr2,cg2,cb2:byte):boolean;
VAR PalXCounter : Byte;
    PalYCounter : Byte;
    TempBX      : word;
    Z           : word;
    TempDi      : word;

    PROCEDURE GetPtrData(pt:pointer; VAR Segm, Offs:word); Assembler;
    ASM
       LES DI,PT            { Point ES:DI to where PT is in memory }
       MOV AX,ES            { Set AX to hold segment }
       MOV BX,DI            { BX to hold offset }

       LES DI,Segm          { Now write directly to variable Segm }
       MOV [ES:DI],AX
       LES DI,Offs          { And variable Offs }
       MOV [ES:DI],BX
    END;

BEGIN
  Halt_Proc:='InitBoard';
  InitBoard:=false;
  { Get memory for board }
     GetMem(Board_PTR,25600);
  if Board_Ptr=nil then begin
     Halt_Error:='Couldn''t spawn board';
     exit;
  end;

  GetPtrData(Board_Ptr,board_seg,board_ofs);

  { First create the colors (colors 1-64 are used for the ground) }
  For PalYCounter := 1 to 64 do
     With Pal[PalYCounter] do begin
       RedLevel   := cr1;
       GreenLevel := cg1;
       BlueLevel  := cb1;
  End;
  For PalYCounter := 0 to 3 do
      For PalXCounter := 0 to 3 do begin
      With Pal[1 + PalXCounter + (PalYCounter shl 3)] do begin
           RedLevel   := cr2;
           GreenLevel := cg2;
           BlueLevel  := cb2;
      End;
      With Pal[37+PalXCounter+(PalYCounter shl 3)] do begin
           RedLevel   := cr2;
           GreenLevel := cg2;
           BlueLevel  := cb2;
      End;
  End;
  {   Now Create the Tile  }
  ASM
   xor bx,bx            { set Y counter to 0 }
 @YLoop:
   xor cx,cx            { set X counter to 0 }
 @XLoop:
   mov SI,offset Tile   { get tile offset    }
   mov ax,cx            { get X counter      }
   shl ax,3             { multiply with 8 (width) }
   add ax,bx            { add Y counter }
   add si,ax            { add to tile-offset }

   mov ax,bx            { get Y counter }
   shl ax,3             { multiply with 8 (height) }
   add ax,cx            { add X counter }
   inc ax               { increase }
   mov ds:[si],al       { store color }
   inc cx               { increase X counter }
   cmp cx,8             { see if we're done }
   jl @Xloop            { not yet... }

   inc bx               { increase Y counter }
   cmp bx,8             { see if we're done }
   jl @Yloop            { not yet... }
  END;

  { Draw the Graphic Board }
  ASM
    mov es,board_seg
    mov bx,120           { starting Y position }

  @DoYLoop:
    mov tempBX,bx          { remember BX }
    shl bx,4               { multiply with 16   }
    add bx,ViewerDist      { add ViewerDistance }
    mov ax,-1700           { make BX -1800 }
    add ax,bx              { add calculated AX to BX }
    mov Z,ax               { remember it in Z }

    mov di,board_Ofs       { start screen offset }
    mov bx,Z               { get Z position }
    mov cx,ViewerDist      { get ViewerDistance }

  @DrawLoop:
    mov TEMPDI,DI
    mov ax,DI               { get X position }
    sub ax,159              { substract 159  }
    imul cx                 { multiply with ViewerDistance }
    idiv bx                 { divide with Z position }
    and ax,7                { MOD with 8 }
    shl ax,3                { multiply with 8 }
    mov X,ax                { remember it in X }

    mov ax,tempBX           { get CounterY }
    mul cx                  { multiply with ViewerDistance }
    div bx                  { divide with Z position }
    and ax,7                { MOD with 8 }
    add X,ax                { remember it in X }

    mov ax,tempBX           { get counter Y in AX... }
    mov dx,ax               { ...and in DX }
    shl ax,8                { multiply with 256 }
    shl dx,6                { ..and with 64... }
    add ax,dx               { add together (=Y*320) }
    add di,ax               { add to screen offset }
    sub di,38400

    mov si,offset Tile      { get Tile array offset }
    add si,X                { add calculated tile Offset }
    movsb                   { copy correct byte }

    mov DI,TEMPDI           { get DI back }
    inc di                  { increase X position }
    cmp di,320              { check on right-border }
    jl @DrawLoop            { Not yet done... }

    mov BX,TEMPBX           { get BX back }
    inc BX                  { increase Y position }
    cmp bx,200              { check on bottom-border }
    jl @DoYLoop             { Not yet done...}

    mov Board_Time,BoardSpeed
  end;

END;
{}
{
          Create the checkerd board

          Expects: Nothing
          Returns: Nothing
}
PROCEDURE UpdateBoard;
VAR   X       : integer;
      TempBX    : word;
      TempDI    : word;
      TempDS    : word;
BEGIN
  { Copy Board image }
  asm
    call retrace

    mov es,vpage_seg
    mov di,vpage_ofs
    add di,38400

    mov TEMPDS,DS
    mov si,board_ofs
    mov ds,board_seg


    mov cx,6400
    DB $66
    rep movsw

    mov DS,TEMPDS
  end;

  if Board_Time>0 then dec(Board_time) else begin
     Board_Time:=BoardSpeed;

     For TempBX := 0 to 7 do
         For TempDI := 0 to 7 do
             Pal[TempDI+(TempBX shl 3)]:=Pal[TempDI+((TempBX+1) shl 3)];
  end;

   asm
    mov ax,ds                { get variables segment }
    mov es,ax                { store it in ES }

    mov di,offset PAL        { get PAL offset }
    mov si,di                { store it in SI aswell }
    add di,171               { add 56*3 for the correct color offset }
    add si,3                 { add 3 for the correct color offset }
    mov cl,8                 { set color counter to 8 }
 @CopyColor:
    movsw                    { move RED+GREEN }
    movsb                    { and move BLUE  }
    loop @CopyColor          { loop thru the colors }
    mov TEMPDS,DS                        { remember DS }
    MOV CX, 192                          { amount of colors to do *3 (R G B) }
    MOV AX, 1
    mov si,offset PAL                    { get palette offset }
    add si,3                             { skip the first color }
    MOV DX, 03C8h                        { get color port }
    OUT DX, AL                           { start at color 1 }
    INC DX                               { get to value port }
    REP OUTSB                            { store the color bytes }
    mov DS,TEMPDS                        { get DS back }
  END;

END;

{}
{
        Flip the screen in VERTICAL direction

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE FlipScreenY; Assembler;
ASM
   call retrace

   mov bx,200                   { 200 lines to flip (0-199) }

   mov es,sega000               { get screen segment }
   xor di,di                    { screen offset is 0 }

   mov DX,DS                    { remember DS }
   mov ds,vpage_seg             { get segment of virtual page }
   mov si,63680                 { get virtual page offset }

 @LoopH:
   mov cx,80                    { copy 80 double-words (320 div 4)}

 @LoopIt:
   DB $66; REP MOVSW            { copy all double words }
   sub si,640                   { decrease 1 line for the virtual page }
   dec bx                       { decrease Y counter }
   jnz @LoopH                   { not yet 0 ? }

   mov DS,DX                    { get DS back }
END;

{}
{
        Split the screen, making the TOP upside down, and the bottom
        normal

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE MirrorSplit; Assembler;
ASM
   call retrace

   mov bx,100                   { 200 lines to flip (0-199) }

   mov es,sega000               { get screen segment }
   xor di,di                    { screen offset is 0 }

   mov DX,DS                    { remember DS }
   mov ds,vpage_seg             { get segment of virtual page }
   mov si,63680                 { get virtual page offset }

 @LoopH:
   mov cx,80                    { copy 80 double-words (320 div 4)}

 @LoopIt:
   DB $66; REP MOVSW            { copy all double words }
   sub si,640                   { decrease 1 line for the virtual page }
   dec bx                       { decrease Y counter }
   jnz @LoopH                   { not yet 0 ? }

   mov cx,8000                  { no copy the final 100 lines normally }
   DB $66; REP MOVSW            { move the double words! }

   mov DS,DX                    { get DS back }
END;

{}
{
        Displace the virtual screen on the visible screen

        Exects : AX to be X position of displacement
                 BX to be Y position of displacement
        Returns: Nothing
}
PROCEDURE Displace; ASSEMBLER;
VAR Sleft,Dleft                   : word;       { Source+Destination LEFT }
    Stop,Dtop                     : word;       { Source+Destination TOP }
    Xlength                       : word;       { Horizontal length }
    YLength                       : word;       { Vertical Length }

    tempDS                        : word;       { to remember DS }
ASM

     xor cx,cx                     { set CX to 0 }
     mov xlength,320               { set X length to 320 bytes }
     mov ylength,200               { set Y length to 200 }
     cmp ax,0                      { see if X is negative }
     jge @XNotNegative             { no it isn't, so perform other calculations }
     mov dleft,cx                  { yes it is, so set destination left to 0 }
     add xlength,ax                { and ADD NEGATIVE X to length }
     neg ax                        { set X value to positive }
     mov Sleft,ax                  { set source left to X position }
     jmp @DoneXpositions           { done X calculations }
   @XNotNegative:
     mov dleft,ax                  { set destination X to X offset }
     mov sleft,cx                  { set source X to 0 }
     sub xlength,ax                { substract X position from length }
   @DoneXpositions:
     cmp bx,0                      { see if Y is negative }
     jge @YNotNegative             { no it isn't, so perform other calculations }
     mov dtop,cx                   { yes it is, so set destination top to 0 }
     add ylength,bx                { ADD NEGATIVE Y to length }
     neg bx                        { make Y positive }
     mov stop,bx                   { add Y to top source Top }
     jmp @DoneYpositions           { done Y calculations }
   @YNotNegative:
     mov dtop,bx                   { set destination Y to Y offset }
     mov stop,cx                   { set source Y to 0 }
     sub ylength,bx                { substract Y position from length }
   @DoneYpositions:
     call retrace

     mov es,sega000                { set screen segment }
     xor di,di                     { set screen offset }
     DB $66; xor ax,ax             { set EAX to 0 }
     mov cx,16000                  { draw 64000 div 4 double words }
     DB $66; REP STOSW             { and make screen black }

     mov bx,YLength     { get amount of vertical pixels }
  @VLoop:
     mov di,DTop        { get Y position on source page }
     mov cx,di          { get Y position in AX aswell }
     shl cx,6           { multiply with 64... }
     shl di,8           { ...and with 128... }
     add di,cx          { and add together (multiplied with 320) }
     add di,Dleft       { add X offset on destination page }

     mov si,Stop        { get Y position on source }
     mov cx,si          { get it in CX aswell }
     shl cx,6           { multiply with 64... }
     shl si,8           { ...and with 128... }
     add si,cx          { and add together (multiplied with 320) }
     add si,Sleft       { add X offset on source page }

     mov TEMPDS,DS      { remember DS }
     mov ds,vpage_seg   { get virtual page segment }

     mov cx,Xlength     { amount of pixels to set }
     mov dx,cx          { remember in DX }
     cmp cx,4           { can we do a double-word }
     jl @NoDoubleWord   { no. }

     shr cx,2           { yes! so divide length with 4 }
     DB $66; rep MOVSW  { store all words }
     mov cx,dx          { get original length back }
     and cx,3           { MOD with 4 }
     or cx,cx           { see if any bytes left }
     jz @NoMoreBytes    { no, so we did it }
   @NoDoubleWord:
     cmp cx,2           { are there 2 bytes left? }
     jb @NoWord         { no, so we can't use a word }
     MOVSW              { yes, so we draw 2 bytes at once }
   @NoWord:
     test cx,1          { still one byte left? }
     jz @NoMoreBytes    { nope, so we're finished }

   @NoMoreBytes:
     mov ds,TEMPDS      { get DS back }

     inc Stop           { increase source Top position }
     inc Dtop           { increase destination top position }
     dec bx             { decrease lines counter }
     jnz @Vloop         { not yet 0, so draw next line }
END;
{}
{
        Zoom in on the screen (not precise, but close enough...)
        this will allways zoom in on the center of the screen!

        Exects : size of zooming (must be higher then 0)
        Returns: Nothing
}
PROCEDURE Zoom(MidX,MidY,size:word);
VAR LEFT    : integer;
    TOP     : integer;
    XLength : word;
    YLength : word;
    y,y1    : word;
    xcount  : word;
    length  : word;
    TEMPDS  : word;
BEGIN
    xcount:=(320 div size)+size;
    ylength:=size;
    length:=size;

    left:=MidX-(Xcount div size);
    if Left<0 then Left:=0;
    if Left+Xcount>320 then Left:=320-Xcount;
    top:=MidY-(50 div size);
    if top+Length>200 then Top:=200-Length;
    if top<0 then top:=0;

    ASM
       call retrace

       mov bx,top
       mov y,bx         { set source Y to Top position }
       xor bx,bx        { set destination Y counter on 0 }
       mov y1,bx        { put it in a variable }
       mov es,sega000   { get screen segment }

    @Vloop:
       mov di,y1        { get Y position }
       mov cx,di        { put it in CX }
       shl cx,6         { multiply with 64... }
       shl di,8         { ... and with 128 (AX*320) }
       add di,cx        { add together }

       mov bx,length    { get amount of pixels per BLOCK loop }

       mov TEMPDS,DS    { remember DS }
       mov si,y         { get Y position source }
       mov ax,si        { put it in AX }
       shl ax,6         { multiply with 64... }
       shl si,8         { ... and with 128 (SI*320) }
       add si,ax        { add together }
       add si,left      { add LEFT offset }
       mov ds,vpage_seg

       mov dx,xcount

    @HLoop:
       lodsb              { load color byte }
       mov ah,al          { get color in AH aswell }
       mov cx,ax          { store color in CX }
       DB $66             { doubleword mode }
       shl ax,16          { and shift the 2 colorbytes to EAX }
       mov ax,cx          { get color back in AX again }

       mov cx,bx          { get length in CX }
       cmp cx,4           { can we do a double-word }
       jl @NoDoubleWord   { no. }

       shr cx,2           { yes! so divide length with 4 }
       DB $66; rep STOSW  { store all words }
       mov cx,bx          { get original length back }
       and cx,3           { MOD with 4 }
       or cx,cx           { see if any bytes left }
       jz @NoMoreBytes    { no, so we did it }
     @NoDoubleWord:
       cmp cx,2           { are there 2 bytes left? }
       jb @NoWord         { no, so we can't use a word }
       STOSW              { yes, so we draw 2 bytes at once }
     @NoWord:
       test cx,1          { still one byte left? }
       jz @NoMoreBytes    { nope, so we're finished }
       STOSB              { store last byte }
     @NoMoreBytes:
       dec DX
       jnz @HLoop
       mov DS,TEMPDS      { get DS back }

       inc y1             { increase Y counter }
       cmp ylength,0      { done complete screen }
       je @SetNewValue    { Yes, so set new value }
       dec ylength        { else decrease, }
       jmp @DoneYValue    { and draw next }
     @SetNewValue:
       mov ax,length      { move the original length }
       mov ylength,ax     { to the temp YLENGTH variable }
       inc y              { increase SCREEN Y counter }
     @DoneYvalue:
       cmp y1,200         { done complete screen? }
       jl @VLoop          { No, so draw next line }
    end;
END;
{}
{
        Flip/Scale the screen.
        Make sure the value is >0 and <199

        Exects : Position of the top line
        Returns: Nothing
}
PROCEDURE FLIP(value:integer);
VAR tabMAX : word;
    yReal  : real;
    BXV    : real;
    tempSI : word;
    tempDS : word;
BEGIN
 retrace;

 if (value=100) then exit;

 if value<100 then begin
     { Calculate table }
        Yreal:=200/(200-(value shl 1));
        bxV:=0;
        tabMAX:=0;
        repeat
           FlipTable[tabMAX]:=round(bxV)*320;
           bxV:=bxV+yreal;
           inc(tabMAX);
        until bxV>199;

        ASM
          {

             First make the top part black

          }
          mov es,sega000  { get screen segment }
          xor di,di       { get screen offset  }

          mov cx,value    { get start value          }
          mov ax,cx       { get it in AX as well,    }
          shl ax,4        { multiply with 256...     }
          shl cx,6        { ... and 64               }
          add cx,ax       { add together (total of *80) }

          db $66
          xor ax,ax       { set EAX to 0 }

          db $66
          rep STOSW       { store all double words }

           mov ax,value   { get begin value        }
           mov cx,ax
           shl ax,8       { multiply with 256      }
           shl cx,6       { and with 64 (total of *320 }
           add ax,cx      { add together           }

           xor bx,bx      { set Y counter to 0     }
           mov di,ax      { set screen offset to   }

           mov tempSI,offset fliptable { get fliptable position }

         @TABLEloop:
            mov si,TEMPSI          { get memory position of table }
            lodsw                  { load }
            mov TEMPSI,si          { store new offset position }

            mov tempDS,DS          { remember DS }

            mov si,vpage_ofs       { get page offset }
            add si,ax              { add start position }
            mov ds,vpage_Seg       { get page segment }

            mov cx,80              { copy double words (320 / 4) }
            db $66
            rep MOVSW              { store the line }

            mov DS,tempDS          { get DS back }
            inc bx                 { increase Y counter }
            cmp bx,tabMAX          { done all lines?    }
            jl @TableLoop          { no, so draw next   }

         {
            Fill bottom with black
         }
            mov cx,64000           { screen size }
            sub cx,di              { minus current position }
            shr cx,2               { divide by 4, for the amount of Dwords }
            db $66
            xor ax,ax              { set EAX to 0 }
            db $66
            rep stosw              { draw the rest of the screen }
        end;
 end else begin  { mirrored aswell }
     {
         Calculate table
     }
     Yreal:=200/((value-100) shl 1);
       bxV:=0;
       tabMAX:=0;
        repeat
           FlipTable[tabMAX]:=round(bxV)*320;
           bxV:=bxV+yreal;
           inc(tabMAX);
        until bxV>199;

         ASM
           mov es,sega000     { get segment of screen }
           xor di,di          { get offset of screen }

           mov cx,value       { get start value }
           mov bx,cx          { also in BX }
           shl cx,8           { multiply with 256, }
           shl bx,6           { and with 64   }
           add cx,bx          { add together (total *320) }
           mov bx,cx          { remember it in BX }

           mov cx,64000       { now, calculate the size }
           sub cx,bx          { we need to draw }
           shr cx,2           { divide by 4 (DWORDS) }

           DB $66
           xor ax,ax          { set EAX to 0 }
           DB $66
           rep stosw          { store all the blackness }

           mov di,bx
           mov ax,bx          { get start position in AX }
           xor bx,bx          { set Y counter to 0 }

           mov tempSI,offset fliptable { get the table offset }

         @TABLEloop:
            mov si,TEMPSI     { get the table offset }
            lodsw             { and load the next value }
            mov TEMPSI,si     { store the next table offset }

            mov tempDS,DS     { remember DS }

            mov si,vpage_ofs  { get page offset }
            add si,ax         { add start position }
            mov ds,vpage_Seg  { get page segment }

            mov cx,80         { draw 320/4 dwords }
            db $66
            rep MOVSW         { copy the line }

            mov DS,tempDS     { get DS back }
            sub di,640        { go to previous line }
            inc bx            { increase Y counter }
            cmp bx,tabMAX     { done complete table? }
            jl @TableLoop     { no, so draw next line }
          {

             now make the bottom part black

          }
          xor di,di
          mov cx,value    { get start value          }
          mov di,cx       { get it in AX as well,    }
          shl di,8        { multiply with 256...     }
          shl cx,6        { ... and 64               }
          add di,cx       { add together (total of *320) }
          mov cx,64000
          sub cx,di
          shr cx,2

          db $66
          xor ax,ax       { set EAX to 0 }

          db $66
          rep STOSW       { store all double words }

        end;
 end;
END;
{}
{
        Show the virtual bitmap

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE ShowBitmap; Assembler;
ASM
   Call Retrace

   MOV DX,DS                    { remember DS }

   MOV ES,sega000               { get screen SEGMENT }
   xor di,di                    { set screen offset to 0 }
   xor si,si                    { set virtual offset to 0 }
   MOV DS,vpage_seg             { get virtual segment }

   MOV CX,16000                 { draw 64000/4 double words }

   DB $66;
   REP MOVSW                    { draw all bytes }

   MOV DS,DX                    { get DS back }
END;
{}
{
        This will save the current !VIRTUALPAGE! as an PCX file

        Expects: Filename to save to (a number will be added if it exists!)
                 you don't add the extension, so call it like :

                 EXAMPL  and it will be named EXAMPL00.PCX

        Returns: Nothing
}
PROCEDURE Screenshot(filename:String);
VAR  F       : File;
     Ln      : Byte;
     L,R,G,B : Byte;
     I : Integer;
     vnum    : string[3];
     fname   : string[12];
     I2,J,T : Word;
     RLE    : array[0..640] of byte;
     rlecount : word;

BEGIN
 Halt_Proc:='ScreenShot';
 { First find a correct file name }
  filename:=copy(filename,1,6);
  l:=0;     str(l,vnum);
  if length(vnum)<2 then vnum:='0'+vnum;
  fname:=filename+vnum+'.pcx';

  assign(F,fname);
  {$I-} reset(f,1); {$I+}
  while (ioresult=0) and (l<100) do begin
        close(f);
        inc(l);     str(l,vnum);
        if length(vnum)<2 then vnum:='0'+vnum;
        fname:=filename+vnum+'.pcx';
        assign(F,fname);
        {$I-} reset(f,1); {$I+}
  end;
  if l=100 then exit;

  Assign (F,fname);
  Rewrite (F,1);

  {=-=-==-=-= Write the header =-=-=-=-=-=}
      b:=10; BlockWrite (F,B,1);            (*  Manufacturer                *)
      b:=5; BlockWrite (F,B,1);             (*  Version                     *)
      b:=1; BlockWrite (F,B,1);             (*  Encoding                    *)
      b:=8; BlockWrite (F,B,1);             (*  Bytes Per Pixel             *)
      i:=0;BlockWrite (F,I,2);              (*  Min X                       *)
      BlockWrite (F,I,2);                   (*  Min Y                       *)
      i:=319;BlockWrite (F,I,2);            (*  Max X                       *)
      i:=199;BlockWrite (F,I,2);            (*  Max Y                       *)
      i:=320; BlockWrite (F,I,2);           (*  Horizontal Resolution       *)
      i:=200; BlockWrite (F,I,2);           (*  Vertical Resolution         *)
      b:=0; For L := 1 to 48 Do BlockWrite (F,B,1); (* 16color palette      *)
      b:=0;BlockWrite (F,B,1);              (*  Reserved                    *)
      b:=1;BlockWrite (F,B,1);              (*  Color Planes                *)
      i:=320;BlockWrite (F,I,2);            (*  Bytes Per Line              *)
      i:=1;BlockWrite (F,I,2);              (*  Palette Type                *)
      B := 0;  i := 0;
      blockwrite(f,i,2); blockwrite(f,i,2);
      For L := 74 to 127 Do BlockWrite (F,B,1);

  {=-=-=-=-=- Go thru all lines =-=-=-=-=-=}
  For Ln := 0 to 199 Do begin
     asm
      xor ax,ax { set the... }
      mov i2,ax { ...i2 to 0... }
      mov j,ax  { ...j to 0... }
      mov t,ax  { ... t to 0... }
      mov RLEcount,ax
      xor ah,ah
      mov al,ln { get Line Number }
      mov bx,ax
      shl bx,6  { multiply with 64 }
      shl ax,8  { and with 256 }
      add ax,bx { add together }
      mov i,ax  { is LineNumber * 320 }
     end;

     WHILE t<320 do begin
        i2:=0;
        while ((t+i2<320) and (i2<63)) and (mem[vpage_Seg:vpage_ofs+i+(i2+t)]=mem[vpage_Seg:vpage_ofs+i+(t+i2+1)]) do
           inc(i2);
        asm
         mov es,vpage_Seg
         mov di,vpage_ofs
         add di,i
         add di,i2
         add di,T
         mov ax,es:[di]
         mov g,al
        end;
        if i2>0 then begin
           r:=i2 or 192;
           RLE[RLECount]:=r; inc(RLECOUNT);
           RLE[RLECount]:=g; inc(RLECOUNT);
           inc(t,i2);
           inc(j,2);
        End Else Begin
           if (g and 192)=192 then begin
              r:=193;
              RLE[RLEcount]:=r; inc(RLEcount);
              Inc(J);
           End;
           RLE[RLEcount]:=g; inc(RLEcount);
           Inc(T);
           Inc(J);
        End;
     End;
     Blockwrite(f,RLE,RLEcount);

  end;

  {=-=-=-=-=- Save the palette =-=-=-=-=-=-}
  L := 12;
  BlockWrite (F,L,1);
  For L := 0 to 255 Do Begin
      port[$03c7]:=l;
      r:=port[$03c9]; g:=port[$03c9]; b:=port[$03c9];
      R:=R shl 2; G:=G shl 2; B:=B shl 2;
      BlockWrite (F,R,1);  BlockWrite (F,G,1); BlockWrite (F,B,1);
  End;
  Close (F);

  {$IFDEF PLUGIN_SHOWEVENTS}
     for i:=1 to length(fname) do fname[i]:=UpCase(fname[i]);
     _AddEvent('SCREENSHOT ('+fname+')');
  {$ENDIF}
END;

{}
{
        Clear the virtual screen

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE ClearScreen; ASSEMBLER;
ASM
  mov es,vpage_Seg        { get virtual segment }
  xor di,di               { set virtual offset to 0 }
  DB $66                  { go into DoubleWord mode }
  xor ax,ax               { set EAX to 0 }
  mov cx,16000            { draw 64000/4 double words }
  DB $66; rep STOSW       { draw the bytes }
END;
{}
{
        Clear the video screen

        Exects : Nothing
        Returns: Nothing
}
PROCEDURE ClearVisible; ASSEMBLER;
ASM
  mov es,sega000        { get screen segment }
  xor di,di             { set screen offset to 0 }
  DB $66                { double words }
  xor ax,ax             { set EAX to 0 }
  mov cx,16000          { draw 64000/4 double words }
  DB $66; REP STOSW     { draw them }
END;
{}
{

        this is the routine that takes a frame and put it on the screen

        Expects: Pointer to new frame-buffer, and the amount of chunks in the
                 buffer.
        Returns: Nothing.

}
PROCEDURE FLIDrawFrame(Buffer : Pointer; Chunks : Word); ASSEMBLER;
ASM
  push ds
  lds si,Buffer       {let DS:SI point at the frame to be drawn}

 @Fli_Loop:           {main loop that goes through all the chunks in a frame}
  cmp Chunks,0        {are there any more chunks to draw?}
  je @Exit
  dec Chunks          {decrement Chunks For the chunk to process now}
  mov ax,[Word ptr ds:si+4] {let AX have the ChunkType}
  add si,6            {skip the ChunkHeader}
  cmp ax,04h          {is it a 256 level FLI_COLOR chunk? }
  je @Fli_Color256
  cmp ax,07h
  je @Fli_SS2         {word delta encoding }
  cmp ax,0Bh          {is it a 64 level FLI_COLor chunk?}
  je @Fli_Color64
  cmp ax,0Ch          {is it a FLI_LC chunk?}
  je @Fli_Lc
  cmp ax,0Dh          {is it a FLI_BLACK chunk?}
  je @Fli_Black
  cmp ax,0Fh          {is it a FLI_BRUN chunk?}
  je @Fli_Brun
  cmp ax,10h          {is it a FLI_COPY chunk?}
  je  @Fli_Copy

  jmp @Fli_Loop           {This command should not be necessary }
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{              This is the 64 color palette loop
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Color64:
  mov bx,[Word ptr ds:si]   { number of packets in this chunk }
  add si,2                  { skip the NumberofPackets }
  xor al,al                 { start at color 0 }
  xor cx,cx                 { reset CX }

 @Color_Loop:
  or  bx,bx                 {set flags}
  jz @Fli_Loop              {Exit if no more packages}
  dec bx                    {decrement NumberofPackages For the package to process now}
  mov cl,[Byte ptr ds:si+0] {first Byte in packet tells how many colors to skip}
  add al,cl                 {add the skiped colors to the start to get the new start}
  mov dx,$3C8               {PEL Address Write Mode Register}
  out dx,al                 {tell the VGA card what color we start changing}
  inc dx                    {at the port abow the PEL_A_W_M_R is the PEL Data Register}
  mov cl,[Byte ptr ds:si+1] {next Byte in packet tells how many colors to change}
  or cl,cl                  {set the flags}
  jnz @Jump_Over            {if NumberstoChange=0 then NumberstoChange=256}
  inc ch                    {CH=1 and CL=0 => CX=256}

 @Jump_Over:
  add al,cl                 {update the color to start at}
  mov di,cx                 {since each color is made of 3 Bytes (Red, Green & Blue) we have to -}
  shl cx,1                  {multiply CX (the data counter) With 3}
  add cx,di                 {CX = old_CX shl 1 + old_CX   (the fastest way to multiply With 3)}
  add si,2                  {skip the NumberstoSkip and NumberstoChange Bytes}
  rep outsb                 {put the color data to the VGA card FAST!}
  jmp @Color_Loop           {finish With this packet - jump back}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{                this is the 256 color palette loop
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Color256:
  mov bx,[Word ptr ds:si]   { number of packets in this chunk }
  add si,2                  { skip the NumberofPackets }
  xor al,al                 { start at color 0 }
  xor cx,cx                 { reset CX }

 @Color_Loop2:
  or  bx,bx                 {set flags}
  jz @Fli_Loop              {Exit if no more packages}
  dec bx                    {decrement NumberofPackages For the package to process now}
  mov cl,[Byte ptr ds:si+0] {first Byte in packet tells how many colors to skip}
  add al,cl                 {add the skiped colors to the start to get the new start}
  mov dx,$3C8               {PEL Address Write Mode Register}
  out dx,al                 {tell the VGA card what color we start changing}
  inc dx                    {at the port abow the PEL_A_W_M_R is the PEL Data Register}
  mov cl,[Byte ptr ds:si+1] {next Byte in packet tells how many colors to change}
  or cl,cl                  {set the flags}
  jnz @Jump_Over2           {if NumberstoChange=0 then NumberstoChange=256}
  inc ch                    {CH=1 and CL=0 => CX=256}

 @Jump_Over2:
  add al,cl                 {update the color to start at}
  mov di,cx                 {since each color is made of 3 Bytes (Red, Green & Blue) we have to -}
  shl cx,1                  {multiply CX (the data counter) With 3}
  add cx,di                 {CX = old_CX shl 1 + old_CX   (the fastest way to multiply With 3)}
  add si,2                  {skip the NumberstoSkip and NumberstoChange Bytes}
 @ColLoop:
  lodsb                     { load 255-value based color }
  shr al,2                  { transform to 63-value based color }
  out dx,al                 {put the color data to the VGA card }
  loop @ColLoop
  jmp @Color_Loop2          {finish With this packet - jump back}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{         This is a byte-encoded data block
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Lc:
  mov ax,0a000h              {get screen segment}
  mov es,ax                  {put it into ES}
  mov di,[Word ptr ds:si+0]  {get screen offset}
  mov ax,di                  {put it into AX }
  shl ax,8                   {multiply with 128...}
  shl di,6                   {and with 64 (DI*320)}
  add di,ax                  {add together}
  mov bx,[Word ptr ds:si+2]  {put LinestoChange into BX}
  add si,4                   {skip the LinestoSkip and LinestoChange Words}
  xor cx,cx                  {reset cx}

 @Line_Loop:
  or bx,bx                   {set flags}
  jz @Fli_Loop               {Exit if no more lines to change}
  dec bx
  mov dl,[Byte ptr ds:si]    {put PacketsInLine into DL}
  inc si                     {skip the PacketsInLine Byte}
  push di                    {save the offset address of this line}

 @Pack_Loop:
  or dl,dl                   {set flags}
  jz @Next_Line              {Exit if no more packets in this line}
  dec dl
  mov cl,[Byte ptr ds:si+0]  {put BytestoSkip into CL}
  add di,cx                  {update the offset address}
  mov cl,[Byte ptr ds:si+1]  {put BytesofDatatoCome into CL}
  or cl,cl                   {set flags}
  jns @Copy_Bytes            {no SIGN means that CL number of data is to come -}
                             {else the next data should be put -CL number of times}
  mov al,[Byte ptr ds:si+2]  {put the Byte to be Repeated into AL}
  add si,3                   {skip the packet}
  neg cl                     {Repeat CL times}
  rep stosb
  jmp @Pack_Loop             {finish With this packet}

 @Copy_Bytes:
  add si,2                   {skip the two count Bytes at the start of the packet}
  rep movsb
  jmp @Pack_Loop             {finish With this packet}
 @Next_Line:
  pop di                     {restore the old offset address of the current line}
  add di,320                 {offset address to the next line}
  jmp @Line_Loop
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{         This is a word-encoded data block, most often used!
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_SS2:
  mov ax,0a000h              {get screen segment}
  mov es,ax                  {put it into ES}
  xor di,di                  {get screen offset}
  mov bx,[Word ptr ds:si]    {put linestoChange into BX}
  add si,2                   {skip the LinestoChange Word}

 @Line_Loop2:
  or bx,bx                   {check linescounter on 0}
  jz @Fli_Loop               {Exit if no more lines to change}
  dec bx                     {decrease linescounter }
  mov dx,[word ptr ds:si]    {get OptionalWord into DL}
  add si,2                   {skip the OptionalWord }
  push di                    {save the offset address of this line}

  mov ax,dx
  and ax,49152               { get bit 15 and 16 }

  cmp ah,128                { check on  128  (byte should be stored) }
  je @PutByte
  cmp ah,192                { check on  64+128  (line  skip count) }
  je @SkipLines

 @Pack_LoopSS:
  or dl,dl                   {set flags}
  jz @Next_Line2             {Exit if no more packets in this line}
  dec dl
  xor ch,ch
  mov cl,[Byte ptr ds:si+0]  {put BytestoSkip into CL}
  add di,cx                  {update the offset address}
  mov cl,[Byte ptr ds:si+1]  {put PacketsType into CL}
  or cl,cl                   {set flags}
  jns @Copy_Words            {no SIGN means that CL number of data is to come -}
                             {else the next data should be put -CL number of times}
  mov ax,[word ptr ds:si+2]  {put the word to be Repeated into AX}
  add si,4                   {skip the packet}
  neg cl                     {Repeat CL times}
  rep stosw
  jmp @Pack_LoopSS           {finish With this packet}

 @Copy_Words:
  add si,2                   {skip the two count Bytes at the start of the packet}
  rep movsw
  jmp @Pack_LoopSS           {finish With this packet}

 @PutByte:
  mov al,dl
  stosb
  jmp @Next_Line2

 @SkipLines:
  mov ax,dx
  neg ax
  mov cx,ax
  shl cx,8
  shl ax,6
  add ax,cx
  add di,ax

 @Next_Line2:
  pop di                     {restore the old offset address of the current line}
  add di,320                 {offset address to the next line}
  jmp @Line_Loop2

{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{             Change the screen to black (all zero-byte-pixels)
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Black:
  mov ax,0a000h
  mov es,ax                  {let ES:DI point to the start of the screen}
  xor di,di
  mov cx,16000               {number of Words in a screen}
  db $66
  xor ax,ax                  {color 0 is to be put on the screen}
  db $66
  rep stosw
  jmp @Fli_Loop             {jump back to main loop}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{            A run-lenght-encode (like PCX) image block
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Brun:
  mov ax,0a000h
  mov es,ax                 {let ES:DI point at the start of the screen}
  xor di,di
  mov AX,DS
  POP DS
  mov bx,FLIHEIGHT          {numbers of lines in a screen}
  PUSH DS
  mov DS,AX
  xor cx,cx

 @Line_Loop3:
  mov dl,[Byte ptr ds:si]   {put PacketsInLine into DL}
  inc si                    {skip the PacketsInLine Byte}
  push di                   {save the offset address of this line}

 @Pack_Loop3:
  or dl,dl                  {set flags}
  jz @Next_Line3            {Exit if no more packets in this line}
  dec dl
  mov cl,[Byte ptr ds:si]   {put BytesofDatatoCome into CL}
  or cl,cl                  {set flags}
  js @Copy_Bytes3           {SIGN meens that CL number of data is to come }
                            { else the next data should be put CL number of times}
  mov al,[Byte ptr ds:si+1] {put the Byte to be Repeated into AL}
  add si,2                  {skip the packet}
  rep stosb
  jmp @Pack_Loop3           {finish With this packet}
 @Copy_Bytes3:
  inc si                    {skip the count Byte at the start of the packet}
  neg cl                    {Repeat CL times}
  rep movsb
  jmp @Pack_Loop3           {finish With this packet}

 @Next_Line3:
  pop di                    {restore the old offset address of the current line}
  add di,320                {offset address to the next line}
  dec bx                    {any more lines to draw?}
  jnz @Line_Loop3
  jmp @Fli_Loop             {jump back to main loop}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
{            A normal full-screen copy
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
 @Fli_Copy:
  mov ax,0a000h
  mov es,ax                 {let ES:DI point to the start of the screen}
  xor di,di
  mov cx,16000              {number of DWords in a screen}
  DB $66
  rep movsw
  jmp @Fli_Loop             {jump back to main loop}
 @Exit:
  pop ds

END;
{}
{
        Create a buffer  (virtual page for the FLI playing)

        Expects: Nothing
        Returns: Nothing
}
CONSTRUCTOR TFliPlayer.Init;
BEGIN
     GetMem(Buffer,BufSize);
END;
{}
{
       Destroy the frame-buffer, and FLIplayer variable

       Expects: Nothing
       Returns: Nothing
}
DESTRUCTOR TFliPlayer.Done;
BEGIN
     FreeMem(Buffer,BufSize);
END;
{}
{
        Handle the playing of the fli-file

        Expects: FILENAME of FLI
        Returns: Nothing
}
PROCEDURE TFliPlayer.Play(UseLIB:boolean;Filename : String);
VAR MainHeader  : MainHeaderRec;
    FrameHeader : FrameHeaderRec;
    FrameSize   : LongInt;
    RestartPos  : LongInt;
    Frame       : Word;
    Timeout     : LongInt;
    code        : byte;

    FUNCTION ReadHeader : Boolean;
    BEGIN
      BlockRead(lib_file,MainHeader,SizeOf(MainHeader)); { Read header record}
      with MainHeader do begin
        if ((ID<>$AF11) and (ID<>$AF12)) or (width>320) or (height>200)then
          ReadHeader:=FALSE                       { Not a correct .FLI File}
        else begin
          ReadHeader:=TRUE;
        end;
        FLIHEIGHT:=height;
      end;
    END;

    PROCEDURE ReadFrame;
    BEGIN
      BlockRead(Lib_File,FrameHeader,SizeOf(FrameHeader));
      if frameheader.id=$F100 then begin { unneeded information in file }
         blockread(lib_file,buffer^,frameheader.size-sizeof(frameheader));
         BlockRead(lib_file,FrameHeader,SizeOf(FrameHeader));
      end;
      FrameSize := FrameHeader.Size - SizeOf(FrameHeader);
    END;

    PROCEDURE ProcessFrame;
    BEGIN
      BlockRead(lib_file,Buffer^,FrameSize);
      FLIDrawFrame(Buffer,FrameHeader.Chunks);
    END;

BEGIN
   LOADON;
   Halt_Proc:='TFliPlayer.Play';

    if UseLib then begin
       code:=LIB_reset(filename);
       if code<>0 then begin
          halt_Error:='unable to open entry '+filename;
          LOADOFF;
          exit;
       end;
    end else begin
       Assign(lib_file,Filename);
       key_start:=0;
       {$I-}
         Reset(lib_file,1);
       {$I+}
       if (IOResult<>0) then begin
          halt_Error:='unable to open entry '+filename;
          LOADOFF;
          exit;
       end;
    end;
    if ReadHeader then begin
       ReadFrame;
       RestartPos:=SizeOf(MainHeader)+SizeOf(FrameHeader)+FrameSize;
       ProcessFrame;
       Frame:=1;
        REPEAT
           ReadFrame;
           if FrameSize<>0 then
              for code:=1 to 7 do retrace;
              ProcessFrame;
              inc(Frame);
        UNTIL (Frame>MainHeader.Frames) or AnyPressed;
    end;
   Close(lib_file);
   LOADOFF;
END;
{}
{
        This will play a FLI file and handle ALL the things

        Expects: Filename of FLI file
        Returns: Nothing
}
PROCEDURE AAPlay(UseLib:boolean;Filename : String);
VAR Player : TFliPlayer;
BEGIN
   with Player do
     if Init then begin
            Play(UseLib,Filename);
            Done;
     end;
END;
{}
{
        Load in the color map for light-sourcing

        Expects: LIB  - True if loading from DFP file
                  and filename of the colormap
        Returns: TRUE if succesfull
}
FUNCTION LoadColorMap(lib:boolean;filename:string):boolean;
VAR code : byte;
BEGIN
 LOADON;
 LoadColorMap:=false;

 if lib then begin              { use a lib file? }
    code:=LIB_RESET(filename);      { yes, so reset it }
    if code<>0 then begin
       halt_error:='Resource not found ('+filename+')';
       LOADOFF;
       exit;       { if code<>0 something went wrong }
    end;
 end else begin
    assign(lib_file,filename);      { use dos file }
    {$I-}
       reset(lib_file,1);       { reset the file }
    {$I+}
    if ioresult<>0 then begin
       Halt_Error:='File not found ('+filename+')';
       LOADOFF;
       exit;
    end;
 end;
 blockread(lib_file,colormap,sizeof(colormap));
 LoadColorMap:=true;
 close(lib_file);
 LOADOFF;
END;

{}
{
        Draw a box somewhere on screen (shaded or illuminated)

        Expects: corner positions (x1,y1 - x2,y2) and brightness value
        Returns: Nothing
}
PROCEDURE DrawLightBox(dx1,dy1,dx2,dy2:integer;Dbright:word); ASSEMBLER;
VAR tempCX : word;
    tempSI : word;
    tempDI : word;
ASM
                mov di,319     { use DI for screen width... faster }
                mov ax,Dx1      { get LEFT X }
                mov cx,Dx2      { get RIGHT X }
              @NoSub1:
                cmp ax,di      { check left on right-screen pos }
                jg @Exit       { larger, so exit! }
                cmp ax,0       { check left on left-screen pos }
                jge @X1Ok      { greater or equal, so it's ok }
                xor ax,ax      { set it to 0 }
              @X1Ok:
                inc di         { change right-screen pos to 320 }
                cmp cx,0       { check right on left-screen pos }
                jng @Exit      { it's less, so EXIT }
                cmp cx,di      { check right on right-screen pos }
                jbe @X2Ok      { below or equal, so it's ok }
                mov cx,di      { set right to right-screen pos }
              @X2Ok:
                mov Dx1,ax      { set X1 to new coordinate }
                sub cx,ax       { substract RIGHT-LEFT, leaving the width in CX }

                and LowDetail,1
                jz @NormalDetail

                inc cx
                shr cx,1
              @NormalDetail:

                mov TEMPCX,CX   { put width in TEMPCX }

                mov di,199     { use DI for screen height... faster }
                mov ax,Dy1      { get TOP }
                mov cx,Dy2      { get BOTTOM }
              @NoSub2:
                cmp ax,di      { check top on bottom-screen pos }
                jg @Exit       { larger, so EXIT }
                cmp ax,0       { check top on top-screen pos }
                jge @Y1Ok      { greater or equal, so it's ok }
                xor ax,ax      { set top to 0 }
              @Y1Ok:
                inc di         { set bottom-screen pos to 200 }
                cmp cx,0       { check bottom on top-screen pos }
                jng @Exit      { not greater, so EXIT }
                cmp cx,di      { check bottom on bottom-screen pos }
                jbe @Y2Ok      { below or equal, so it's ok }
                mov cx,di      { set bottom to bottom-screen pos }
              @Y2Ok:
                mov bx,cx      { set BX to bottom value }

                mov es,vpage_seg      { get screen segment }
                mov di,ax             { put TOP Y value also in CX }

                sub bx,ax             { substract top Y  from BOTTOM Y to get height }
                shl ax,6              { multiply top Y with 64... }
                shl di,8              { ... and with 256 }
                add di,ax             { add together (y*320) }
                add di,Dx1            { and add LEFT X position }

                mov si,offset colormap { get offset of the colormap }
                add si,Dbright         { add brightness }
                mov DX,SI              { and remember it }

                and lowDetail,1
                jz @YLoopHi

              @YLoop:
                mov TEMPDI,DI         { remember calculated DI }
                mov CX,TEMPCX         { get width back }
              @Xloop:
                xor ah,ah             { set AH to 0 }
                mov al,es:[di]        { get color value on-screen }
                mov SI,DX             { get offset colormap back }
                shl ax,5              { multiply with 32 (0-31 tints) }
                add si,ax             { add to colormap offset }
                mov al,[si]           { get new color value }
                mov ah,al
                stosw

                LOOP @Xloop           { loop until CX=0 }
              @DoneX:
                mov DI,TEMPDI         { get DI back }
                add di,320            { add 320, for the next line }
                dec bx                { and decrease the Y counter }
                jnz @YLoop            { not 0, draw next line }
                jmp @Exit

              @YLoopHi:
                mov TEMPDI,DI         { remember calculated DI }
                mov CX,TEMPCX         { get width back }
              @XloopHI:
                xor ah,ah             { set AH to 0 }
                mov al,es:[di]        { get color value on-screen }
                mov SI,DX             { get offset colormap back }
                shl ax,5              { multiply with 32 (0-31 tints) }
                add si,ax             { add to colormap offset }
                mov al,[si]           { get new color value }
                stosb

                LOOP @XloopHi         { loop until CX=0 }
              @DoneXHi:
                mov DI,TEMPDI         { get DI back }
                add di,320            { add 320, for the next line }
                dec bx                { and decrease the Y counter }
                jnz @YLoopHi           { not 0, draw next line }
              @Exit:
END;

{}
{
        Add a Light source on the map

        Expects: top-left, bottom-right position, start-brightness,
                 brightADD, and if  MAPX,MAPY should be substracted
        Returns: True if succesfully added the bullet
}
FUNCTION AddLight(  xx1,yy1,xx2,yy2 : integer;
                    bright  :word;
                    SubMap2 : boolean;
                    LType   : byte): boolean;
VAR  Temp     : PLight;
     i        : integer;
BEGIN
 Halt_Proc:='AddLight';
 AddLight:=true;
 if (xx1=xx2) or (yy1=yy2) then exit;

 if memavail<sizeof(temp^) then exit;
 new(Temp);
 IF Temp=NIL then begin
    AddLight:=false;
    halt_error:='unable to spawn light-source';
    exit;
 END;

 IF FirstLight=NIL  then begin
    LastLight:=Temp;
    FirstLight:=Temp;
    with FirstLight^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 END ELSE BEGIN
     LastLight^.next:=temp;
     Temp^.prev:=LastLight;
     LastLight:=Temp;
     Temp^.next:=NIL;
 END;


 WITH TEMP^ do begin
  if xx1>xx2 then begin
     i:=xx1;
     xx1:=xx2;
     xx2:=i;
  end;
  if yy1>yy2 then begin
     i:=yy1;
     yy1:=yy2;
     yy2:=i;
  end;

  x1:=xx1;  y1:=yy1;
  x2:=xx2;  y2:=yy2;
  LightFlag:=LType;
  StartBright:=Bright;
  CurBright:=StartBright;
    CASE LType of
     1 :  CurBright:=random(StartBright);
     2 :  BrAdd:=1;
     3 :  BrAdd:=-1;
     4 :  BrAdd:=1;
     5 :  BrAdd:=-1;
    END;
    SubMap:=SubMap2;

 END;
END;
{}
{

        Erase a LIGHT source from the linked-list

        Expects: pointer to Light object that needs to be ERASED!
        Returns: True if succesfull

}
FUNCTION EraseLight(Temp:PLight):boolean;
VAR  next_light,
     prev_light  : Plight;
     i        : integer;
     msize    : word;
BEGIN
  Halt_Proc:='EraseLight';
  eraselight:=true;
  if Temp=NIL then begin
     eraselight:=false;
     halt_error:='unable to deallocate light-source';
     exit;
  end;

  prev_light:=Temp^.prev;
  next_light:=Temp^.next;

  if prev_light=NIL then begin
     Firstlight:=next_light;
  end else Prev_light^.next:=next_light;

  if next_light=NIL then begin
     Lastlight:=prev_light;
  end else Next_light^.prev:=prev_light;

  dispose(Temp);
END;
{}
{

        Erase ALL LIGHT sources

        Expects: Nothing
        Returns: True if succesfull

}
FUNCTION EraseLightAll:boolean;
VAR  next_light,
     prev_light  : Plight;
     i        : integer;
     msize    : word;
     temp     : plight;
     nxt      : plight;
BEGIN
  Halt_Proc:='EraseLightAll';
  eraselightAll:=true;
  temp:=FirstLight;
  while temp<>nil do begin
        nxt:=temp^.next;
        if not EraseLight(temp) then begin
           Halt_Error:=('unable to erase lights');
           EraseLightAll:=false;
           exit;
        end;
        temp:=nxt;
  end;
END;
{}
{
        Handle the LIGHT-SOURCE linked list

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE DoLights;
VAR temp      : PLight;
    next_Light: PLight;
    done      : boolean;

    Dx1,Dy1,Dx2,Dy2 : integer;
    DBright         : word;
    DSubMap         : boolean;

    tempDI : word;
    tempCX : word;
BEGIN
 Halt_Proc:='DoLights';
 temp:=FirstLight;
 while temp<>Nil do begin
       with temp^ do begin
            done:=false;
            next_Light:=temp^.next;
             case LightFlag of
            { 0  : Normal light, no changes }
              1 : begin    { random flickering }
                    if BrAdd>0 then dec(BrAdd) else begin
                       CurBright:=random(StartBright);
                       BrAdd:=3;
                    end;
              end;
              2 : begin { Bright pulsating, continously }
                    inc(curBright,BrAdd);
                    if (CurBright>=31) or (CurBright<=StartBright) then BrAdd:=-BrAdd;
              end;
              3 : begin { Dark pulsating, continously }
                    inc(curBright,BrAdd);
                    if (CurBright>=StartBright) or (CurBright=0) then BrAdd:=-BrAdd;
              end;
              4 : begin { Bright pulsating, once }
                    inc(curBright,BrAdd);
                    if (CurBright=31) then BrAdd:=-BrAdd;
                    if CurBright=16 then begin
                       if not EraseLight(Temp) then halt;
                       done:=true;
                    end;
              end;
              5 : begin { Dark pulsating, once }
                    inc(curBright,BrAdd);
                    if (CurBright=0) then BrAdd:=-BrAdd;
                    if CurBright=16 then begin
                       if not EraseLight(Temp) then halt;
                       done:=true;
                    end;
              end;
            end;
            {=-=-=-=-=-= Draw Light Area =-=-=-=-=-=}
            if not DONE then BEGIN
               if SubMap then begin
                   Dx1:=x1-mapx;
                   Dx2:=x2-mapx;
                   Dy1:=y1-mapy;
                   Dy2:=y2-mapy;
               end else begin
                   Dx1:=x1;
                   Dy1:=y1;
                   Dx2:=x2;
                   Dy2:=y2;
               end;
               Dbright:=curbright;
               ASM
                mov di,319     { use DI for screen width... faster }
                mov ax,Dx1      { get LEFT X }
                mov cx,Dx2      { get RIGHT X }
              @NoSub1:
                cmp ax,di      { check left on right-screen pos }
                jg @Exit       { larger, so exit! }
                cmp ax,0
                jge @X1Ok      { greater or equal, so it's ok }
                xor ax,ax      { set it to 0 }
              @X1Ok:
                inc di         { change right-screen pos to 320 }
                cmp cx,0       { check right on left-screen pos }
                jng @Exit      { it's less, so EXIT }
                cmp cx,di      { check right on right-screen pos }
                jbe @X2Ok      { below or equal, so it's ok }
                mov cx,di      { set right to right-screen pos }
              @X2Ok:
                mov Dx1,ax      { set X1 to new coordinate }
                sub cx,ax       { substract RIGHT-LEFT, leaving the width in CX }

                and LowDetail,1
                jz @NormalDetail

                inc cx
                shr cx,1
              @NormalDetail:
                mov TEMPCX,CX   { put width in TEMPCX }

                mov di,199     { use DI for screen height... faster }
                mov ax,Dy1      { get TOP }
                mov cx,Dy2      { get BOTTOM }
              @NoSub2:
                cmp ax,di      { check top on bottom-screen pos }
                jg @Exit       { larger, so EXIT }
                cmp ax,0       { check top on top-screen pos }
                jge @Y1Ok      { greater or equal, so it's ok }
                xor ax,ax      { set top to 0 }
              @Y1Ok:
                inc di         { set bottom-screen pos to 200 }
                cmp cx,0       { check bottom on top-screen pos }
                jng @Exit      { not greater, so EXIT }
                cmp cx,di      { check bottom on bottom-screen pos }
                jbe @Y2Ok      { below or equal, so it's ok }
                mov cx,di      { set bottom to bottom-screen pos }
              @Y2Ok:
                mov bx,cx      { set BX to bottom value }

                mov es,vpage_seg      { get screen segment }
                mov di,ax             { put TOP Y value also in CX }

                sub bx,ax             { substract top Y  from BOTTOM Y to get height }

                shl ax,8              { multiply top Y with 64... }
                shl di,6              { ... and with 256 }
                add di,ax             { add together (y*320) }
                add di,Dx1            { and add LEFT X position }

                mov si,offset colormap { get offset of the colormap }
                add si,Dbright         { add brightness }
                mov DX,SI

                and lowDetail,1
                jz @YLoopHi

              @YLoop:
                mov TEMPDI,DI         { remember calculated DI }
                mov CX,TEMPCX         { get width back }
              @Xloop:
                xor ah,ah             { set AH to 0 }
                mov al,es:[di]        { get color value on-screen }
                mov SI,DX             { get offset colormap back }
                shl ax,5              { multiply with 32 (0-31 tints) }
                add si,ax             { add to colormap offset }
                mov al,[si]           { get new color value }
                mov ah,al
                stosw

                LOOP @Xloop           { loop until CX=0 }
              @DoneX:
                mov DI,TEMPDI         { get DI back }
                add di,320            { add 320, for the next line }
                dec bx                { and decrease the Y counter }
                jnz @YLoop            { not 0, draw next line }
                jmp @Exit

              @YLoopHi:
                mov TEMPDI,DI         { remember calculated DI }
                mov CX,TEMPCX         { get width back }
              @XloopHI:
                xor ah,ah             { set AH to 0 }
                mov al,es:[di]        { get color value on-screen }
                mov SI,DX             { get offset colormap back }
                shl ax,5              { multiply with 32 (0-31 tints) }
                add si,ax             { add to colormap offset }
                mov al,[si]           { get new color value }
                stosb

                LOOP @XloopHi         { loop until CX=0 }
              @DoneXHi:
                mov DI,TEMPDI         { get DI back }
                add di,320            { add 320, for the next line }
                dec bx                { and decrease the Y counter }
                jnz @YLoopHi           { not 0, draw next line }
              @Exit:
            END;
          END;
       end;
       temp:=next_Light;
  end;
END;

{
        Initialise the copper bar

        Exects : Nothing
        Returns: Nothing
{}
PROCEDURE InitCopper; ASSEMBLER;
ASM
    and ForceHight,1     { see if FORCEHIGHT = true }
    jnz @NoHightCalculate { yes, so we don't have to calculate it! }

    mov al,coppertop     { get top color in AL (AH is stil 0, so this is... }
    mov dx,ax            { ...faster to get it in DX }
    mov al,copperbottom  { get bottom color }
    sub ax,dx            { substract top color }
    add ax,2             { add 2 (first and last color) }
    mov cx,ax            { get calculated value in CX }
    mov ax,200           { get 200 in AX }

    and UseLAyer,1       { using parallax layer effect? }
    jz  @FullScreenCopper  { no, so we have full-screen copper }
    mov ax,152             { yes, so copper ends at 152 (one spare bar) }
   @FullScreenCopper:
    cwd                  { convert AX word to EAX Dword }
    idiv cx              { and divide with calculated value }
    mov Copperhight,ax   { get AX in barhight }
   @NoHightCalculate:
    mov LayerCopper,false
    mov al,usecopper
    mov ah,uselayer
    or al,ah
    jz  @NoBackground
    mov LayerCopper,true
  @NoBackground:

    mov dx,copperhight  { get bar hight in copperhight }
    mov ax,320          { screen width }
    mul dx              { multiply screen width with bar height }
    shr ax,2            { and divide by 4 (double-words are used) }
    mov dx,cx           { get CX (AX color values) in DX for later }
    mov BytesPerBar,ax  { get calculated value in CX }

END;
{}
{
        Create copper background sky...
        The colors will be decreased from color2 downto color1, no checking
        on the color values, so make sure color2 is LARGER/HIGHER then color1
        !!!

        Note that this is not a real copper sky, since it uses colors in
        the palette to DRAW them on screen, not using an interrupt to change
        color 0...but it works!!

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE CopperSkyDown; Assembler;
ASM
    mov es,vpage_seg    { get virtual page segment }
    xor ax,ax           { set AX to 0 }
    mov di,ax           { set screen offset set to 0 }


  @NoHightCalculate:
    mov bl,CopperBottom { get color 2 in BL }
    mov al,bl           { get color in AL for later use }
    sub bl,CopperTop    { substract color 1 }
    inc bl              { increase 1 because the last color is also valid }

    mov ah,al           { get color in AH aswell }
    mov cx,BytesPerBar  { Size of the !complete! bar (width*height pixels) }

    mov DX,CX           { remember CX }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { shift AX to double-word EAX }
    mov ax,cx           { get values back in AX aswell }
    mov CX,DX           { get CX back }

  @LoopColorSet:
    mov DX,CX           { remember CX }
    DB $66              { double-word mode }
    rep STOSW           { Store the color }

    dec al              { decrease color value }
    dec ah              { decrease color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }

    mov CX,DX           { get CX back }
    dec bl              { decrease lines left }
    jnz @LoopColorSet   { done all lines? }

    and UseLayer,1      { if true, skip drawing rest of screen }
    jnz @NoMorePutting
    cmp di,64000        { see if we got to the bottom }
    ja @NoMorePutting  { no, so we won't have to put it }
   @Startputtin:
    inc al              { increase color value }
    inc ah              { increase color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }

    mov cx,64000        { get 64000 in CX }
    sub cx,di           { and substract the position were we are }
    shr cx,2            { divide by 4 (using double-words) }

    DB $66
    rep STOSW

   @NoMorePutting:

    {

        Put some more lines in it for better effect, if possible...

    }


    mov bl,byte ptr Copperhight { get barhight in BL (BH will be 0 since
                                  copperhight won't be more then 255) }
    mov bh,184         { bottom Y is 184 }
    and UseLayer,1     { see if we use a layer }
    jz  @NotUsingLayer { we're not using a layer }
    mov bh,152         { we are using a layer, so draw only half-screen }
   @NotUsingLayer:
    cmp bl,5           { see if we need to put lines in... }
    jle @NotPossible   { nope, so skip this part (faster aswell!) }
    sub bl,3           { substract 3 lines }

    xor ah,ah
    mov al,bl          { get Y position }
    mov di,ax
    shl di,8
    shl ax,6
    add di,ax

    mov ax,320
    mul Copperhight     { multiply screen width with bar height }
    mov cx,ax           { get it in CX }
    sub cx,320          { decrease with one line }

    mov DX,CX           { remember CX }

    mov al,CopperBottom { first color }
    dec al              { decrease with one }
    mov ah,al           { get color in AH and AL }
    mov cx,ax           { remember color }
    DB $66              { double word mode }
    shl ax,16           { move AX to EAX }
    mov ax,cx           { get color back in AX }

    mov CX,DX           { get bar-hight back in CX }

  @NextLine:
    mov DX,CX           { remember CX }

    mov cx,80           { draw 1 line of double words (320/4) }
    DB $66              { double word mode }
    rep STOSW           { store all words }

    cmp al,coppertop
    je @NoDecreases
    dec al              { decrease color value }
    dec ah              { decrease color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }
   @NoDecreases:
    mov CX,DX           { get CX back }
    add di,cx           { add CX to the screen offset }
    add bl,byte ptr copperhight  { add hight of the bar to BX }

    cmp bl,bh           { see if we hit the bottom of the screen }
    jb @NextLine
   @NoTpossible:
END;
{}
{
        Create copper background sky...
        The colors will be INCREASED from color1 to color2, no checking
        on the color values, so make sure color2 is LARGER/HIGHER then color1
        !!!

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE CopperSkyUP; Assembler;
ASM
    mov es,vpage_seg    { get virtual page segment }
    xor ax,ax           { set AX to 0 }
    xor di,di           { get screen offset set to 0 }

    mov bl,Copperbottom { get color 2 in BL }
    mov al,CopperTop    { get color in AL for later use }
    sub bl,al           { substract color 1 }
    inc bl              { increase 1 because the last color is also valid }

    mov ah,al           { get color in AH aswell }
    mov cx,BytesPerBar  { get full amount of pixels per bar (width*height) }

    mov DX,CX           { remember CX }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { shift AX to double-word EAX }
    mov ax,cx           { get values back in AX aswell }
    mov CX,DX           { get CX back }

  @LoopColorSet:
    mov DX,CX           { remember CX }
    DB $66              { double-word mode }
    rep STOSW           { Store the color }

    inc al              { increase color value }
    inc ah              { increase color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }

    mov CX,DX           { get CX back }
    dec bl              { decrease lines left }
    jnz @LoopColorSet   { done all lines? }

    and UseLayer,1      { if true, skip drawing rest of screen }
    jnz @NoMorePutting
    cmp di,64000        { see if we got to the bottom }
    ja @NoMorePutting  { no, so we won't have to put it }
   @Startputtin:
    dec al              { decrease color value }
    dec ah              { decrease color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }

    mov cx,64000        { get 64000 in CX }
    sub cx,di           { and substract the position were we are }
    shr cx,2            { divide by 4 (using double-words) }

    DB $66
    rep STOSW

   @NoMorePutting:

    {

        Put some more lines in it for better effect, if possible...

    }


    mov bl,byte ptr Copperhight { get barhight in BL (BH will be 0 since
                                  copperhight won't be more then 255) }
    mov bh,184         { bottom Y is 184 }
    and UseLayer,1     { see if we use a layer }
    jz  @NotUsingLayer { we're not using a layer }
    mov bh,152         { we are using a layer, so draw only half-screen }
   @NotUsingLayer:
    cmp bl,5           { see if we need to put lines in... }
    jle @NotPossible   { nope, so skip this part (faster aswell!) }
    sub bl,3           { substract 3 lines }

    xor ah,ah
    mov al,bl          { get Y position }
    mov di,ax
    shl di,8
    shl ax,6
    add di,ax

    mov ax,320
    mul Copperhight     { multiply screen width with bar height }
    mov cx,ax           { get it in CX }
    sub cx,320          { decrease with one line }

    mov DX,CX           { remember CX }

    mov al,CopperTop    { first color }
    inc al              { increase with one }
    mov ah,al           { get color in AH and AL }
    mov cx,ax           { remember color }
    DB $66              { double word mode }
    shl ax,16           { move AX to EAX }
    mov ax,cx           { get color back in AX }

    mov CX,DX           { get bar-hight back in CX }

  @NextLine:
    mov DX,CX           { remember CX }

    mov cx,80           { draw 1 line of double words (320/4) }
    DB $66              { double word mode }
    rep STOSW           { store all words }

    cmp al,copperbottom
    je @NoDecreases
    inc al              { increase color value }
    inc ah              { increase color value High aswell }
    mov cx,ax           { remember AX }
    db $66              { double word mode }
    shl ax,16           { copy AX to EAX }
    mov ax,cx           { get colors back in AX }
   @NoDecreases:
    mov CX,DX           { get CX back }
    add di,cx           { add CX to the screen offset }
    add bl,byte ptr copperhight  { add hight of the bar to BX }

    cmp bl,bh           { see if we hit the bottom of the screen }
    jb @NextLine
   @NoTpossible:
END;
{}
FUNCTION GetSpriteX(sprite:spritetyp):byte;
VAR dataptr : pointer;
    wi      : byte;
BEGIN
  DataPtr:=sprite.data;
  asm
   les di,dataptr
   xor ah,ah
   mov al,es:[di]
   mov wi,al
  end;
  GetSpriteX:=wi;
END;
{}
FUNCTION GetSpriteY(sprite:spritetyp):byte;
VAR dataptr : pointer;
    hi      : byte;
BEGIN
  DataPtr:=sprite.data;
  asm
   les di,dataptr
   xor ah,ah
   mov al,es:[di+1]
   mov hi,al
  end;
  GetSpriteY:=hi;
END;
{}
{
        Put a sprite on screen console style (clipping, and masking)
        Original procedure by Chris Curtis.

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE Sprite; Assembler;
var XSize, YSize, SIOff : Integer;
    tempDS              : word;
    OrigW               : word;
    OrigH               : word;
    X,Y                 : integer;
ASM
    mov tempDS,DS

    mov X,ax
    mov Y,bx

    xor ch,ch
    mov cl,es:[di]
    mov origW,cx
    mov cl,es:[di+1]
    mov origH,cx

    {'Cache' MinY and MaxY}
    cmp ax, 319
    jg @Done
    cmp bx, 199 { cx }
    jg @Done
    {les di, Image}
    add ax, origW {es:[di]}
    dec ax
    cmp ax, 0
    jl @Done {AX -> X2}
    add bx, origH {es:[di+2]}
    dec bx
    cmp bx, 0 { dx }
    jl @Done {BX -> Y2}
    mov si, di
    add si, 2 {SI points to start of image data}
    mov ax, origH {es:[di+2]}
    mov YSize, ax
    {Clip lower Y region}
    cmp bx, 199 { cx }
    jle @1
    sub bx, 199 { cx }
    sub YSize, bx
   @1:
    {Clip upper Y region}
    mov bx, Y
    cmp bx, 0 { dx }
    jge @2 {Y2 is on screen}
    xor cx,cx { mov cx, dx }
    sub cx, bx
    add Y, cx
    sub YSize, cx
    mov ax, origW {es:[di] {Width}
    imul cx
    add si, ax
   @2:
   {Now Y dimension is clipped, SI points to offset start of image, YSize is
    how many lines to draw}
    mov ax, origW {es:[di]}
    mov XSize, ax
    mov bx, X
    cmp bx, 0
    jl @XClip
    add bx, ax
    dec bx
    cmp bx, 319
    jg @XClip
{---- No XClipping-----------------------------------------------------------}
    mov ax, es
    mov es, vpage_seg
    mov bx, Y
    mov di,bx
    shl bx, 6
    shl di, 8
    add di, bx

    add di, X
    mov ds, ax {ES:DI points to screen, DS:SI points to start of image}
    mov bx, 320
    sub bx, XSize
    mov dx, YSize
    shr XSize, 1
    jnc @aEvenLine
    jz @Single
    jmp @aOddLine
    {AX -> Color grab
     BX -> DI displacement
     CX -> Width counter
     DX -> Line counter}
   @aEvenLine:
     mov cx, XSize       {Ch chnng, new line}
   @aEvenPixel:
     mov ax, ds:[si]
     add si, 2
     test al, al
     jnz @aE?1
     test ah, ah
     jnz @aE10
    @aE00:
      add di, 2
      dec cx
      jnz @aEvenPixel
      add di, bx
      dec dx
      jnz @aEvenLine
      jmp @Done
   @aE10:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @aEvenPixel
      add di, bx
      dec dx
      jnz @aEvenLine
      jmp @Done
   @aE?1:
      test ah, ah
      jnz @aE11
   @aE01:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @aEvenPixel
      add di, bx
      dec dx
      jnz @aEvenLine
      jmp @Done
   @aE11:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @aEvenPixel
      add di, bx
      dec dx
      jnz @aEvenLine
      jmp @Done
  @aOddLine:
   mov cx, XSize       {Ch chnng, new line}
   mov al, ds:[si]
   inc si
   test al, al
   jz @Skip
   mov es:[di], al
  @Skip:
   inc di
  @aOddPixel:
     mov ax, ds:[si]
     add si, 2
     test al, al
     jnz @aO?1
     test ah, ah
     jnz @aO10
    @aO00:
      add di, 2
      dec cx
      jnz @aOddPixel
      add di, bx
      dec dx
      jnz @aOddLine
      jmp @Done
    @aO10:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @aOddPixel
      add di, bx
      dec dx
      jnz @aOddLine
      jmp @Done
    @aO?1:
      test ah, ah
      jnz @aO11
    @aO01:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @aOddPixel
      add di, bx
      dec dx
      jnz @aOddLine
      jmp @Done
    @aO11:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @aOddPixel
      add di, bx
      dec dx
      jnz @aOddLine
      jmp @Done
      jmp @Done
{----------------------------------------------------------------------------}
  @XClip:
   mov ax, 320
   sub ax, XSize
   xor cx, cx    {CX will keep track of SI displacement}
   mov dx, X
   cmp dx, 0
   jge @ClipRight
   xor bx,bx
   sub bx, dx     {BX = X bytes in left}
   add si, bx
   add X, bx
   add cx, bx
   sub XSize, bx
  @ClipRight:
   add dx, origW {es:[di]}
   dec dx {X2}
   cmp dx, 319
   jle @Start
   sub dx, 319    {DX = X bytes in right}
   sub XSize, dx
   add cx, dx
  @Start:
   mov SIOff, cx
   mov ax, es
   mov es, vpage_Seg
   mov bx, Y
   mov di, bx
   shl bx, 6
   shl di, 8
   add di, bx

   add di, X {ES:DI points to screen, DS:SI points to start of image}
   mov ds, ax
   mov bx, 320
   sub bx, XSize
   mov dx, YSize
   shr XSize, 1
   jnc @bEvenLine
   jz @SingleStart
   jmp @bOddLine
{
  AX -> Color grab
  BX -> DI displacement
  CX -> Width counter
  DX -> Line counter}
  @bEvenLine:
     mov cx, XSize       {Ch chnng, new line}
   @bEvenPixel:
      mov ax, ds:[si]
      add si, 2
      test al, al
      jnz @bE?1
      test ah, ah
      jnz @bE10
     @bE00:
      add di, 2
      dec cx
      jnz @bEvenPixel
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLine
      jmp @Done
     @bE10:
      mov es:[di+1], ah
      add di, 2
      dec cx
      jnz @bEvenPixel
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLine
      jmp @Done
     @bE?1:
      test ah, ah
      jnz @bE11
     @bE01:
      mov es:[di], al
      add di, 2
      dec cx
      jnz @bEvenPixel
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLine
      jmp @Done
     @bE11:
      mov es:[di], ax
      add di, 2
      dec cx
      jnz @bEvenPixel
      add di, bx
      add si, SIOff
      dec dx
      jnz @bEvenLine
      jmp @Done
  @bOddLine:
   mov cx, XSize       {Ch chnng, new line}
   mov al, ds:[si]
   inc si
   test al, al
   jz @bSkip
   mov es:[di], al
    @bSkip:
      inc di
     @bOddPixel:
       mov ax, ds:[si]
       add si, 2
       test al, al
       jnz @bO?1
       test ah, ah
       jnz @bO10
      @bO00:
       add di, 2
       dec cx
       jnz @bOddPixel
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLine
       jmp @Done
      @bO10:
       mov es:[di+1], ah
       add di, 2
       dec cx
       jnz @bOddPixel
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLine
       jmp @Done
      @bO?1:
       test ah, ah
       jnz @bO11
      @bO01:
       mov es:[di], al
       add di, 2
       dec cx
       jnz @bOddPixel
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLine
       jmp @Done
      @bO11:
       mov es:[di], ax
       add di, 2
       dec cx
       jnz @bOddPixel
       add di, bx
       add si, SIOff
       dec dx
       jnz @bOddLine
       jmp @Done
  @SingleStart:
   mov bx, 320
  @Single:
    mov al, ds:[si]
    test al, al
    jz @SingleSkip
    mov es:[di], al
   @SingleSkip:
    inc si
    add di, bx
    dec dx
    jnz @Single
 @Done:
  mov DS,TEMPDS
END;
{}
{
        This is the same as the SPRITE procedure, but this one mirrors the
        image in X direction.

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE XFlipSprite; ASSEMBLER;
VAR TempREG       : word;
    TempCH        : byte;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}
   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub dx,cx               { substract 320, to get clip-position in data }
   add si,dx
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @ExitSprite
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,0
    jz @ExitSprite
    or cl,0
    jz @ExitSprite
    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @ExitSprite     { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @ExitSprite     { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }


{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }

{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,vpage_seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   xor al,al                   { set CH to 0 }
   xchg al,ah
   ADD BP,AX                   { add clipping width to DI }
   dec BP                      { minus one (trust me, this is needed) }
   xchg al,ah
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }

@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   MOV [ES:DI],AL              { Otherwise store byte }

@NoBlit:
   DEC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }

   DEC CH                       { Decrease Hight Counter }
   JNZ @Outer

   POP BP
   POP DS

 @ExitSprite:
END;
{}
{
        Put a sprite on screen fast style (only clipping, no masking)
        Original procedure by Chris Curtis.

        Expects: AX to be X position
                 BX to be Y position
                 ES:[DI] to point to image data
        Returns: Nothing
}
PROCEDURE SpriteNoMask; Assembler;
VAR XSize, YSize : Integer;
    X,Y          : integer;
    tempDS       : word;
ASM
   mov X,ax
   mov Y,bx
   mov tempDS,DS
   {'Cache' MinY and MaxY}
   cmp ax, 319
   jg @Done
   cmp bx, 199 { cx }
   jg @Done
   add al, es:[di]
   dec ax
   cmp ax, 0
   jl @Done {AX -> X2}
   add bl, es:[di+1]
   dec bx
   cmp bx, 0 { dx }
   jl @Done {BX -> Y2}
   mov si, di
   add si, 2 {SI points to start of image data}
   xor ah, ah
   mov al, es:[di+1]
   mov YSize, ax
   {Clip lower Y region}
   cmp bx, 199 { cx }
   jle @1
   sub bx, 199 { cx }
   sub YSize, bx
  @1:
   {Clip upper Y region}
   mov bx, Y
   cmp bx, 0 { dx }
   jge @2 {Y2 is on screen}
   xor cx,cx { mov cx, dx }
   sub cx, bx
   add Y, cx
   sub YSize, cx
   mov al, es:[di] {Width}
   imul cx
   add si, ax
  @2:
   {Now Y dimension is clipped, SI points to offset start of image, YSize is
    how many lines to draw}
   mov al, es:[di]
   mov XSize, ax
   mov bx, X
   cmp bx, 0
   jl @XClip
   add bx, ax
   dec bx
   cmp bx, 319
   jg @XClip
{----------------------------------------------------------------------------}
   {This section has no SI add every line, XSize is simpy width of line}
   {Loops have register setup
    AX -> Row Size / SI displacement
    BX -> DI displacement
    CX -> REP
    DX -> Row counter
}
{----------------------------------------------------------------------------}
   mov ax, es
   mov es, vpage_seg
   mov bx, Y
   mov di, bx
   shl di, 8
   shl bx, 6
   add di, bx

   add di, X {ES:DI points to screen, DS:SI points to start of image}
   mov ds, ax
   mov ax, XSize
   mov bx, 320
   sub bx, ax
   {The following loops will be used.
    a00. REP MOVSD with DI add every line
    a01. MOVSB, REP MOVSD with DI add every line
    a10. MOVSW, REP MOVSD with DI add every line
    a11. MOVSB, MOVSW, REP MOVSD with DI add every line
    b00. REP MOVSD with DI and SI add every line
    b01. MOVSB, REP MOVSD with DI and SI add every line
    b10. MOVSW, REP MOVSD with DI and SI add every line
    b11. MOVSB, MOVSW, REP MOVSD with DI and SI add every line
   }
   mov dx, YSize
   shr ax, 1
   jc @Test2
   shr ax, 1
   jc @a10
   jmp @a00
  @Test2:
   shr ax, 1
   jc @a11
   @a00:
    mov cx, ax
    rep; DB $66; movsw
    add di, bx
    dec dx
    jnz @a00
    jmp @Done
   @a01:
     mov cx, ax
     movsb
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @a01
     jmp @Done
   @a10:
     mov cx, ax
     movsw
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @a10
     jmp @Done
   @a11:
     mov cx, ax
     movsb
     movsw
     rep; DB $66; movsw
     add di, bx
     dec dx
     jnz @a11
     jmp @Done
{----------------------------------------------------------------------------}
 @XClip:
   mov ax, 320
   sub ax, XSize {AX will keep track of DI displacement}
   xor cx, cx    {CX will keep track of SI displacement}
   mov dx, X
   cmp dx, 0
   jge @ClipRight
   xor bx,bx
   sub bx, dx     {BX = X bytes in left}
   add si, bx
   add X, bx
   add ax, bx
   add cx, bx
   sub XSize, bx
  @ClipRight:
   add dl, es:[di]
   dec dx {X2}
   cmp dx, 319
   jle @Start
   sub dx, 319    {DX = X bytes in right}
   sub XSize, dx
   add ax, dx
   add cx, dx
  @Start:
   mov dx, es
   mov es, vpage_Seg
   mov bx, Y
   mov di, bx
   shl bx, 8
   shl di, 6
   add di, bx

   add di, X {ES:DI points to screen, DS:SI points to start of image}
   mov ds, dx
   mov bx, cx
   mov dx, YSize
   {AX -> SI displacement
    BX -> DI displacement
    CX -> REP
    DX -> Line counter
   }
   shr XSize, 1
   jc @b?1
   shr XSize, 1
   jc @b10
   jmp @b00
  @b?1:
    shr XSize, 1
    jc @b11
    jmp @b01
   @b00:
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @b00
     jmp @Done
   @b01:
     movsb
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @b01
     jmp @Done

   @b10:
     movsw
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @b10
     jmp @Done

   @b11:
     movsb
     movsw
     mov cx, XSize
     rep; DB $66; movsw
     add di, ax
     add si, bx
     dec dx
     jnz @b11
 @Done:
   mov DS,tempDS
end;
{}
{
        Put a sprite on screen in one color, for when a enemy get's hit
        it can be "blinked" to white for a few frames...

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE SpriteBLINK; ASSEMBLER;
VAR TempREG       : word;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   add si,ax               { Inc(DataStart, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @ExitSprite
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,0
    jz @ExitSprite
    or cl,0
    jz @ExitSprite
    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @ExitSprite     { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @ExitSprite     { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }

{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,vpage_Seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }


@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   MOV AL,ColorWhite           { set the color to white }
   MOV [ES:DI],al              { Otherwise store byte }

@NoBlit:
   INC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }


   DEC CH
   JNZ @Outer

   POP BP
   POP DS

 @ExitSprite:
END;

{}
{
        Draw a shade-sprite, wich darkens or brightens the background

        Expects: X,Y position and a pointer to the SpriteData
        Returns: Nothing
}
PROCEDURE ShadeSprite(x,y:integer;data:pointer); ASSEMBLER;
VAR  x1,y1   : word;
     w,h     : word;
     w2      : word;
     tempSI  : word;
     tempDS  : word;
     tempDI  : word;
ASM
    les di,data         { get seg+ofs of the sprite }
    xor bh,bh
    xor ah,ah
    mov bl,es:[di]      { get width in AL }
    mov al,es:[di+1]    { and height in AH }
    dec ax              { decrease height }
    mov w2,bx           { put width in W2 }
    mov h,ax            { put height in H }
    dec bx              { decrease width }
    mov w,bx            { put width in W }

    mov ax,x
    sub ax,mapx
    mov x,ax
    add ax,w
    cmp ax,0
    jl @ExitIt
    cmp ax,319
    jg @ExitIt

    mov ax,y
    sub ax,mapy
    mov y,ax
    add ax,h
    cmp ax,0
    jl @ExitIt
    cmp ax,199
    jg @ExitIt

    xor ax,ax
    mov x1,ax           { set X1 to 0 }
    mov y1,ax           { set Y1 to 0 }

    mov ax,X            { get X in AX }
    cmp ax,0            { check on screen boundary }
    jnl @XisOk
      neg ax             { make it positive }
      mov x1,ax          { set it to X1 }
      xor ax,ax
      mov x,ax           { set X to 0 }
   @XIsOk:
    mov ax,y           { get Y in AX }
    cmp ax,0           { check on screen boundary }
    jnl @YisOk
      neg ax            { make it positive }
      mov y1,ax         { set it to Y1 }
      xor ax,ax
      mov y,ax          { set Y to 0 }
   @YisOk:

     mov ax,x           { get X }
     add ax,W           { add width }
     cmp ax,319         { check on screen_boundary }
     jle @WisOk         { it's on screen }
     mov cx,x           { get X }
     mov ax,319
     sub ax,cx          { subtract 319-X position }

     mov w,ax           { and store it into width }
    @WisOk:
     mov ax,y           { get Y }
     add ax,h           { add height }
     cmp ax,200         { check on screen_boundary }
     jle @HisOk
     mov cx,y           { it's on screen }
     mov ax,200
     sub ax,cx          { substract 200-Y position }
     mov h,ax           { and store it into height }
    @HisOk:

     mov si,offset colormap    { get offset of colormap }
     mov TEMPSI,SI             { store in local-word (faster I think)}

     mov es,vpage_Seg    { get screen_segment }
     mov ax,y
     mov di,ax           { set screen_offset }
     shl ax,8            { multiply with 256 }
     shl di,6            { and with 64 }
     add di,ax           { add to screen_offset }
     add di,x            { add X to screen offset }

     mov bx,y1

   @VertLoop:
     mov TEMPDI,DI
     mov cx,x1           { get data_X }

   @HorizonLoop:
     mov TEMPDS,DS       { remember DS }

     mov ax,bx           { get Y position }
     mov dx,w2           { get WIDTH }
     mul dx              { multiply Y with width }
     add ax,cx           { add X position }

     lds si,data         { get sprite_Data pointer }
     add si,2            { increase 2 (skipping width+height) }
     add si,ax           { add calculate position }
     mov dl,ds:[si]      { get value of DATA pixel }
     mov DS,TEMPDS       { get DS back }

     or dl,dl            { check on 0 for masking }
     je @MaskIt          { mask it, because it's 0 }

     xor ah,ah
     mov al,es:[di]      { get background_pixel }

     mov si,tempSI       { get offset of colormap }
     shl ax,5            { multiply with 32 (32-shades) }
     add si,ax           { add to offset }
     xor ah,ah
     dec dx              { decrease DATA color }
     add si,dx           { add to offset }
     mov al,ds:[si]      { get color value }

     mov es:[di],al      { store on screen }

     and LowDetail,1
     jz @MaskIt

     mov es:[di+1],al
     inc di
     inc cx

   @MaskIt:
     inc di              { increase screen_X position }
     inc cx              { increase DATA_X counter }
     cmp cx,w            { check on sprite_width }
     jng @HorizonLoop

     mov DI,TEMPDI       { get OLD DI back }
     add di,320          { add 320 for next line }

     inc bx              { increase Y counter }
     cmp bx,h            { check on sprite_height }
     jng @VertLoop       { no, so do next line }

   @ExitIt:
END;

{}
{
        This is the same as the SPRITEBLINK procedure, but this one
        mirrors the image in X direction.

        Expects: AX to be X position
                 BX to be Y position
                 and ES:[DI] pointing at image data
        Returns: Nothing
}
PROCEDURE XFlipSpriteBlink; ASSEMBLER;
VAR TempREG       : word;
    TempCH        : byte;
ASM
{-=-=-=-=-=-=-=-=- Do clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   cmp bx,199              { Y > 199 ? }
   jg @ExitSprite          { JG is for SIGNED integers. If Y pos is
                             > 199 then no blit }
   cmp ax,319              { X > 319 ? }
   jg @ExitSprite          { Yes, Do not do any blits at all }

   mov si,di
   add si,2                { Make SI point to actual sprite data }

   xor ch,ch
   mov cl,[es:di]          { CL holds Clipwidth }

   cmp ah,$80              { Quick test if X position is negative }
   jb @XNotNegative        { If not then check if image is off right hand
                             of screen }
   neg ax                  { Make X position positive }

   cmp ax,cx               { If Abs(X) >= Image Width Then Don't Draw }
   ja @ExitSprite

   sub cx,ax               { Dec(ClipWidth, Abs(X)) }
   xor ax,ax               { Set X to 0 }
   jmp @NowDoY             { Do Y portion of data now. }

 @XNotNegative:
   mov dx,cx               { Set DX to clipwidth }
   add dx,ax               { If X + ClipWidth < 320 Then }
   cmp dx,320
   jb @NowDoY              { Do Y part (No need to clip width) }
   mov cx,320
   sub dx,cx               { substract 320, to get clip-position in data }
   add si,dx
   sub cx,ax               { ClipWidth = 320 - X }

{  At this point:

      AX is the X position of the Shape
      BX is the Y position of the Shape
      CL is the clipped width of the Shape.

      Now it is time to do the height part and set the result in CH.
}

 @NowDoY:
   xor dh,dh               { Make DX the height of image }
   mov dl,[es:di+1]
   mov ch,dl               { Set CH also to height for main blit routine }

   cmp bh,$80              { Quick test if Y position is negative }
   jb @YNotNegative

   neg bx                  { Make Y a positive number }

   cmp bx,dx               { If Y > ClipHeight }
   ja @ExitSprite
   sub dx,bx               { Dec(ClipHeight, Abs(Y) ) }
   mov ch,dl               { As an image can only be 255 bytes high
                             this works fine.. }
   mov TEMPREG,AX          { Save X Coord on stack }
   xor ah,ah
   mov al,[es:di]          { AX = Width }
   mul bx                  { Calculate Y * Width }
   add si,ax               { Inc(DataStart, Abs(Y) * Width ) }
   mov AX,TEMPREG
   xor bx,bx               { Set Y to 0 }
   jmp @NowDoBlit          { NOW do the blit work. Whew! }

 @YNotNegative:
   add dx,bx               { If Y + ClipHeight > 199 Then }
   cmp dx,200
   jb @NowDoBlit
   mov dx,200
   sub dx,bx               { ClipHeight = 200 - Y }
   mov ch,dl

{
        At this point AX is the X position
                      BX is the Y position
                      CL is the ClipWidth and
                      CH is the ClipHeight.

        As the width/height of an Shape can only be an 8 bit
        quantity (i.e. < 256) I can discard the H portions of
        the registers. Whew!

        Now follows some weird code.. I'm going to make :

        DX = Modulo for datastart (which is the width in bytes of Shape.
        And yes, I do know that Width could be held in DL but adding extra
        code just to satisfy you optimisation junkies is v. boring.)

        DS:SI already points to data
        ES:DI points to active (source) Bitmap

}
  @NowDoBlit:
    or ch,0
    jz @ExitSprite
    or cl,0
    jz @ExitSprite
    mov TEMPREG,CX        { Save ClipWidth & ClipHeight on stack }

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @ExitSprite     { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @ExitSprite     { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
    mov CX,TEMPREG              { Restore ClipWidth and ClipHeight }

    xor dh,dh
    mov dl,[es:di]              { DX = Modulo }
    mov di,bx                   { Ahhh. Now DI points to the screen offset }

{-=-=-=-=-=-=-=-=- End clip calculations =-=-=-=-=-=-=-=-=-=-=-=-=-}

   PUSH DS
   PUSH BP

   MOV AX,vpage_seg
   MOV BX,ES
   MOV DS,BX                   { Now DS: SI points to correct space }
   MOV ES,AX

   MOV BX,SI                   { BX to be used to reload SI }
   MOV BP,DI                   { And the screen modulo }

   MOV AH,CL                   { AH = Width }
   xor al,al                   { set CH to 0 }
   xchg al,ah
   ADD BP,AX                   { add clipping width to DI }
   dec BP                      { minus one (trust me, this is needed) }
   xchg al,ah
   CLD                         { Make sure LODSB works OK }

@Outer:
   MOV CL,AH                   { Re-load CL }
   MOV SI,BX                   { And SI with address of next sprite row }
   MOV DI,BP                   { And DI with address of next scan line }

@WriteByte:
   LODSB                       { Read byte from DS:SI }
   OR AL,AL                    { Is byte 0 (transparent) ? }
   JZ @NoBlit                  { yes, so don't blit }
   mov al,ColorWhite
   MOV [ES:DI],AL              { Otherwise store byte }

@NoBlit:
   DEC DI                       { Move DI to next pos. on screen }
   DEC CL                       { Reduce shape width count }
   JNZ @WriteByte               { If not zero, end of shape not reached }

   ADD BX,DX                    { BX = BX + Modulo, so BX now points
                                  to first byte of next sprite line
                                  to blit }
   ADD BP,320                   { Make BP point to next line. Note :
                                  If you are going to add some extra
                                  stuff here make sure you're not
                                  accessing local variables! }

   DEC CH                       { Decrease Hight Counter }
   JNZ @Outer

   POP BP
   POP DS

 @ExitSprite:
END;
{}
{
        This will put a shape on screen in SCALED form, No clipping on
        screen edges!!!
        Scaling by Sean Palmer, assembler code by Scott Tunstall

        Expects: Pointer to data, and the corner-values of the
                 area it should be scaled in
        Returns: Nothing

}
PROCEDURE SCALESHAPE(var DataPtr; x1:word;y1:byte;x2:word;y2:byte); ASSEMBLER;
TYPE  fixed = record
          case boolean of
               true  : (w : longint);
               false : (f, i : word);
          end;

VAR  x,y        : word;  { Makes those muls easier }
     s, w, h    : word;
     sx, sy, cy : fixed;

ASM
     MOV SI, WORD PTR DataPtr
     MOV ES, WORD PTR DataPtr+2

     XOR AH,AH                  { Get shape width into X }
     MOV AL,[ES:SI]
     MOV x,AX
     INC SI

     MOV AL,[ES:SI]             { Get shape height into Y }
     MOV y,AX
     INC SI

     MOV AX,x1
     XOR BH,BH
     MOV BL,y1

{=-=-=-=-=-=-=-=-=-=-=-= Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
     cmp ax,319         { Is X> 319 ? }
     ja @ExitSprite     { Yes }
     cmp bx,199         { Is Y> 199 ?. Do not use BL instead as this is
                          when problems will occur.}
     ja @ExitSprite     { Yes }

     xor ch,ch                  { CX = Y }
     mov cl,bl
     shl cx,6                   { Y * 64 }
     mov bh,bl                  { BX = Y * 256 }
     xor bl,bl
     add bx,cx                  { BX = BX + CX, which gives Y * 320 }
     add bx,ax                  { Add the X position to offset in BX }

{=-=-=-=-=-=-=-=-=-=-=-= End Calculate Offset =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}

     MOV DI,BX

     MOV BX,x2
     XCHG AX,BX                 { AX = X2, BX = X1 }
     SUB AX,BX
     INC AX
     MOV CX,AX
     MOV w,AX

     MOV AX,320                 { s = 320 - w }
     SUB AX,CX
     MOV s,AX

     XOR DX,DX                  { Make DX:AX = 65536 }
     INC DL
     XOR AX,AX
     DIV CX                     { 65536 / w }

     MUL x                      { * x }
     MOV WORD [sx.w],AX
     MOV WORD [sx.w+2],DX


     XOR AH,AH                  { Calc (y2 - y1) + 1 }
     MOV AL,y2
     SUB AL,y1
     INC AL
     MOV h,AX                   { h = result }
     MOV BX,AX

     XOR DX,DX                  { Make DX:AX = 65536 }
     INC DL
     XOR AX,AX
     DIV BX                     { 65536 / h }
     MUL y                      { * y }
     MOV WORD [sy.w],AX
     MOV WORD [sy.w+2],DX

     DB $66; XOR AX,AX
     DB $66; MOV WORD PTR cy.w, AX



     PUSH DS

     MOV AX,ES
     MOV ES,Vpage_Seg
     MOV DS,AX




{
At this point

   CX    = width
   DX    = height
   DS:SI = points to top left of shape
   ES:DI = points to ADDress on screen where scaled shape
           will be placed
}


    cld


@L2:

    MOV AX,SI                   { I THINK this is faster than a push }
    DB $66; SHL SI,16           { I mean, there are no memory accesses }
    MOV SI,AX                   { right ? Nor any stack pointer updates }


    MOV  AX, cy.i
    MUL  X                      { It would have been nice if intel
                                  created a 16 bit MUL which didn't
                                  f**k up DX }
    ADD  SI,AX


    MOV  AX,CX                  { Get width }
    DB $66; shl CX,16           { Put it in MSW of EAX }
    MOV  CX, AX

    XOR  BX, BX
    MOV  DX, sx.f

@L:
    MOV AL,[SI]
    cmp al,0
    je @NoBlit
    mov es:[di],al
 @NoBlit:
    inc di

    ADD  BX, DX
    ADC  SI, sx.i               { if carry or sx.i<>0,
				  new source pixel }

    DEC CX
    JNZ @L

    DB $66; SHR SI,16           { Restore SI }
    DB $66; SHR CX,16           { And CX }

    ADD  DI, s                  { skip to next screen row}
    DB $66; MOV  AX, sy.f       { MOV EAX, sy.f }
    DB $66; ADD  cy.f, AX       { ADD DWORD PTR cy.f, EAX }

    DEC  WORD PTR h
    JNZ  @L2
    POP  DS
  @ExitSprite:
END;
{}
{
        Load in a palette from a DFPLIB file, or just from DOS

        Expects: LIB      - TRUE if you use a library file
                 name     - name of the palette- file
        Returns: TRUE if file succesfully loaded.

}
FUNCTION Loadpal(lib:boolean;name:string):boolean;
VAR i,code : byte;
    r,g,b  : byte;
BEGIN
 LOADON;
 LoadPal:=false;            { not yet loaded }

 if lib then begin              { use a lib file? }
    code:=LIB_RESET(name);      { yes, so reset it }

    if code<>0 then begin
       LOADOFF;
       exit;       { if code<>0 something went wrong }
    end;

 end else begin
    assign(lib_file,name);      { use dos file }
    {$I-}
       reset(lib_file,1);       { reset the file }
    {$I+}
    if ioresult<>0 then begin
       LOADOFF;
       exit;
    end;
 end;
 FOR i:=0 to 255 do begin
     blockread(lib_file,r,sizeof(r)); if r>63 then r:=r shr 2;
     blockread(lib_file,g,sizeof(g)); if g>63 then g:=g shr 2;
     blockread(lib_file,b,sizeof(b)); if b>63 then b:=b shr 2;
     pal[i].redlevel:=r;
     pal[i].greenlevel:=g;
     pal[i].bluelevel:=b;
 end;
 close(lib_file);
 loadpal:=true;
 LOADOFF;
END;

FUNCTION ClosestColor(R, G, B : Byte) : Byte;
var A : Byte;
    Best : Byte;
    BestDev : Integer;
    I : Integer;
    r2,g2,b2 : byte;
begin
  Best := 0;
  BestDev := MaxInt;
  For A := 0 to 255 do begin
      port[$03c7]:=a;
      r2:=port[$03c9];
      g2:=port[$03c9];
      b2:=port[$03c9];
    I := Abs(R - r2) + Abs(G - g2) + Abs(B - b2);
    if I < BestDev then begin
      Best := A;
      BestDev := I;
    end;
    if BestDev = 0 then Break;
  end;
  ClosestColor := Best;
end;

{}
{
        Set Palette

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE SetPal; ASSEMBLER;
ASM
  xor ch,ch
  mov si,offset pal

  mov cl,0
 @ColorLoop:
  mov dx,$03c8
  mov al,cl
  out dx,al
  inc dx

  lodsb;  out dx,al
  lodsb;  out dx,al
  lodsb;  out dx,al

  inc cl
  jnz @ColorLoop
END;
{}
{
        Black Palette

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE BlackPal; ASSEMBLER;
ASM
  xor ch,ch

  mov cl,255
 @ColorLoop:
  mov dx,$03c8
  mov al,cl
  out dx,al
  inc dx
  xor al,al

  out dx,al
  out dx,al
  out dx,al

  Loop @ColorLoop
END;


{}
{
        Go into black&white mode

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE GreyPal(col1,col2:Byte);
VAR   i ,r,g,b : byte;
      total    : byte;
BEGIN
 for i:=col1 to col2 do begin
     port[$03c7]:=i;
     r:=port[$03c9];
     g:=port[$03c9];
     b:=port[$03c9];
     total:=round( (r*0.3)+ (g*0.59)+ (b*0.11) );
     port[$03c8]:=i;
     port[$03c9]:=total;
     port[$03c9]:=total;
     port[$03c9]:=total;
 end;
END;
{}
{
        Create a Fade out

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE FadeOut(col1,col2:byte);
VAR j,i,r,g,b : byte;
BEGIN
 for j:=0 to 63 do begin
    for i:=col1 to col2 do begin
      port[$03c7]:=i;
      r:=port[$03c9];
      g:=port[$03c9];
      b:=port[$03c9];
      if r>1 then dec(r,2) else r:=0;
      if g>1 then dec(g,2) else g:=0;
      if b>1 then dec(B,2) else b:=0;
      port[$03c8]:=i;
      port[$03c9]:=r;
      port[$03c9]:=g;
      port[$03c9]:=b;
    end;
    Retrace;
  end;
END;
{}
{
        Create a Fade in

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE FadeIn(col1,col2:byte);
VAR j,i,r,g,b : byte;
BEGIN
 for j:=0 to 63 do begin
    for i:=col1 to col2 do begin
      port[$03c7]:=i;
      r:=port[$03c9];
      g:=port[$03c9];
      b:=port[$03c9];
      if r<pal[i].redlevel-1 then inc(r,2) else r:=pal[i].redlevel;
      if g<pal[i].greenlevel-1 then inc(g,2) else g:=pal[i].greenlevel;
      if b<pal[i].bluelevel-1 then inc(B,2) else b:=pal[i].bluelevel;
      port[$03c8]:=i;
      port[$03c9]:=r;
      port[$03c9]:=g;
      port[$03c9]:=b;
    end;
    retrace;
 end;
END;
{}
{
        Create a Fade in to grey (using the loaded color-palette)

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE FadetoGrey(col1,col2:Byte);
VAR j,i,r,g,b : byte;
    total     : byte;
BEGIN
 for j:=0 to 63 do begin
    for i:=col1 to col2 do begin
      r:=pal[i].redlevel;
      g:=pal[i].greenlevel;
      b:=pal[i].bluelevel;
      total:=round( (r*0.3)+ (g*0.59)+ (b*0.11) );

      port[$03c7]:=i;
      r:=port[$03c9];
      g:=port[$03c9];
      b:=port[$03c9];
      if r<total-1 then inc(r,2) else
         if r>total+1 then dec(r,2) else
            r:=total;
      if g<total-1 then inc(g,2) else
         if g>total+1 then dec(g,2) else
            g:=total;
      if b<total-1 then inc(B,2) else
         if b>total+1 then dec(b,2) else
            b:=total;
     port[$03c8]:=i;
     port[$03c9]:=r;
     port[$03c9]:=g;
     port[$03c9]:=b;
    end;
    retrace;
 end;
END;
{}
{
        Get a XAS file....

        Expects: LIB      - true if dfplib file used.
                 filename - name of XAS file
                 storing  - array of sprites in wich the XAS will be stored

        Returns: The amount of shapes that where loaded, if a 0 is returned
                 there was probably something wrong with the file, or the
                 file was not found.
}
FUNCTION GetXAS(lib:boolean; filename:string; var storing:array of spritetyp):Byte;
VAR TID     : string [6];
    k       : integer;
    l       : integer;
    msize   : word;
    dtx,dty : word;
    x,y     : word;
    ent     : word;
    cycle   : boolean;
    datamem : longint;
    SubBar  : tProgressBar;
BEGIN
  LOADON;
  Halt_Proc:='GetXAS';

  GetXAS:=0;
  if lib then begin
     k:=LIB_RESET(filename);        {Open the LIB_File}
     if k<>0 then begin
        Halt_Error:='unable to spawn resource ('+filename+')';
        LOADOFF;
        exit;
     end;
  end else begin
     assign(lib_file,filename);
     {$I-}
        reset(lib_file,1);
     {$I+}
     if ioresult<>0 then begin
        GetXAS:=0;
        Halt_Error:='unable to spawn file ('+filename+')';
        LOADOFF;
        exit;
     end;
  end;
   blockread(lib_file,tid[1],5);
   tid[0]:=#5;
   if tid<>'XASv4' then begin
      halt_Error:='Not a valid XAS file ('+filename+')';
      close(lib_file);
      LOADOFF;
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   blockread(lib_file,datamem,sizeof(datamem)); { only used with XMS version }

   _InitProgressBar(120,193,200,199,blue,ent+1,'LOADING IMAGES',SubBar);

   UpdateProgressBar(SubBar);

   k:=low(storing);
   if k<>0 then begin
      halt_error:='SpriteArray base must be 0';
      close(lib_file);
      LOADOFF;
      exit;
   end;
   l:=1;

   repeat
    if storing[k].data<>NIL then begin   { dispose old first }
       dtx:=mem[seg(storing[k].data^):ofs(storing[k].data^)];
       dty:=mem[seg(storing[k].data^):ofs(storing[k].data^)+1];
       msize:=(dtx*dty)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
          freemem(storing[k].data,msize);
    end;
    storing[k].bitflags:=0;

    blockread(lib_file,dtx,2);
    blockread(lib_file,dty,2);
    blockread(lib_file,storing[k].a_frame,1); {sizeof(storing[k].a_frame));}
    blockread(lib_file,storing[k].s_frame,1);
    blockread(lib_file,cycle,1);
    if cycle then
       storing[k].BitFlags:=storing[k].BitFlags or 1;

    storing[k].c_Frame:=k;
    storing[k].t_Frame:=storing[k].s_frame;

    msize:=(dtx*dty)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
        GetMem(storing[k].data,msize);

    mem[seg(storing[k].data^):ofs(storing[k].data^)]:=byte(dtx);
    mem[seg(storing[k].data^):ofs(storing[k].data^)+1]:=byte(dty);

    blockread(lib_file,mem[seg(storing[k].data^):ofs(storing[k].data^)+2],dtx*dty);

    { check to see if we can skip the masking }
    with storing[k] do begin
      y:=0;
      cycle:=false;
      repeat
        x:=0;
        repeat
          if mem[seg(data^):ofs(Data^)+2+(y*dtx)+x]=0 then begin
             Cycle:=true;
          end;
          inc(x);
        until (x=dtx) or (cycle);
        inc(y);
      until (y=dty) or (cycle);
    end;
    if not Cycle then
       storing[k].BitFlags:=storing[k].BitFlags or 2;
    inc(k);
    inc(l);
    UpdateProgressBar(SubBar);
   until l>ent;
   close(lib_file);
   LOADOFF;
   GetXas:=ent;
   if (seg(storing)=seg(tiles)) and (ofs(storing)=ofs(tiles)) then begin
      TilesInFile:=ent;
      cycle:=false;
      for k:=low(storing) to ent do
          if storing[k].a_frame>1 then cycle:=true;
      animated:=cycle;
   end;

   RemoveProgressBar(SubBar);
END;
{}
{
        Get an image file....

        Expects: LIB      - true if dfplib file used.
                 filename - name of XAS file
                 storing  - array of images in wich the XAS will be stored

        Returns: The amount of shapes that where loaded, if a 0 is returned
                 there was probably something wrong with the file, or the
                 file was not found.
}
FUNCTION GetImages(lib:boolean; filename:string; var storing:array of imagetyp):Byte;
VAR TID     : string [6];
    k       : integer;
    l       : integer;
    frame   : byte;
    msize   : word;
    dtx,dty : word;
    x,y     : word;
    ent     : word;
    cycle   : boolean;
    datamem : longint;
BEGIN
  LOADON;
  Halt_Proc:='GetImages';

  GetImages:=0;
  if lib then begin
     k:=LIB_RESET(filename);        {Open the LIB_File}
     if k<>0 then begin
        LOADOFF;
        exit;
     end;
  end else begin
     assign(lib_file,filename);
     {$I-}
        reset(lib_file,1);
     {$I+}
     if ioresult<>0 then begin
        GetImages:=0;
        LOADOFF;
        exit;
     end;
  end;
   blockread(lib_file,tid[1],5);
   tid[0]:=#5;
   if tid<>'XASv4' then begin
      halt_error:='Not a valid XAS file ('+filename+')';
      close(lib_file);
      LOADOFF;
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   blockread(lib_file,datamem,sizeof(datamem)); {only needed with XMS version}

   k:=low(storing);
   if k<>0 then begin
      halt_error:='SpriteArray base must be 0';
      close(lib_file);
      LOADOFF;
      exit;
   end;

   l:=1;
   repeat
    if storing[k].data<>NIL then begin   { dispose old first }
       dtx:=mem[seg(storing[k].data^):ofs(storing[k].data^)];
       dty:=mem[seg(storing[k].data^):ofs(storing[k].data^)+1];
       msize:=(dtx*dty)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
          freemem(storing[k].data,msize);
    end;
    storing[k].bitflags:=0;

    blockread(lib_file,dtx,2);
    blockread(lib_file,dty,2);
    blockread(lib_file,frame,1);
    blockread(lib_file,frame,1);
    blockread(lib_file,cycle,1);
    if cycle then
       storing[k].BitFlags:=storing[k].BitFlags or 1;

    msize:=(dtx*dty)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
        GetMem(storing[k].data,msize);

    mem[seg(storing[k].data^):ofs(storing[k].data^)]:=byte(dtx);
    mem[seg(storing[k].data^):ofs(storing[k].data^)+1]:=byte(dty);

    blockread(lib_file,mem[seg(storing[k].data^):ofs(storing[k].data^)+2],dtx*dty);

    { check to see if we can skip the masking }
    with storing[k] do begin
      y:=0;
      cycle:=false;
      repeat
        x:=0;
        repeat
          if mem[seg(data^):ofs(Data^)+2+(y*dtx)+x]=0 then begin
             Cycle:=true;
          end;
          inc(x);
        until (x=dtx) or (cycle);
        inc(y);
      until (y=dty) or (cycle);
    end;
    if not Cycle then
       storing[k].BitFlags:=storing[k].BitFlags or 2;
    inc(k);
    inc(l);
   until l>ent;
   close(lib_file);
   GetImages:=ent;
   LOADOFF;
END;
{}
{
        Load the LOADINGICON image

        Expects: LIB      - true if dfplib file used.
                 filename - name of XAS file

        Returns: TRUE if image loaded
}
FUNCTION LOADICON(lib:boolean; filename:string):boolean;
VAR TID     : string [6];
    k       : integer;
    frame   : byte;
    msize   : word;
    dtx,dty : word;
    x,y     : word;
    ent     : word;
    cycle   : boolean;
    datamem : longint;
BEGIN
  LOADICON:=False;
  Halt_Proc:='LOADICON';

  if DEBUG then begin
     writeln(debugfile,'LOADING ICON');
  end;

  if lib then begin
     k:=LIB_RESET(filename);        {Open the LIB_File}
     if k<>0 then exit;
  end else begin
     assign(lib_file,filename);
     {$I-}
        reset(lib_file,1);
     {$I+}
     if ioresult<>0 then exit;
  end;
   blockread(lib_file,tid[1],5);
   tid[0]:=#5;
   if tid<>'XASv4' then begin
      halt_error:='Not a valid XAS file ('+filename+')';
      close(lib_file);
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   blockread(lib_file,datamem,sizeof(datamem)); {only needed with XMS version}

    if LoadImages.data<>NIL then begin   { dispose old first }
       dtx:=mem[seg(LoadImages.data^):ofs(LoadImages.data^)];
       dty:=mem[seg(LoadImages.data^):ofs(LoadImages.data^)+1];
       msize:=(dtx*dty)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
          freemem(LoadImages.data,msize);
    end;

    blockread(lib_file,dtx,2);
    blockread(lib_file,dty,2);
    blockread(lib_file,frame,1);
    blockread(lib_file,frame,1);
    blockread(lib_file,cycle,1);

    msize:=(dtx*dty)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
        GetMem(LoadImages.data,msize);
        GetMem(LoadOLD,msize);

    mem[seg(LoadImages.data^):ofs(LoadImages.data^)]:=byte(dtx);
    mem[seg(LoadImages.data^):ofs(LoadImages.data^)+1]:=byte(dty);

    blockread(lib_file,mem[seg(LoadImages.data^):ofs(LoadImages.data^)+2],dtx*dty);


   close(lib_file);
   LOADICON:=True;

  if DEBUG then begin
     writeln(debugfile,'ICON LOADED');
  end;

END;

{}
{
        Get a single LAYER image

        Expects: LIB      - true if dfplib file used.
                 filename - name of XAS file
                 image    - the image-number to get from the XAS file
                 storing  - Pointer for image to be put at
        Returns: TRUE if succesfull
}
FUNCTION LoadLayerImage(lib:boolean; filename:string; image:byte):boolean;
VAR TID     : string [6];
    k       : integer;
    l       : integer;
    msize   : word;
    dtx,dty : word;
    x,y     : word;
    ent     : word;
    cycle   : boolean;
    X_Info  : byte;
    datamem : longint;
BEGIN
  LOADON;
  Halt_Proc:='LoadLayerImage';

  LoadLayerImage:=false;
  if lib then begin
     k:=LIB_RESET(filename);        {Open the LIB_File}
     if k<>0 then begin
        halt_error:='Resource not found ('+filename+')';
        LOADOFF;
        exit;
     end;
  end else begin
     assign(lib_file,filename);
     {$I-}
       reset(lib_file,1);
     {$I+}
     if ioresult<>0 then begin
        LoadLAyerImage:=false;
        halt_Error:='File not found ('+filename+')';
        LOADOFF;
        exit;
     end;
  end;
   blockread(lib_file,tid[1],5);
   tid[0]:=#5;
   if tid<>'XASv4' then begin
      close(lib_file);
      LOADOFF;
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   blockread(lib_file,datamem,sizeof(Datamem));
   if ent<Image then begin
      close(lib_file);
      LOADOFF;
      exit;
   end;

   l:=1;
   k:=low(layertile);
   if k<>0 then begin
      halt_error:='SpriteArray base must be 0';
      close(lib_file);
      LOADOFF;
      exit;
   end;

   repeat
    if layertile[k]<>NIL then begin   { dispose old first }
       dtx:=mem[seg(layertile[k]^):ofs(layertile[k]^)];
       dty:=mem[seg(layertile[k]^):ofs(layertile[k]^)+1];
       msize:=(dtx*dty)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
          freemem(layertile[k],msize);
    end;
    blockread(lib_file,dtx,2);
    blockread(lib_file,dty,2);
    blockread(lib_file,X_Info,1);
    blockread(lib_file,X_Info,1);
    blockread(lib_file,X_Info,1);

    msize:=(dtx*dty)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
      GetMem(layertile[k],msize);

    mem[seg(layertile[k]^):ofs(layertile[k]^)]:=byte(dtx);
    mem[seg(layertile[k]^):ofs(layertile[k]^)+1]:=byte(dty);

    blockread(lib_file,mem[seg(layertile[k]^):ofs(layertile[k]^)+2],dtx*dty);

    inc(k);
    inc(l);
    if k=image+1 then LayerNR:=k;
   until (l>ent) or (k>5);
   close(lib_file);
   LoadLayerImage:=true;
   LayerNR:=IMAGE;
   LOADOFF;
END;
{}
{
        Read in a charset file.

        Expects: LIB=TRUE if using library file, and the Filename of charset.
                 and number of charset to load ing
        Returns: Nothing
}
FUNCTION LoadCharset(lib:boolean;filename:string;charsetNR:byte):boolean;
VAR TID  : string [4];
    k,l    : integer;
    ent    : word;
    msize : word;
    charwidth : byte;
    charheight : byte;
BEGIN
  LOADON;
  Halt_Proc:='LoadCharset';
  CharWidth:=CharsetWidth[charsetNR];
  CharHeight:=CharsetHeight[charsetNR];
  LoadCharset:=false;
  if lib then begin
     k:=lib_Reset(filename);
     if k<>0 then begin
        LOADOFF;
        exit;
     end;
  end else begin
      assign(lib_file,filename);
      {$I-}
         reset(lib_file,1);
      {$I+}
      if ioresult<>0 then begin
         LoadCharset:=false;
         halt_error:='unable to open file '+filename;
         LOADOFF;
         exit;
      end;
  end;
   blockread(lib_file,tid[1],3);
   tid[0]:=#3;
   if tid<>'CHR' then begin
      close(lib_file);
      halt_error:='unable to open file '+filename+', non valid';
      LOADOFF;
      exit;
   end;
   blockread(lib_file,ent,sizeof(ent));
   k:=32;
   l:=1;
   repeat
    msize:=(charwidth*charheight);
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
      GetMem(charset[charsetNR,k],msize);

    blockread(lib_file,mem[seg(charset[charsetNR,k]^):ofs(charset[charSetNR,k]^)],charwidth*charheight);

    inc(k);
    inc(l);
   until l>ent;
   close(lib_file);
   LoadCharset:=true;
   CharsetLoaded:=true;
   LOADOFF;
END;
{}
{
        Set the page-segment to draw the text on

        Expects: segment of page to draw one (vpage_Seg or sega000)
        Returns: Nothing
}
PROCEDURE SetTEXTSegment(newseg:word);
BEGIN
 TextSeg:=newseg;
END;
{}
{
        Write text on screen using the graphics charset

        Expects: X+Y position on screen, and the text
        Returns: Nothing

        NOTE: No clipping is performed on the screen edges!!!
}
PROCEDURE WText(Xpos,Ypos:Word;text:String;CharsetNR:Byte);
VAR i      : word;
    nx     : word;
    dataptr : pointer;
    tempDS  : word;
    Charwidth  : byte;
    CharHeight : byte;
BEGIN
 if not CharsetLoaded then exit;
 Charwidth:=CharsetWidth[CharsetNr];
 CharHeight:=CharsetHeight[CharsetNr];
 nx:=xpos;                                      { start value of X }
 for i:=1 to length(Text) do                    { go thru every character }
     if ord(text[i])<>0 then begin
     Dataptr:=charset[charSetNR,ord(text[i])];     { get pointer to char-data }
     ASM
      xor bx,bx         { Y counter per character }
      xor ch,ch

     @Vloop:
      mov es,textseg    { segment of screen }
      mov ax,bx         { get current Y value }
      add ax,ypos       { add Y start value }
      mov di,ax         { get Y value in CX }
      shl di,6          { multiply with 64... }
      shl ax,8          { ...and with 128 }
      add ax,nx         { add drawing start X position }
      add di,ax         { and move calculate offset to DI }

      mov TEMPDS,DS     { remember DS! }

      mov cl,charwidth

      LDS si,dataptr    { get memory location of the data }
      mov ax,bx         { get current Y value }
      mul cx            { multiply with width of charset }
      add si,ax         { add the calculated offset to the offset of the data }

     @HLoop:
      lodsb             { get byte }
      cmp al,0          { see if AL is 0 }
      je @NoSet         { yes, so don't draw it }
      mov es:[di],al    { else draw it }
     @NoSet:
      inc di
      loop @Hloop       { loop until CX =0 }

      mov DS,TEMPDS     { get DS back }

      inc bl            { increase the Y scanline }
      cmp bl,CharHeight { are we at the bottom of the character? }
      jl @Vloop         { no, so draw next line }
      mov bl,CharWidth
      add nx,bx         { next X position on screen for the new character }
    end;
 end else inc(nx,CharWidth);    { go to next character position }
END;
{}
{
        Rough check if 2 shapes are colliding. This works faster as a
        pixel by pixel check for a collision, and as long as the shapes don't
        have to much "space" on the edges the collision will be allmost
        perfect.

        Expects: X+Y position and the WIDTH + HEIGHT of the first sprite,
                 X+Y position and the WIDTH + HEIGHT of the second sprite.

        Returns: True if collision has been detected.

}

FUNCTION collision(x1,y1,w1,h1, x2,y2,w2,h2 :integer):boolean;
VAR xd,yd : boolean;
BEGIN
 ASM
  mov xd,false
  mov yd,false
 END;

 if ((x1 <=x2) and (x1+w1>=x2)) then xd:=true else
    if ((x1 <=x2+w2) and (x1+w1>=x2+w2)) then xd:=true else
       if ((x1 >=x2) and (x1+w1<=x2+w2)) then xd:=true;
 if ((y1 <=y2) and (y1+h1>=y2)) then yd:=true else
    if ((y1 <=y2+h2) and (y1+h1>=y2+h2)) then  yd:=true else
       if ((y1 >=y2) and (y1+h1<=y2+h2)) then yd:=true;
 collision:=xd and yd;
END;
{}
{

        Add a FX type to a linked list

        Expects: X and Y position + spriteSET number
        Returns: True if succesfull

}
FUNCTION AddFX(  Xpos2,Ypos2  :  integer;
                  F_Frame2     :  byte;
                  LSprite2     : boolean):boolean;
VAR  Temp_FX  : PFX;
     i        : word;
     add      : word;
     firstF   : byte;
     done     : boolean;
BEGIN
 Halt_Proc:='AddFX';
 AddFX:=true;

 if memavail<sizeof(temp_fx^) then exit;
 new(Temp_FX);
 if Temp_FX=NIL then begin
    Halt_Error:='Out of memory';
    AddFX:=false;
    exit;
 end;

 if FirstFX=NIL  then begin
    LastFX:=Temp_FX;
    FirstFX:=Temp_FX;
    with FirstFX^ do begin
         next:=NIL;
         prev:=Nil;
    end;
 end else begin
     LastFX^.next:=temp_FX;
     Temp_FX^.prev:=LastFX;
     LastFX:=Temp_FX;
     Temp_FX^.next:=NIL;
 end;


 With TEMP_FX^ do begin
  xpos:=xpos2;
  ypos:=ypos2;
  i:=1;
  add:=0;
  while i<>f_frame2 do begin
        done:=false;
        firstF:=add;
        while not done do begin
          if (FXS[add].a_Frame<>0) and (FXS[add].a_Frame<>firstF) and (FXS[add].a_frame<>add) then inc(add)
             else begin
                  done:=true;
                  inc(Add);
             end;
        end;
        inc(i);
  end;
  if add<>0 then inc(add);
  f_Frame:=add;
  c_frame:=f_frame;
  a_frame:=FXS[f_Frame].a_frame;
  s_frame:=FXS[f_Frame].s_frame;
  t_frame:=s_frame;
  bitflag:=FXS[f_Frame].bitflags;
  LSprite:=Lsprite2;
 end;
END;
{}
{

        Erase a FX object from the linked-list

        Expects: pointer to FX object  that needs to be ERASED!

        Returns: True if succesfull

}
FUNCTION EraseFX(Temp_FX:PFX):boolean;
VAR  next_fx,
     prev_fx  : PFX;
     i        : integer;
     msize    : word;
BEGIN
  Halt_Proc:='EraseFX';
  eraseFX:=true;
  if Temp_FX=NIL then exit;

  prev_fx:=Temp_fx^.prev;
  next_fx:=Temp_fx^.next;

  if prev_fx=NIL then begin
     FirstFX:=next_fx;
  end else Prev_fx^.next:=next_fx;

  if next_fx=NIL then begin
     LastFX:=prev_fx;
  end else Next_fx^.prev:=prev_fx;

  dispose(Temp_FX);
END;
{}
{
        Handle the FX- linked list

        Expects: Nothing

        Returns: Nothing

}
PROCEDURE DoFX;
VAR temp_fx : PFx;
    next_FX : PFx;
    done    : boolean;
    dataptr : pointer;
    x,y     : integer;
BEGIN
 Halt_Proc:='DoFX';
 temp_fx:=FirstFX;
 while temp_fx<>NIL do begin
       with temp_fx^ do begin
            done:=false;
            next_FX:=temp_fx^.next;
            if t_frame>0 then dec(t_frame) else begin
               t_Frame:=s_frame;
               c_frame:=FXS[c_Frame].a_Frame;
               if (c_Frame=f_Frame) or (FXS[c_Frame].a_Frame=c_frame) then begin
                  if not eraseFX(temp_fx) then begin
                     halt_error:='Couldn''t dispose FX_object.';
                     halt(1);
                  end;
                  done:=true;
               end;
            end;
            if not done then begin
               {$IFDEF DEBUGGING}
                 inc(maxSprites);
               {$ENDIF}
               if not Lsprite then begin
                  x:=xpos-mapx; y:=ypos-mapy;
                  dataptr:=fxs[c_frame].data;
                  asm
                    mov ax,x
                    mov bx,y
                    les di,dataptr
                    call Sprite
                  end;
               end else begin
                   ShadeSprite(xpos,ypos,fxs[c_Frame].data);
               end;
            end;
       end;
       temp_fx:=next_fx;
 end;
END;

{----------------- Stuff specific to snowfall --------------------}
PROCEDURE Perturb;assembler;  {Peturbation algorhythm (C) 1982 BarathSoft}
ASM
  Mov dx,r
  Xor dx,0aa55h
  SHL dx,1
  Adc dx,$118
  Mov r,dx
END;
{}
{
      Initialise the Snow

      Expects: Nothing
      Returns: Nothing
}
Procedure Init_Snow;
BEGIN
  for CurFlake:=0 to Flakes do
    With Flake[curflake] do begin
       Perturb; Inc(s,r);
       Snowy:=Hi(Hi(r)*fastest)+5;
       Snowx:=Hi(Lo(r)*y)+1;                {limit x movement}
       P:=S;
    end;
END;
{}
{
      Update the snow for new frame

      Expects: Speed of snow falling, and orientation (left=1,right=1)
      Returns: Nothing

      Author : Slotman
}
PROCEDURE SNow(Snow_Speed,Orient:integer);
VAR temp:integer;
BEGIN
    if (Orient<-1) or (Orient>1) then exit;
    Perturb;
    for CurFlake:= 1 to flakes do
      with flake[curflake] do begin
        If Snowx>=lo(r) then p:=p+Orient;
        Temp:=Snow_Speed;
        repeat
          If (Snowy>=Hi(r)) or (Snowy<lo(r)) then Inc(p,320);
          dec(Temp);
        Until Temp<1;
        if p>=(319*199) then p:=p-(319*199);
        {Draw the Snow}
        Mem[vpage_Seg:p]:=colorwhite;
    end;
END;
{}
{
        Load a PCX file

        Expects    : use a LIB file, and the Filename of PCX
        Returns    : True if succesfull in loading

}
FUNCTION LoadPCX(lib:Boolean; filename:String):boolean;
TYPE PCX_Header = record
       manu     : byte;
       version  : byte;
       encoding : byte;
       b_p_pix  : byte;
       xmin     : word;
       ymin     : word;
       xmax     : word;
       ymax     : word;
       hres     : word;
       vres     : word;
       colormap : array[1..48] of byte;
       reserve  : byte;
       nplanes  : byte;
       bpline   : word;
       palinfo  : word;
       filler   : array[1..58] of byte;
    end;

VAR  i,r,g,b     : byte;
     Xsize,Ysize : word;            { Size of image }
     Xscrn,Yscrn : word;            { Screen positions }
     plotdata    : byte;            { Byte-Color-Pixel to plot }
     readbyte    : byte;            { Byte to read from file }
     count       : integer;         { Count of continuous bytes }
     Header      : PCX_Header;
     code        : integer;
     error       : boolean;
     bytesleft   : longint;
     sizeread    : longint;
     bytesmem    : longint;
     mempos      : longint;

      PROCEDURE REadNewBlock;
      BEGIN
        if bytesleft<63000 then sizeread:=bytesleft else sizeread:=63000;
        blockread(lib_file,mem[vpage_seg:vpage_ofs],sizeread);
        dec(bytesleft,sizeread);
        bytesmem:=sizeread;
        mempos:=0;
      END;

      PROCEDURE GetByte(Var return:byte);
      BEGIN
        if mempos>=bytesmem then ReadNewBlock;
        return:=mem[vpage_seg:vpage_ofs+mempos];
        inc(mempos);
      END;

BEGIN
  Halt_Proc:='LoadPCX';
  LOADON;

  LoadPCX:=true;                                     { all's well }
  error:=false;                                      { no error's (yet) }

  if lib then begin
     code:=lib_reset(filename);
     if code<>0 then begin
        halt_Error:='Resource not found ('+filename+')';
        LoadPCX:=false;
        LOADOFF;
        exit;
     end;
     bytesleft:=(key_size)-897;
  end else begin
     assign(lib_file,filename);
       {$I-}
            reset(lib_file,1);    { open file }
       {$I+}
       bytesleft:=filesize(lib_file)-897;
       if ioresult<>0 then begin
          halt_Error:='File not found ('+filename+')';
          LoadPCX:=false;
          LOADOFF;
          exit;
       end;
  end;
  blockread(lib_file,header,sizeof(header));      { Read header first}
 {

    Check for correct PCX format

 }
 if header.encoding<>1 then error:=true;        { different encoding used }
 if header.b_p_pix<>8 then error:=true;         { to many bits per pixel }
 if header.nplanes<>1 then error:=true;         { to many color planes }
 if error then begin
    close(lib_file);         { Close the file          }
    Halt_Error:='Wrong PCX format';
    LoadPCX:=false;      { not decoded!            }
    LOADOFF;
    exit;                    { And exit this procedure }
 end;

  { Init some values }
  Xsize:=header.xmax-header.xmin+1;             { Get actual X-Size of image }
  Ysize:=header.ymax-header.ymin+1;             { Get actual Y-Size of image }
  Xscrn:=0;                                     { Screen positions }
  Yscrn:=0;                                     { Screen positions }

  if Xsize>320 then begin
     Halt_error:='PCX width to large';
     LoadPCx:=false;
  end;

  if Ysize>200 then begin
     Halt_error:='PCX height to large';
     LoadPCx:=false;
  end;

  bytesmem:=0;
  mempos:=1;

  REPEAT
       getbyte(readbyte);
       if (readbyte and 192)=192 then begin     { Are Top 2 bits set? }
           count:=readbyte and 63;              { Yes, so it's a packed }
           getbyte(plotdata);
       end else begin
           count:=1;                            { Not packed, so 1 byte to set}
           plotdata:=readbyte;                  { Set the color to plot }
       end;
       ASM
          mov cx,320           { width of screen                }
          mov es,sega000       { get screen segment             }
          mov ax,yscrn         { get screen Y                   }
          mov bx,ax
          shl ax,6
          shl bx,8
          add ax,bx
          mov di,ax            { and set to screen offset       }
          mov ax,xscrn         { get X position                 }
          add di,ax            { add to screen offset           }
          mov al,plotdata      { get color value                }
          mov cx,count
          rep stosb            { store the byte                 }
          mov ax,xscrn
          add ax,count         { increse X position on screen   }
          mov xscrn,ax
       END;
          if xscrn>=xsize then begin             { Hit the image-width? }
             dec(xscrn,320);                           { Yes, so restart at 0 }
             inc(yscrn);                         { And go 1 line down on screen}
          end;
  UNTIL (yscrn=ysize);                           { Repeat until complete image}

  {

    Now load the palette

  }
  seek(lib_file,filesize(lib_file)-769);
  if lib then
     seek(lib_file,Key_Start+Key_Size-769)      { get last 769 bytes }
  else
     seek(lib_file,filesize(lib_file)-769);
  blockread(lib_file,readbyte,1);               { read a byte, }
  if readbyte=12 then begin                     { and check for 12 (palette) }
     for plotdata:=0 to 255 do begin            { walk thru all colors }
         port[$03c8]:=plotdata;

         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].Redlevel:=readbyte;
         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].GreenLevel:=readbyte;
         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].BlueLevel:=readbyte;
     end;
  end;
  close(lib_file);                                 { Close image file }
  LOADOFF;
  FadeIn(0,255);
END;
{
        Load the SFX logo for startup-booting screen

        Expects    : Nothing
        Returns    : Nothing
{}
PROCEDURE ShowLogo;
VAR  Xscrn,Yscrn : word;            { Screen positions }
     plotdata    : byte;            { Byte-Color-Pixel to plot }
     readbyte    : byte;            { Byte to read from file }
     count       : integer;         { Count of continuous bytes }
     mempos      : longint;

      PROCEDURE GetByte(Var return:byte);
      BEGIN
        return:=mem[seg(LogoPTR^):ofs(LogoPTR^)+mempos];
        inc(mempos);
      END;

BEGIN
  BlackPal;

  {=-=- Init some values -=-=}
  Xscrn:=0;                                     { Screen positions }
  Yscrn:=0;                                     { Screen positions }

  mempos:=127;

  REPEAT
       getbyte(readbyte);
       if (readbyte and 192)=192 then begin     { Are Top 2 bits set? }
           count:=readbyte and 63;              { Yes, so it's a packed }
           getbyte(plotdata);
       end else begin
           count:=1;                            { Not packed, so 1 byte to set}
           plotdata:=readbyte;                  { Set the color to plot }
       end;
       ASM
          mov cx,320           { width of screen                }
          mov es,sega000       { get screen segment             }
          mov ax,yscrn         { get screen Y                   }
          mov bx,ax
          shl ax,6
          shl bx,8
          add ax,bx
          mov di,ax            { and set to screen offset       }
          mov ax,xscrn         { get X position                 }
          add di,ax            { add to screen offset           }
          mov al,plotdata      { get color value                }
          mov cx,count
          rep stosb            { store the byte                 }
          mov ax,xscrn
          add ax,count         { increse X position on screen   }
          mov xscrn,ax
       END;
          if xscrn>=320 then begin
             dec(xscrn,320);
             inc(yscrn);
          end;
  UNTIL (yscrn=200);

  {=-=- Now set the palette -=-=}

     GetByte(readbyte);
     for plotdata:=0 to 255 do begin            { walk thru all colors }
         port[$03c8]:=plotdata;

         GetByte(readbyte);
         readbyte:=readbyte shr 2;
            port[$03c9]:=readbyte;
            {pal[plotdata].Redlevel:=readbyte;}
         GetByte(readbyte);
         readbyte:=readbyte shr 2;
            port[$03c9]:=readbyte;
            {pal[plotdata].GreenLevel:=readbyte;}
         GetByte(readbyte);
         readbyte:=readbyte shr 2;
            port[$03c9]:=readbyte;
            {pal[plotdata].BlueLevel:=readbyte;}
     end;
END;

{}
{
        View a 360x480x256 image... FAST and sure great looking.

        Expects    : use a LIB file, and the Filename of PCX
        Returns    : True if succesfull in loading

}
FUNCTION LOADPCXHIGH(lib:boolean;filename:string):boolean;
TYPE PCX_Header = record
       manu     : byte;
       version  : byte;
       encoding : byte;
       b_p_pix  : byte;
       xmin     : word;
       ymin     : word;
       xmax     : word;
       ymax     : word;
       hres     : word;
       vres     : word;
       colormap : array[1..48] of byte;
       reserve  : byte;
       nplanes  : byte;
       bpline   : word;
       palinfo  : word;
       filler   : array[1..58] of byte;
    end;

VAR  i,r,g,b     : byte;
     Xsize,Ysize : word;            { Size of image }
     Xscrn,Yscrn : word;            { Screen positions }
     plotdata    : byte;            { Byte-Color-Pixel to plot }
     readbyte    : byte;            { Byte to read from file }
     count       : integer;         { Count of continuous bytes }
     Header      : PCX_Header;
     code        : integer;
     error       : boolean;
     bytesleft   : longint;
     sizeread    : longint;
     bytesmem    : longint;
     mempos      : longint;

      PROCEDURE REadNewBlock;
      BEGIN
        if bytesleft<63000 then sizeread:=bytesleft else sizeread:=63000;
        blockread(lib_file,mem[vpage_seg:vpage_ofs],sizeread);
        dec(bytesleft,sizeread);
        bytesmem:=sizeread;
        mempos:=0;
      END;

      PROCEDURE GetByte(Var return:byte);
      BEGIN
        if mempos>=bytesmem then ReadNewBlock;
        return:=mem[vpage_seg:vpage_ofs+mempos];
        inc(mempos);
      END;

BEGIN
  Halt_Proc:='LoadPCXhigh';
  LOADON;
  LoadPCXHigh:=true;                                 { all's well }
  error:=false;                                      { no error's (yet) }

  if lib then begin
     code:=lib_reset(filename);
     if code<>0 then begin
        halt_Error:='Resource not found ('+filename+')';
        LoadPCXhigh:=false;
        LOADOFF;
        exit;
     end;
     bytesleft:=(key_size)-897;
  end else begin
     assign(lib_file,filename);
       {$I-}
            reset(lib_file,1);    { open file }
       {$I+}
       bytesleft:=filesize(lib_file)-897;
       if ioresult<>0 then begin
          halt_Error:='File not found ('+filename+')';
          LoadPCXhigh:=false;
          LOADOFF;
          exit;
       end;
  end;
  blockread(lib_file,header,sizeof(header));      { Read header first}
 {

    Check for correct PCX format

 }
 if header.encoding<>1 then error:=true;        { different encoding used }
 if header.b_p_pix<>8 then error:=true;         { to many bits per pixel }
 if header.nplanes<>1 then error:=true;         { to many color planes }
 if error then begin
    close(lib_file);         { Close the file          }
    Halt_Error:='Wrong PCX format';
    LoadPCXHigh:=false;      { not decoded!            }
    LOADOFF;
    exit;                    { And exit this procedure }
 end;

  { Init some values }
  Xsize:=header.xmax-header.xmin+1;             { Get actual X-Size of image }
  Ysize:=header.ymax-header.ymin+1;             { Get actual Y-Size of image }
  Xscrn:=0;                                     { Screen positions }
  Yscrn:=0;                                     { Screen positions }
  {
    Go into HIGH screen mode (ModeX 360x480x256)
  }
  ASM
     mov ax,$13           { select the VGA mode }
     int 10h              { go into it! }

     mov dx,$3c4
     mov ax,$0604
     out dx,ax            { disable chain4 mode }
     mov ax,$0f02
     out dx,ax            { set Write plane mask to all planes }

     mov cx,16000         { let's clear the screen first }
     DB $66
     xor ax,ax            { set EAX to 0 }
     mov es,sega000       { get screen segment }
     xor di,di            { get screen offset  }
     DB $66
     rep STOSW            { store all DOUBLE words }

     mov dx,$3c2
     mov al,$e7
     out dx,al            { use 28mhz dot clock }
     mov dx,$3c4
     mov ax,$0300
     out dx,ax            { restart sequencer }
     mov dx,$3d4
     mov al,$11
     out dx,al            { select CRTC register 11 }
     xor ah,ah
     mov dx,$3d5
     in al,dx
     and al,$7f            { "write protect" }
     out dx,al
     mov dx,$3d4           { write new register values }
     mov ax,$6b00          { horz total                }
     out dx,ax
     mov ax,$5901          { horz displayed            }
     out dx,ax
     mov ax,$5a02          { start horz blanking       }
     out dx,ax
     mov ax,$8e03          { end horz blanking         }
     out dx,ax
     mov ax,$5e04          { start h sync              }
     out dx,ax
     mov ax,$8a05          { end h sync                }
     out dx,ax
     mov ax,$0d06          { vertical total            }
     out dx,ax
     mov ax,$3e07          { overflow                  }
     out dx,ax
     mov ax,$4009          { cell height               }
     out dx,ax
     mov ax,$ea10          { v sync start              }
     out dx,ax
     mov ax,$ac11          { v sync end and protect cr0-cr7  }
     out dx,ax
     mov ax,$df12          { vertical displayed        }
     out dx,ax
     mov ax,$2d13          { offset                    }
     out dx,ax
     mov ax,$0014          { turn off dWord mode       }
     out dx,ax
     mov ax,$e715          { v blank start             }
     out dx,ax
     mov ax,$0616          { v blank end               }
     out dx,ax
     mov ax,$e317          { turn on Byte mode         }
     out dx,ax

     { Make the palette Black }
     call BlackPal
  end;

  bytesmem:=0;
  mempos:=1;

  REPEAT
       getbyte(readbyte);
       if (readbyte and 192)=192 then begin     { Are Top 2 bits set? }
           count:=readbyte and 63;              { Yes, so it's a packed }
           getbyte(plotdata);
       end else begin
           count:=1;                            { Not packed, so 1 byte to set}
           plotdata:=readbyte;                  { Set the color to plot }
       end;
          while count>0 do begin
                PortW[$3c4]:=($100 shl (xscrn and 3))+2;
                ASM
                   mov cx,90            { width of screen in modeX 360.. }
                   mov es,sega000       { get screen segment             }
                   mov ax,yscrn         { get screen Y                   }
                   mul cx               { multiply with screen width     }
                   mov di,ax            { and set to screen offset       }
                   mov ax,xscrn         { get X position                 }
                   shr ax,2             { divide with 4 (4 planes)       }
                   add di,ax            { add to screen offset           }
                   mov al,plotdata      { get color value                }
                   stosb                { store the byte                 }
                   inc xscrn            { increse X position on screen   }
                   dec count            { decrease couter                }
                END;
          end;
          if xscrn>=xsize then begin             { Hit the image-width? }
             xscrn:=0;                           { Yes, so restart at 0 }
             inc(yscrn);                         { And go 1 line down on screen}
          end;
  UNTIL (yscrn=ysize);                           { Repeat until complete image}

  {

    Now load the palette

  }
  seek(lib_file,filesize(lib_file)-769);
  if lib then
     seek(lib_file,Key_Start+Key_Size-769)      { get last 769 bytes }
  else
     seek(lib_file,filesize(lib_file)-769);
  blockread(lib_file,readbyte,1);               { read a byte, }
  if readbyte=12 then begin                     { and check for 12 (palette) }
     for plotdata:=0 to 255 do begin            { walk thru all colors }
         port[$03c8]:=plotdata;

         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].Redlevel:=readbyte;
         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].GreenLevel:=readbyte;
         blockread(lib_file,readbyte,1); readbyte:=readbyte shr 2;
            pal[plotdata].BlueLevel:=readbyte;
     end;
  end;
  close(lib_file);                                 { Close image file }
  FadeIn(0,255);
  LOADOFF;
END;
{}
{
        Deallocate memory from a spritetype array

        Expects: array of the spritetyp
        Returns: Nothing
}

PROCEDURE DeAllocXAS(VAR storing:Array of SpriteTyp);
VAR i            : word;
    msize        : word;
    width,height : byte;
BEGIN
 for i:=low(storing) to high(storing) do begin
     if storing[i].data<>NIL then begin
       Width:=mem[seg(storing[i].data^):ofs(storing[i].data^)];
       Height:=mem[seg(storing[i].data^):ofs(storing[i].data^)+1];
       msize:=(Width*Height)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
          freemem(storing[i].data,msize);
     end;
 end;
END;
{}
{
   Takes a sample of the joystick state, and button states..

   Expects: Nothing
   Returns: Nothing

}

PROCEDURE SAMPLE; ASSEMBLER;
ASM
 CLI
 xor si,si     {x count}
 xor di,di     {y count}
 mov dx,$201   {Game port}
 out dx,al     {Fire the joystick one-shots}
@@L:
 in  al,dx     {get joystick bits}
 mov ah,al     {save original value}
 shr al,1      {joy 0 x expired? 0 if so, else 1}
 adc si,0      {accumulate in x}
 jc @@TOOLONG  {if overflow, give up}
 shr al,1      {joy 0 y expired? 0 if so, else 1}
 adc di,0      {accumulate in y}
 jc @@TOOLONG  {if overflow, give up}
 test ah,3
 jnz @@L       {keep going til they're both 0 or we overflow}
 not ah        {flip button bits so 1=pressed}
 mov al,ah
 and al,$10    {mask off buttons and store them}
 mov JoystickA,al
 mov al,ah
 and al,$20
 mov JoystickB,al
 mov al,ah
 and al,$40
 mov JoystickC,al
 mov al,ah
 and al,$80
 mov JoystickD,al

 mov X,si      {store x & y coords}
 mov Y,di
 jmp @@X
@@TOOLONG:
 mov X,-1      {overflowed, return -1 as error}
 mov Y,-1
 xor al,al
 mov JoystickA,al
 mov JoystickB,al
 mov JoystickC,al
 mov JoystickD,al
@@X:
 STi
END;
{}
{
   It does the usual "swirl" calibrating of the joystick.
   display message before starting this one!

   Expects: Nothing
   Returns: Nothing

}
PROCEDURE SWIRLCALIBRATE;
BEGIN
 REPEAT
   SAMPLE;
 until NOT (JoystickA or JoystickB or JoystickC or JoystickD);

 REPEAT                           {collect max extents}
  sample;
  if x<Cal_L then Cal_L:=x;
  if x>Cal_R then Cal_R:=x;
  if y<Cal_T then Cal_T:=y;
  if y>Cal_B then Cal_B:=y;
 UNTIL JoystickA or JoystickB or joystickC or joystickD; {until user presses a button}
 Cal_L:=((Cal_L*3)+Cal_R)div 4;      {now adjust for center by}
 Cal_R:=((Cal_R*3)+Cal_L)div 4;      { weighted averaging}
 Cal_T:=((Cal_T*3)+Cal_B)div 4;
 Cal_B:=((Cal_B*3)+Cal_T)div 4;
END;
{}
{
   This one expects the joystick to be in the center, and then takes
   a "SNAP SHOT" of the center positions... not as accurate as the
   "swirl" calibrating...but it should work in most cases.

   Expects: Nothing
   Returns: Nothing

}
PROCEDURE CENTERCALIBRATE;
VAR x2,y2   : word;
BEGIN
 sample;
 x2:=x shr 1;
 y2:=y shr 1;
 Cal_L:=x-x2;
 Cal_R:=x+x2;
 Cal_T:=y-y2;
 Cal_B:=y+y2;
END;
{}
{
   Get the joystick booleans SET to TRUE or FALSE, according to actions
   from the player.

   Expects: Nothing
   Returns: Nothing

}
PROCEDURE GetJoy;
BEGIN
 Sample;
 JoyThings[1]:=x<cal_l;
 JoyThings[2]:=x>cal_R;
 JoyThings[3]:=y>cal_B;
 JoyThings[4]:=y<cal_T;
 JoyThings[5]:=JoystickA;
 JoyThings[6]:=JoystickB;
 JoyThings[7]:=JoystickC;
 JoyThings[8]:=JoystickD;

 JoystickDown:=JoyThings[JoyDown];
 Joystickleft:=JoyThings[JoyLeft];
 JoystickUp:=JoyThings[JoyUp];
 JoystickRight:=JoyThings[Joyright];
 JoystickA:=JoyThings[JoyFire];
 JoystickB:=JoyThings[JoyFire2];
 JoystickC:=JoyThings[JoyFire3];
 JoystickD:=JoyThings[JoyFire4];
END;
{}
{
   Show a picture of the joystick and ask the user to push some buttons

   Expects: Nothing
   Returns: Nothing

}
PROCEDURE InitJoy;
BEGIN
 if ControlTYPE=JoystickValue then begin { Calibrate the joystick                   }
    GETXAS(true,'joystick.xas',joypic);  { read joystick images         }
    asm
     call setpal                { set the palette we loaded             }
     mov ax,127                 { X position of image                   }
     mov bx,67                  { Y position of image                   }
     mov si,offset joypic       { first image                           }
     les di,[ds:si]             { get pointer to data                   }
     call SPRITENOMASK          { draw the sprite, no masking           }
     call ShowBitmap            { show the bitmap (image)               }
    end;
    REPEAT SAMPLE; UNTIL JoystickA or JoystickB or JoystickC or JoystickD;
    asm
     mov ax,127                 { X position of image                   }
     mov bx,67                  { Y position of image                   }
     mov si,offset joypic       { get image offset                      }
     add si,SizeSpriteType    { and get data of second image          }
     les di,[ds:si]             { get pointer to data                   }
     call SPRITENOMASK          { draw the sprite, no masking           }
     call ShowBitmap            { show the bitmap (image)               }
    end;
    SwirlCalibrate;             { Do the "swirl" thing                  }
    DeAllocXAS(joypic);         { get rid of joystick images            }
 end;
END;
{}
{
        Shut down the library, and free all memory... this is also called
        thru the NEWEXIT procedure (every time you HALT, or at the end of the
        program..)

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE ShutSuperFX;
VAR I,j          : byte;
    MSIZE        : word;
    Width,Height : byte;
    tempFX       : PFX;
    nextFX       : PFX;
    CharWidth    : byte;
    CharHeight   : byte;
BEGIN
 Halt_Proc:='ShutSuperFX';
 if Vpage_PTR<>NIL then begin
        FreeMem(VPage_PTR,64004);
 end;
 if Board_PTR<>NIL then begin
        FreeMem(Board_PTR,25600);
 end;

  if map<>nil then begin
      FreeMem(map,(mapheight+1)*(mapwidth+1)*sizeof(MapType));
  end;

{

    Erase TileData from memory

}
 for i:=0 to 255 do begin
     if Tiles[i].data<>NIL then begin
       Width:=mem[seg(Tiles[i].data^):ofs(Tiles[i].data^)];
       Height:=mem[seg(Tiles[i].data^):ofs(Tiles[i].data^)+1];
       msize:=(Width*Height)+2;
       if (msize mod 16)<>0 then msize:=msize+16;
       msize:=16*(msize div 16);
          freemem(Tiles[i].data,msize);
    end;
 end;

 {

        Erase LAYER from memory

 }
 FOR i:=1 to 5 do begin
  if layertile[i]<>NIL then begin   { dispose old first }
    Width:=mem[seg(layertile[i]^):ofs(layertile[i]^)];
    Height:=mem[seg(layertile[i]^):ofs(layertile[i]^)+1];
    msize:=(Width*Height)+2;
    if (msize mod 16)<>0 then msize:=msize+16;
    msize:=16*(msize div 16);
        freemem(layertile[i],msize);
   end;
 END;

 {
        Erase CHARSET
 }
 for j:=1 to CharSETS do begin
  charWidth:=CharsetWidth[j];
  charheight:=CharsetHeight[j];
  for i:=low(charset[j]) to high(charset[j]) do begin
     IF Charset[j,i]<>NIL then begin
        msize:=(charwidth*charheight);
        if (msize mod 16)<>0 then msize:=msize+16;
        msize:=16*(msize div 16);
            FreeMem(charset[j,i],msize);
     end;
  end;
 end;
{

    Erase FX data from memory

}
   tempfx:=FirstFX;
   while tempfx<>NIL do begin
       nextFX:=tempfx^.next;
       eraseFX(tempfx);
       tempfx:=nextfx;
   end;

 if (EndingScreen<>'') then begin
    if lib_reset(endingScreen)=0 then begin
       blockread(lib_file,mem[segb800:0],key_size);
       close(lib_file);
    end;
 end;


 {

   Restore Timer/Keyboard interrupt

 }
 RestoreTimerInterrupt;
 RestoreInt09;

END;
{
                            NEW Timer Procedures
}
{$IFDEF DEBUGGING}
  FUNCTION time:longint;     { used for FPS calculating                      }
  BEGIN
   time:=meml[seg0040:$6c];
  END;

  PROCEDURE _NextFrame;
  var  s1 : string;
  BEGIN
    {=-=-=- See if FPS counter was initialised -=-=-=}
    if StartTimer=0 then begin
       FrameCount:=0;
       if OPsystem=1 then
          StartTimer:=time          { Windows Mode }
       else
          StartTimer:=time*timeout; { DOS Mode }
       EndTimer:=0;
    end;
    inc(FrameCount);
    if OPsystem=1 then
        EndTimer:=time              { Windows Mode }
    else
        EndTimer:=Time*timeout;     { DOS Mode }
    if EndTimer>StartTimer then
       FramePerSecond:=round(FrameCount*18.2/(EndTimer-StartTimer));
   {$IFDEF DEBUGGING}
      if maxSprites>totalMaxSprites then totalMaxSprites:=maxSprites;
      maxSprites:=0;
   {$ENDIF}
   if FramePerSecond<35 then begin
      textSeg:=sega000;
      WText(280,4,'SLOW!',1);
      TextSeg:=vpage_seg;
   end;
   str(FramePerSecond,s1);
   WTEXT(270,190,'FPS '+s1,1);
  END;

  PROCEDURE _ResetFPS;
  BEGIN
       FrameCount:=0;
       if OPsystem=1 then
          StartTimer:=time          { Windows Mode }
       else
          StartTimer:=time*timeout; { DOS Mode }
       EndTimer:=0;
  END;

{$ENDIF}

PROCEDURE SetTimer(x : word); assembler;
asm
	cli
	mov	al,$36
	out	$43,al
	jmp	@1
@1:mov	ax,[x]
	out	$40,al
	jmp	@2
@2:mov	al,ah
	out	$40,al
	jmp	@3
@3:sti
end;
{}
{$F+,S-}
procedure TimerHandler; interrupt; assembler;
{$F-}
asm
	cli
	inc	[timercount]
	mov	ax,[TIMEOUT]
	cmp	[timercount],ax
	jb		@noretrace
	mov	[timercount],0

	{wait for a vertical retrace}
	mov	dx,$3DA
@vblank:
	in		al,dx
	test	al,8
	jz		@vblank

	{set timer again}
	mov	al,$36
	out	$43,al
	jmp	@1
@1:mov	ax,[TimeSet]
	out	$40,al
	jmp	@2
@2:mov	al,ah
	out	$40,al

	{increase timer counters}
	inc	[retraces]
	inc	[total_retraces]

	{should we call user-defined hook?}
	mov	ax,WORD PTR [TimerProc]
	or		ax,WORD PTR [TimerProc+2]
	jz		@nouserproc
	sti
	call	DWORD PTR [TimerProc]
	cli
@nouserproc:

	cmp	[execbiostimer],FALSE
	je		@nobiostimer
	mov	ax,[TimeSet]
	add	[bioscount],ax
	jno	@nobiostimer
	sti
	pushf
	call	DWORD PTR [Int08Save]
	jmp	NEAR PTR @xit
@nobiostimer:

@noretrace:
	mov	al,$20
	out	$20,al
	sti
@xit:
end;
{}
FUNCTION GetTime : word; assembler;
{Find time between two vertical retraces...}
asm
	mov	dx,$3DA   {wait for a vertical retrace to begin}
@wait1a:
	in		al,dx
	test	al,8
	jnz	@wait1a
@wait1b:
	in		al,dx
	test	al,8
	jz		@wait1b

	mov	al,$36
	out	$43,al
	xor	al,al		{ reset the timer }
	out	$40,al
	out	$40,al

	mov	dx,$3DA   {wait for a new vertical retrace to begin}
@wait2a:
	in		al,dx
	test	al,8
	jnz	@wait2a
@wait2b:
	in		al,dx
	test	al,8
	jz		@wait2b

	xor	al,al
	out	$43,al
	in		al,$40
	mov	ah,al
	in		al,$40		{ read timer count - time between }
	xchg	al,ah       { two Vertical Retraces }
	neg	ax
end;
{}
FUNCTION SyncTimerToVBLANK : word; assembler;
const
	FRAMEPERCENT = 950; {returned time will be 97.5% of measured value}
asm
@GetFrameTime:
	cli									{ Don't bother us while timing things }
	call	GetTime
	push	ax
	call	GetTime
	pop	dx
	sti
	sub	dx,ax
	cmp  	dx,5                    { If the difference between the two }
	jg		@GetFrameTime           { values read was >5, read again }
	cmp	dx,-5
	jl		@GetFrameTime

	mov	bx,FRAMEPERCENT
	mul	bx
	mov	bx,1000
	div	bx
	shr	ax,1
end;
{}
PROCEDURE SetTimerInterrupt;
begin
 Halt_Proc:='SetTimerInterrupt';
	retraces:=0; total_retraces:=0; timercount:=0;
	TimeSet:=$FFFF;
	GetIntVec($08,@Int08Save);
	SetIntVec($08,addr(TimerHandler));         {  FPS is in the SFX_VARS unit}
	if (TIMEOUT<>0) then TimeSet := ($1234DD DIV FPS DIV TIMEOUT)+TIMESLACK
	   else TimeSet:=SyncTimerToVBLANK;
	SetTimer(TimeSet);
	TimerInstalled:=TRUE;
        TimeDemo:=false;
end;
{}
PROCEDURE RestoreTimerInterrupt;
begin
	if NOT TimerInstalled then exit;
	SetIntVec($08,@Int08Save);
	SetTimer(0);
	TimerInstalled:=FALSE;
end;
{}
{
        This is the new RETRACE procedure... it checks on interrupt and not
        on vga-retrace

        Expects: Nothing
        Returns: Nothing
{}
{
        Wait for the next vertical retrace using the timer interrupt

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE Retrace; assembler;
ASM
  and TimeDemo,1
  jnz @ExitRetrace
  cmp [TimerInstalled],TRUE
  je  @timerinstalled
  mov dx,$3DA
 @wait1: {if we are in retrace, wait 'till we are not...}
  in al,dx
  test al,8
  jnz @wait1

 @wait2: {wait for a new retrace}
  in al,dx
  test al,8
  jz @wait2
  jmp NEAR PTR @done
 @timerinstalled:

  {$IFDEF DEBUG_RETRACE}
     mov dx,$3c8
     xor al,al
     out dx,al
     inc dx
     out dx,al
     out dx,al
     out dx,al
  {$ENDIF}

   mov ax,[total_retraces]
 @Wait3:
   cmp ax,[total_retraces]
   je @Wait3
 @done:

  {$IFDEF DEBUG_RETRACE}
     mov dx,$3c8
     xor al,al
     out dx,al
     inc dx
     out dx,al
     out dx,al
     mov al,$15
     out dx,al
  {$ENDIF}
 @ExitRetrace:
END;
{}
{
        New exit procedure to quit to dos

        Expects: Nothing
        Returns: Nothing

}
PROCEDURE NewExit;
var i : byte;
    time : integer;
    hh   : byte;
    mm   : byte;
    ss   : byte;
    eradr: string;

    FUNCTION word2hex(value:word):string;
    VAR tmp  : string;
        tmp2 : byte;
        tmp3 : byte;
        k    : integer;
    BEGIN
      tmp:='';
      tmp2:=value shr 8;
      tmp3:=tmp2 div 16;
      if tmp3>9 then tmp3:=tmp3+7;
      tmp:=tmp+char(tmp3+48);
      tmp3:=tmp2 mod 16;
      if tmp3>9 then tmp3:=tmp3+7;
      tmp:=tmp+char(tmp3+48);

      tmp2:=value mod 256;
      tmp3:=tmp2 div 16;
      if tmp3>9 then tmp3:=tmp3+7;
      tmp:=tmp+char(tmp3+48);
      tmp3:=tmp2 mod 16;
      if tmp3>9 then tmp3:=tmp3+7;
      tmp:=tmp+char(tmp3+48);

      word2hex:=tmp;
    END;

    FUNCTION Ptr2hex(adr:pointer):string;
    VAR tmp : string;
        tw  : word;
        value  : word;
    BEGIN
      value:=(longint(adr) shr 16);
      tmp:=word2hex(value);
      value:=(longint(adr) mod 65536);
      tmp:=tmp+':'+word2hex(value);

      ptr2hex:=tmp;
    END;

BEGIN
  ExitProc:=OldExit;
  ASM
   mov ax,$03        { set mode to TEXT mode (3h) }
   int 10h           { call BIOS interrupt }
  END;

  if ErrorAddr<>nil then begin
     Halt_Proc:='RunTime Error / '+Halt_Proc;
     Case ExitCode of
       2 : Halt_Error:='(2) File Not Found';
       3 : Halt_Error:='(3) Path Not Found';
     100 : Halt_Error:='(100) Disk Read Error';
     101 : Halt_Error:='(101) Disk Write Error';
     103 : Halt_Error:='(103) File Not Open (programmers fault)';
     200 : Halt_Error:='(200) Division by Zero';
     201 : Halt_Error:='(201) Range Check Error (programmers fault)';
     202 : Halt_Error:='(202) Stack overflow Error (programmers fault)';
     203 : Halt_Error:='(203) Heap Overflow error (programmers fault)';
     204 : Halt_Error:='(204) Invalid pointer operation (programmers fault)';
     216 : Halt_Error:='(216) General Protection fault';
     end;
     
     eradr:=ptr2hex(ErrorAddr);
     halt_error:=halt_error+'  (ADR='+eradr+')';
     ErrorAddr:=NIL;
  end;

  if halt_error<>'' then begin

   twrite(1,1,' RunTime Error occured, Shutting SuperFX Engine                                 ',15,1);
   twrite(1,2,'ͻ',7,0);
   twrite(1,3,'Last Proc   :                                                                 ',7,0);
   twrite(1,4,'Error MSG   :                                                                 ',7,0);
   twrite(1,5,'ͼ',7,0);

   Twrite(16,3,Halt_proc,7,0);
   Twrite(16,4,Halt_Error,7,0);

   IF DEBUG then begin
      writeln(DebugFile,'*** ERROR, PROGRAM HALTED');
      writeln(DebugFile,'Last procedure: '+halt_proc);
      writeln(DebugFile,'Error message : '+halt_error);
   end;


   window(1,6,80,25);
   clrscr;
  end else window(1,1,80,25);


  {$IFDEF DEBUG}
   clrscr;
   twrite(1,1,' SuperFX Debug Information                                                      ',15,1);
   twrite(1,2,'ͻ',7,0);
   twrite(1,3,'Play Time   :               Max Sprites  :                                   ',7,0);
   twrite(1,4,'Frames      :               Tiles Anim   :                                   ',7,0);
   twrite(1,5,'Frame/Second:                                                                ',7,0);
   twrite(1,6,'Screen draw :                                                                ',7,0);
  twrite(1, 7,'Ķ',7,0);
  twrite(1, 8,'Last Proc   :                                                                 ',7,0);
  twrite(1, 9,'Error MSG   :                                                                 ',7,0);
  twrite(1,10,'ͼ',7,0);

   Twrite(16,8,Halt_proc,7,0);
   Twrite(16,9,Halt_Error,7,0);

   time:=round((EndTimer-StartTimer)/18.2);
   ss:=time mod 60;   {=-=-=  Seconds =-=-=}
   time:=time div 60;
   mm:=time mod 60;   {=-=-=  Minutes =-=-=}
   hh:=time div 60;   {=-=-=   Hours  =-=-=}

   Twrite(16,3,'00:',7,0);

   STR(mm,Halt_error); if length(halt_error)<2 then halt_Error:='0'+halt_Error;
   Twrite(19,3,halt_error+':',7,0);
   STR(ss,halt_Error); if length(halt_error)<2 then halt_Error:='0'+halt_Error;
   Twrite(22,3,Halt_Error,7,0);

   STR(FrameCount,halt_Error);
     Twrite(16,4,halt_Error,7,0);
   STR(FramePerSecond,halt_error);
     Twrite(16,5,halt_Error+'fps',7,0);

   str(totalMaxSprites,halt_error);     Twrite(46,3,halt_Error+' (on screen at once)',7,0);
   if animated then Twrite(46,4,'Enabled',7,0)
       else Twrite(46,4,'Disabled',7,0);
   if LowDetail then Twrite(16,6,'Low Detail',7,0)
       else Twrite(16,6,'High Detail',7,0);

   window(1,11,80,25);
   clrscr;
  {$ENDIF}
  ShutSuperFX;


END;
{}
{
        Write Text

        Expects: X,Y position of the text, and the text-string
                 and the forground+background color
        Returns: Nothing
}
PROCEDURE TWRITE(x,y:word;text:string;col1,col2:byte);
BEGIN
 ASM
   dec x
   dec y
   lea di,text
   mov bx,di

   mov es,segb800       { get screen segment }
   mov di,y             { get Y position }
   mov ax,di
   shl di,7             { multiply with 7... }
   shl ax,5             { and with 32        }
   add di,ax            { add together= Y*160}
   mov ax,x             { get X position }
   shl ax,1             { multiply with 2 }
   add di,ax            { add to screen offset }

   mov ah,col2          { get background color }
   shl ah,4             { multiply with 16     }
   add ah,col1          { add forground color  }

   mov DX,DS            { remember DX          }

   mov cx,ss
   mov ds,cx
   mov si,bx

   lodsb                { read length of string }
   xor ch,ch
   mov cl,al            { set length into CL    }
   cmp cl,0
   je @NoSet            { if no text, skip writing }

  @TLoop:
   LODSB                { load character }
   STOSW                { store character+color }
   dec cl               { decrease length counter }
   jnz @TLoop
  @NoSet:
   mov DS,DX            { get DX back }
 END;
END;


{============================================================================}
{          PLUG-IN CODE                                                      }
{}
{}
{
        Change a string to uppercase

        Expects: string to change
        Returns: Nothing
}
PROCEDURE _UCASE(var _line:string);
VAR i : word;
BEGIN
 for i:=1 to length(_Line) do _Line[i]:=UpCase(_Line[i]);
END;

{$IFDEF PLUGIN_GCODE}
{*****************************************************************************
  GCODE PARSER procedures, functions and variables
*****************************************************************************}
VAR    LineCount   : word; { specifies the current line                         }

{}
CONST  pre_count = 28;
       pre_func  : array [1..pre_count] of string[16] =
       ( 'END',             'ELSE',          'SET_PROJECTNAME',
         'SET_LIBRARY',     'LOAD_CFG',      'LOADTILES',
         'LOADPARALLAX',    'ECHO',          'LOADCHARSET',
         'LOADMAP',         'FORCE',         'LOADCOLORMAP',
         'BIND',            'ECHO_OFF',      'ECHO_ON',
         'HALT',            'HALT_ERROR',    'IF_PARAM',
         'IF_FILE',         'ADDEVENT',      'DETAIL',
         'CLS',             'WINDOW',        'UNBIND',
         'INITJOY','KEYWAIT','VER','LIST');
{}
VAR   subComm : string;
      CommCode: integer;

      IF_counter : byte;


      Command : string;
      variable: string;
      rest    : string;

{}
CONST InComment : boolean = false;
{}
 {=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         MISC HANDLING PROCEDURES
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
{=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        PARSE FILE HANDLING PROCEDURES
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
{}
{
        Strip the current code-line down, by removing spaces, remarks etc...

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE StripLine;
VAR  i,j,k,l : byte;
     invariable  : boolean;
     intext      : boolean;
BEGIN
 i:=1;
 invariable:=false;
 intext:=false;
 WHILE ( i<=length(ConsoleCode) ) and ( ConsoleCode<>'' ) do begin
 {=-=-=-=-= Check on weird ascii chars =-=-=-=-=-=-=-=-=-=- }
  if Consolecode[i]<char(32) then begin
     Consolecode:=copy(Consolecode,i+1,length(Consolecode));
     dec(i);
  end;
 {=-=-=-=-= Check on remark- block start   /*  =-=-=-=-=-=- }
  if (copy(Consolecode,i,2)='{*') then InComment:=true;
   if not InComment then begin

      if (copy(Consolecode,i,1)='(') then InVariable:=true;
      if (copy(Consolecode,i,1)='"') then InText:=not InText;
      if InVariable then begin
         if not InText then begin
            if copy(Consolecode,i,1)=' 'then begin
               Consolecode:=copy(Consolecode,1,i-1)+copy(Consolecode,i+1,length(Consolecode));
               dec(i);
            end;
         end;
      end;

    {=-=-=-=-=-=-= check on remark part   //  //  =-=-=-=-=-=-=-=-=}
      if (copy(Consolecode,i,2)='//') then begin
         j:=pos('//',copy(Consolecode,i+2,length(Consolecode)));
         if j>0 then Consolecode:=copy(Consolecode,j+i+3,length(Consolecode))
            else ConsoleCode:=copy(Consolecode,1,i-1);
      end;
    {=-=-=-=-=-=-= check on multiple-spaces =-=-=-=-=-=-=-=-=-=-=-=}
      if (copy(Consolecode,i,2)='  ') then begin
           j:=pos('"',Consolecode);
           k:=pos('  ',Consolecode);
           if (k<j) or (j=0) then begin
              ConsoleCode:=copy(Consolecode,1,i-1)+copy(Consolecode,i+1,length(Consolecode));
              dec(i);
           end else begin
               l:=pos('"',copy(Consolecode,j+1,length(Consolecode)));
               if k>(j+l) then begin
                  ConsoleCode:=copy(Consolecode,1,i-1)+copy(Consolecode,i+1,length(Consolecode));
                  dec(i);
               end;
           end;
      end;

   end;
  {=-=-=-=-=-= Check on end of remark-block   */  =-=-=-=-=-=-=-=-}
  if (copy(Consolecode,i,2)='*}') then begin
     InComment:=false;
     Consolecode:=copy(Consolecode,i+3,length(Consolecode));
  end;
  inc(i);
 END;
 if InComment then Consolecode:='';
 if (Consolecode[1]=' ') or (Consolecode[1]<char(32)) then Consolecode:=copy(Consolecode,2,length(Consolecode));
END;

{}
{
        Get a "text-parameter" from a string

        Expects: The string, and the number of the parameter
        Returns: Nothing
}
FUNCTION GetPARAMstring(txt:String;num:byte):string;
VAR i,j  : byte;
    s1   : string;
BEGIN
  GetPARAMstring:='';
  while (num>0) and (length(txt)>0) do begin
    j:=pos('"',txt);
    i:=pos(',',txt);
    if (j<i) and (j<>0) then begin
       j:=pos('"',copy(txt,j+1,length(txt)))+j;
       i:=pos(',',copy(txt,j,length(txt)));
       if i=0 then inc(i,j+1) else inc(i,j-1);
    end;

    if i=0 then i:=length(variable)+1;
    s1:=copy(txt,1,i-1);
    txt:=copy(txt,i+1,length(txt));
    dec(num);
  end;
  GetPARAMstring:=s1;
END;
{}
{
        Get a "value-parameter" from a string

        Expects: The string, and the number of the parameter
        Returns: Nothing
}
FUNCTION GetPARAMvalue(txt:String;num:byte):integer;
VAR i,j : byte;
    s1  : string;
    k   : integer;
BEGIN
  GetPARAMvalue:=0;
  while (num>0) and (length(txt)>0) do begin
    j:=pos('"',txt);
    i:=pos(',',txt);
    if (j<i) and (j<>0) then begin
       j:=pos('"',copy(txt,j+1,length(txt)))+j;
       i:=pos(',',copy(txt,j,length(txt)));
       if i=0 then inc(i,j+1) else inc(i,j-1);
    end;

    if i=0 then i:=length(variable)+1;
    s1:=copy(txt,1,i-1);
    txt:=copy(txt,i+1,length(txt));
    dec(num);
  end;
  val(s1,i,k);
  if k<>0 then i:=0;
  GetPARAMvalue:=i;
END;

{}
{
        Handle the pre-compiled functions

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE HANDLEPREFUNCTIONS;
VAR  j  :  word;
     i  :  byte;
     k  :  integer;
     s1,s2,s3 : string;
     v1,v2,v3,v4 : integer;
     flag     : boolean;
BEGIN
  if (searchend) and (CommCode>2) then exit;

   Case CommCode of
     1 : searchend:=false;
     2 : searchend:=false;
     4 : if not usefile(copy(variable,2,length(variable)-2)) then begin
            if VGA_ECHO=FALSE then halt
               else begin
                    s1:=Halt_Error;
                    _UCASE(s1);
                    Halt_Error:=s1;
                    exit;
               end;
     end;
     5 : BEGIN { LOAD CONFIG }
           s1:=GetPARAMstring(variable,1);
           LoadCFG(copy(s1,2,length(s1)-2));
           if screen_echo then begin
              VGAwriteln('Config file loaded: '+s1);
           end else if vga_echo then begin
                         {$IFDEF PLUGIN_SHOWEVENTS}
                           _ucase(s1);
                           _addevent('CONFIG FILE LOADED: '+s1);
                         {$ENDIF}
           end;
     END;
     6 : begin { GETXAS }
           s1:=GetPARAMstring(variable,1);
           s2:=GetPARAMstring(Variable,2);
           _UCASE(s1);
           if s1='TRUE' then flag:=true else flag:=false;
           if GETXAS(flag,copy(s2,2,length(s2)-2),tiles)=0  then halt;
     end;
     7 : begin { LOADLAYERIMAGE}
           s1:=GetPARAMstring(variable,1);
           s2:=GetPARAMstring(Variable,2);
           j:=GetPARAMvalue(variable,3);
           _UCASE(s1);
           if s1='TRUE' then flag:=true else flag:=false;
           if not LoadLAyerImage(flag,copy(s2,2,length(s2)-2),j) then halt;
     end;
     8 : BEGIN { ECHO }
            if screen_echo then begin
               s1:=GetPARAMstring(variable,1);
               VGAwriteln(copy(s1,2,length(s1)-2));
            end else if vga_echo then begin
                       {$IFDEF PLUGIN_SHOWEVENTS}
                          s1:=GetPAramString(variable,1);
                          _Ucase(s1);
                          _addevent(copy(s1,2,length(s1)-2));
                       {$ENDIF}
            end;
     END;
     9 : BEGIN { LOADCHARSET }
            s1:=GetPARAMstring(variable,1);
            s2:=GetPARAMstring(Variable,2);
            j:=GetPARAMvalue(Variable,3);
            _UCASE(s1);
            if s1='TRUE' then flag:=true else flag:=false;
            if not LoadCharset(flag,copy(s2,2,length(s2)-2),j) then halt;
     END;
    10 : BEGIN { LOADMAP }
            s1:=GetPARAMstring(variable,1);
            s2:=GetPARAMstring(Variable,2);
            _UCASE(s1);
            if s1='TRUE' then flag:=true else flag:=false;
            LoadMap(flag,copy(s2,2,length(s2)-2));
            if Halt_Error<>'' then begin
               if VGA_echo=false then halt
                  else begin
                       s1:=halt_Error;
                       _UCASE(s1);
                       Halt_Error:=s1;
                       exit;
                  end;
            end;
     END;
    11: BEGIN { FORCE }
            s1:=GetParamstring(variable,1);
            _UCASE(s1);
            if s1='KEYBOARD' then begin
               ControlType:=KeyboardValue;
               if screen_echo then VGAwriteln('Controls are forced to Keyboard')
                  else if vga_echo then {$IFDEF PLUGIN_SHOWEVENTS}
                                           _addevent('CONTROLS ARE FORCED TO KEYBOARD');
                                        {$ENDIF}
            end;
            if s1='JOYSTICK' then begin
               if not JoyInstalled then begin
                  if VGA_echo=FALSE then begin
                     Halt_Error:='Joystick required';
                     halt;
                  end else begin
                     Halt_Error:='JOYSTICK REQUIRED';
                     exit;
                  end;
               end;
               ControlType:=JoystickValue;
               if screen_echo then VGAwriteln('Controls are forced to Joystick')
                  else if vga_Echo then {$IFDEF PLUGIN_SHOWEVENTS}
                                          _addevent('CONTROLS ARE FORCED TO JOYSTICK');
                                        {$ENDIF}
            end;
            ControlForced:=true;
     END;
     12: BEGIN { LOAD COLORMAP }
            s1:=GetPARAMstring(variable,1);
            s2:=GetPARAMstring(variable,2);
            _UCASE(s1);
            if s1='TRUE' then flag:=true else flag:=false;
            if not LoadColorMap(flag,copy(s2,2,length(s2)-2)) then halt;
     END;
     13 : BEGIN { BIND }
           s1:=getPARAMstring(Variable,1);
           s2:=getPARAMstring(variable,2);
           _UCASE(s1);
           _UCASE(s2);
           j:=1;  flag:=false;
           while (not flag) and (j<84) do begin
              s3:=keyname[j];
              _UCASE(s3);
              if s3=s1 then flag:=true
                 else inc(j);
           end;
           if (flag=false) then begin
              if VGA_Echo=false then begin
                 halt_Error:='unable to bind key ('+s1+')';
                 halt;
              end else begin
                 halt_Error:='UNABLE TO BIND KEY';
                 exit;
              end;
           end;
           _BIND(j,copy(s2,2,length(s2)-2));
            if screen_echo then begin
              VGAwriteln('Binding key : '+keyname[j]+' with '+copy(s2,2,length(s2)-2));
            end else if vga_echo then begin
                {$IFDEF PLUGIN_SHOWEVENTS}
                  s1:=keyname[j];
                  _ucase(s1);
                  _ucase(s2);
                  _addevent('BINDING KEY : '+s1+' WITH '+copy(s2,2,length(s2)-2));
                {$ENDIF}
            end;

     END;
     14 : screen_echo:=false; { ECHO_OFF }
     15 : screen_echo:=true;  { ECHO_ON }
     16 : HALT;               { HALT }
     17 : halt_error:=copy(variable,2,length(variable)-2); { HALT_ERROR }
     18 : BEGIN                 { IF_PARAM }
           searchend:=true;
           { Get If Statement }
           if paramcount<>0 then begin
              i:=1;
              _UCASE(variable);
              flag:=false;
              while (i<=paramcount) and (flag=FALSE) do begin
                    s1:=paramstr(i); _UCASE(s1);
                    if (s1[1]='/') or (s1[1]='-') then s1:=copy(s1,2,length(s1));
                    if s1=variable then begin searchend:=false; flag:=true; end;
                    inc(i);
              end;
           end;
     END;
     19 : BEGIN                 { IF_FILE }
           assign(lib_file,copy(variable,2,length(variable)-2));
           {$I-}
           reset(lib_file,1);
           {$I+}
           if ioresult<>0 then begin
               searchend:=true;
           end else close(lib_file);
     END;
     20 : BEGIN                { AddEvent Text }
           {$IFDEF PLUGIN_SHOWEVENTS}
              s1:=GetParamString(variable,1);
              if s1<>'' then
                _AddEvent(copy(s1,2,length(s1)-2));
           {$ELSE}
              halt_error:='EVENTS ARE NOT LINKED.';
           {$ENDIF}
     END;
     21 : BEGIN                { graphic DETAIL }
           s1:=GetParamString(Variable,1);
           _UCASE(s1);
           if s1='LOW' then begin
              LowDetail:=true;
              if Screen_Echo then VGAwriteln('Low graphic detail')
                 else if VGA_echo then {$IFDEF PLUGIN_SHOWEVENTS}
                                           _AddEvent('LOW DETAIL');
                                       {$ENDIF}
           end;
     END;
     22 : BEGIN                      { ClearScreen }
          ASM
            MOV DX,DS                    { remember DS }

            MOV ES,sega000               { get screen SEGMENT }
            xor di,di                    { set screen offset to 0 }
            xor si,si                    { set virtual offset to 0 }
            MOV DS,vpage_seg             { get virtual segment }

            MOV CX,16000                 { draw 64000/4 double words }

            DB $66;
            REP MOVSW                    { draw all bytes }

            MOV DS,DX                    { get DS back }
          END;
          for CursY:=0 to 24 do SCRNLINES[CursY]:='';
               CursX:=0; CursY:=0;
     END;
     23 : BEGIN                 { WINDOW }
           v1:=getParamValue(Variable,1);
           v2:=getParamValue(Variable,2);
           v3:=getParamValue(Variable,3);
           v4:=getParamValue(Variable,4);
           if v2<11 then v2:=11;
           if v4<v2 then v4:=v2;
           window(v1,v2,v3,v4);
     END;
     24 : BEGIN                 { UNBIND }
           s1:=getPARAMstring(Variable,1);
           _UCASE(s1);
           j:=1;  flag:=false;
           while (not flag) and (j<84) do begin
              s3:=keyname[j];
              _UCASE(s3);
              if s3=s1 then flag:=true
                 else inc(j);
           end;
           if (flag=false) then begin
              if VGA_echo=false then begin
                 halt_Error:='unable to unbind key ('+s1+')';
                 halt;
              end else begin
                 Halt_Error:='UNABLE TO UNBIND KEY';
                 exit;
              end;
           end;
           FunctionKeys[j]:=0;
            if screen_echo then begin
              VGAwriteln('Unbinding key : '+keyname[j]);
            end else if vga_echo then begin
                {$IFDEF PLUGIN_SHOWEVENTS}
                  s1:=keyname[j];
                  _ucase(s1);
                  _addevent('UNBINDING KEY : '+s1);
                {$ENDIF}
            end;
     END;
     25 : CenterCalibrate;  { INITJOY }
     26 : BEGIN
            while anypressed do;
            repeat until anypressed; { KEYWAIT }
     END;
     27 : BEGIN             { VER }
            str(fxVersion div 256,halt_Error);
            str(fxversion and $ff,halt_proc);
            VGAwriteln('');
            VGAwriteln('SUPER FX VERSION:'+Halt_error+'.'+Halt_Proc);
            VGAwriteln('programming p.bestebroer');
            VGAwriteln('copyright 1996,1997 Just4Fun Productions');
            VGAwriteln(' ');
            Halt_Error:='  ';
            Halt_Proc:='';
          END;
     28 : BEGIN             { LIST }
            for i:=1 to Pre_Count do begin
                VGAwriteln(Pre_Func[i]);
                if (i mod 23)=0 then begin
                  VGAwriteln('---- KEY FOR MORE ----');
                  {$IFDEF GCODE}
                   if ConsoleOn then begin
                      while keypressed do readkey;
                      repeat until keypressed;
                   end else begin
                      while anypressed do;
                      repeat until anypressed;
                   end;
                  {$ELSE}
                    while keypressed do readkey;
                    repeat until keypressed;
                  {$ENDIF}
                  VgaWriteln('');
                end;
                
            end;
          END;
   end;


END;
{}
{
        Search for the command code in the list of pre_compiled functions

        Expects: Nothing
        Returns: FALSE if command not identified
}
FUNCTION GetCommandCode:boolean;
VAR i : byte;
BEGIN
 Halt_Proc:='GetCommandCode';
 GetCommandCode:=FALSE;

 SubComm:=command;
 i:=pos('(',subComm);
 if i>0 then subcomm:=copy(SubComm,1,i-1);
 _UCASE(SubComm);

 if subComm[length(subComm)]=';' then subComm:=copy(subComm,1,length(subComm)-1);
 CommCode:=-1;

 for i:=1 to pre_count do begin
     if pre_func[i]=subComm then begin
        CommCode:=i;
        GetCommandCode:=TRUE;
     end;
 end;
 if CommCode<>-1 then HandlePreFunctions
    else if assigned(_UserFunctions) then begin
         GetCommandCode:=_UserFunctions(subComm,Variable);
    end;
END;
{}
{
        Code the striped line

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE CodeLine;
VAR  i, j, k,l : word;
     zin  : string;
BEGIN
  Halt_Proc:='CodeLine';
  if length(Consolecode)=0 then exit;
  Consolecode:=Consolecode+' ';
  i:=pos(' ',Consolecode);
  j:=pos('(',Consolecode);
  if (j<i) and (j>0) then i:=j;

  if i>0 then begin
     Command:=''; Variable:=''; rest:='';
     command:=copy(Consolecode,1,i-1);

     k:=pos('(',copy(Consolecode,i,length(Consolecode)));
     j:=pos(')',copy(Consolecode,k,length(Consolecode)));
     l:=pos('"',copy(Consolecode,k,length(Consolecode)));
     if (l<>0) and (l<j) and (l>k) then begin
        l:=l+k+pos('"',copy(Consolecode,k+l+1,length(Consolecode)));
        if l>j then begin
           j:=l+pos(')',copy(Consolecode,l+1,length(Consolecode)));
        end;
     end;
     if j>0 then begin
        variable:=copy(Consolecode,i+k,j-i-1);
        rest:=copy(Consolecode,(I+K)+(j-i)+1,length(Consolecode));
        if rest[1]=' ' then rest:=copy(rest,2,length(rest));
     end;
     _UCase(Command);

     IF GetCommandCode=FALSE then begin { not a pre_compiled function }
        if (VGA_Echo=FALSE) and (searchEND=FALSE )then begin
           str(LineCount,zin);
           VGAwriteln('unidentified command ('+command+') on line:'+zin);
        end else begin
           Halt_Error:='UNKNOWN COMMAND ('+command+')';
        end;
     END;

  end;
END;
{}
{
        Starting parsing the file

        Expects: Nothing
        Returns: TRUE if succesfull
}
FUNCTION _ParseFile(filename:String):Boolean;
VAR InFile : array [ 1..2 ] of text;
    SubBar : tProgressBar;
BEGIN
 _ParseFile:=false;
 LineCount:=0;
 IF_Counter:=0;
 searchend:=false;

 assign(InFile[1], filename);
 {$I-}
   reset(InFile[1]);
 {$I+}
 if IOResult<>0 then exit;

 {$IFDEF SHOWSYSTEMINFO}
  VGAwriteln('PARSING: '+filename);
 {$ENDIF}

 {=-=- Count amount of lines in file -=-=}
 LineCount:=0;
 while not eof(infile[1]) do begin
    readln(infile[1],consolecode);
    inc(linecount);
 end;
 reset(infile[1]);

 _InitProgressBar(120,155,200,160,red,LineCount,'PARSING FILE',SubBar);

 LineCount:=0;
  WHILE not EOF(InFile[1]) do begin
    readln(Infile[1],ConsoleCode); inc(LineCount);
    UpdateProgressBar(SubBar);

    StripLine;

    CodeLine;
    while rest<>'' do begin
          Consolecode:=rest;
          StripLine;
          CodeLine;
    end;
  END;
 _ParseFile:=true;

 Close(InFile[1]);
 RemoveProgressBar(SubBar);
END;
{}
{=-=-=-=-= Empty BREAK interrupt =-=-==-=-=}
PROCEDURE _Console_BreakHandler; interrupt;
BEGIN
END;

{}
{
        This will create a small-console area, in wich you can type
        the GCODE commands in run-time

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE _Console_Pop;
VAR  ConsoleI       : byte;     { Just a counter used in this proc.     }
     BreakSave      : pointer;  { Used for saving old CTRL+BREAK int.   }
     ch             : char;     { To read the key-input                 }
     OldCY          : word;

     _ConsoleExit  : boolean;   { TRUE when ~ was pressed               }

     {=-=-=-=-= Remeber the previous 12 commands =-=-=-=-=-=}
     PROCEDURE _Console_ScrollLines;
     VAR i : byte;
     BEGIN
       FOR I:=1 to 24 do SCRNLines[I-1]:=SCRNLines[I];
       SCRNlines[24]:='';
     END;

BEGIN
  RestoreInt09;            { Get original KeyBoard interrupt back }
  GetIntVec($1B, BreakSave); { remember the original CTRL+BREAK int }
  SetIntVec($1B, Addr(_Console_BreakHandler)); { set new CTRL+BREAK int }

  
 {=-=-=- Draw the console window -=-=-=}
 ShowLogo;
 asm
   mov dx,ds                    { remember DS }

   mov es,vpage_seg             { get screen SEGMENT }
   xor di,di                    { set screen offset to 0 }
   xor si,si                    { set virtual offset to 0 }
   mov ds,sega000               { get virtual segment }

   mov cx,16000                 { draw 64000/4 double words }

   DB $66;
   rep movsw                    { draw all bytes }

   mov ds,dx                    { get DS back }
 end;

 _ConsoleExit   :=false;        { TRUE when ~ pressed, or HALT given }
 ConsoleCode    :='';           { Current command line }

 CursX:=0;
 CursY:=0;
 _InitDosPalette;
      asm
       mov dx,ds                    { remember DS }

       mov es,sega000               { get screen SEGMENT }
       xor di,di                    { set screen offset to 0 }
       xor si,si                    { set virtual offset to 0 }
       mov ds,vpage_seg             { get virtual segment }

       mov cx,16000                 { draw 64000/4 double words }

       DB $66;
       rep movsw                    { draw all bytes }

       mov ds,dx                    { get DS back }
     end;

    CursY:=0;
    for ConsoleI:=0 to 23 do begin
        VGAwriteIT(SCRNlines[ConsoleI]);
        inc(cursY,8);
    end;
    OldCY:=CursY;

    ConsoleOn:=true;
 REPEAT
    CursX:=0;
    CursY:=OldCY;
    VGAwriteIt(']'+ConsoleCode+'_'); { show current command line }

    Repeat Until keypressed;            { wait for action }
    SearchEnd:=false;                   { make sure IF statements are not used}
    ch:=readkey;                        { get key code }
    if (ch='~') or (ch='`') then _ConsoleExit:=true; { EXIT THIS! }

    if ch=char(0) then begin { special characters? }
       ch:=readkey;          { yes, so read thru key-value }
    end else begin
        if ch=char(13) then begin
              if length(ConsoleCode)>0 then SCRNlines[24]:=']'+ConsoleCode;
              _Console_ScrollLines;
              Stripline;
              Halt_Error:='';
              CodeLine;
              if Halt_Error<>'' then begin
                 SCRNlines[24]:=Halt_Error;
                 _Console_ScrollLines;
              end;
              ConsoleCode:='';

              ASM
                mov dx,ds                    { remember DS }

                mov es,sega000               { get screen SEGMENT }
                xor di,di                    { set screen offset to 0 }
                xor si,si                    { set virtual offset to 0 }
                mov ds,vpage_seg             { get virtual segment }

                mov cx,16000                 { draw 64000/4 double words }

                DB $66;
                rep movsw                    { draw all bytes }

                mov ds,dx                    { get DS back }
              end;

              CursY:=0;
              for ConsoleI:=0 to 23 do begin
                  VGAwriteIT(SCRNlines[ConsoleI]);
                  inc(cursY,8);
              end;
              OldCY:=CursY;
        end;
        if ch=char(8) then begin
           for x:=0 to 6 do begin
               for y:=0 to 8 do begin
                mem[sega000:((192+y)*320)+(x+(length(consolecode)*4))]:=0;
               end;
           end;
           ConsoleCode:=copy(ConsoleCode,1,length(ConsoleCode)-1);
        end;
        if (ch>char(96)) and (ch<char(123)) then dec(ch,32);
        if (ch>char(31)) and (ch<char(97)) and (length(ConsoleCode)<42)then begin
           ConsoleCode:=ConsoleCode+ch;
           for x:=0 to 4 do begin
               for y:=0 to 8 do begin
                mem[sega000:((192+y)*320)+(x+(length(consolecode)*4))]:=0;
               end;
           end;
        end;

    end;

 UNTIL (_ConsoleExit);

 ConsoleOn:=false;

 SetIntVec($1B, BreakSave);
 InitInt09;

 SetPal;

 {$IFDEF PLUGIN_RUNTIME}
   _ResetFPS;
 {$ENDIF}
END;


{$ENDIF}

{}
{          PLUGIN  SHOWEVENTS                                                 }
{}
{
        Add a text event

        Expects: text
        Returns: Nothing
}
{$IFDEF PLUGIN_SHOWEVENTS}
 PROCEDURE _AddEvent(txt:String);
 VAR i : byte;
 BEGIN
   if EventNext=MaxEvent then begin
      for i:=2 to MaxEvent do begin
        EventTime[i-1]:=EventTime[i];
        EventText[i-1]:=EventText[i];
      end;
      EventTime[EventNext]:=255;
      EventText[EventNext]:=txt;
   end else begin
      inc(EventNext);
      EventTime[eventnext]:=255;
      EventText[eventnext]:=txt;
   end;
 END;
{}
{
        Show text events if any

        Expects: Nothing
        Returns: Nothing
}
 PROCEDURE _ShowEvents;
 VAR i : byte;
     j : byte;
 BEGIN
   if Eventnext=0 then exit;
   i:=1;
   repeat
      if Eventtime[i]>0 then begin
         dec(eventtime[i]);
         WText(5,(i*charsetwidth[1]),EventText[i],1);
      end else begin
         for j:=i+1 to MaxEvent do begin
             EventTime[j-1]:=EventTime[j];
             EventText[j-1]:=EventText[j];
         end;
         dec(EventNext);
         dec(i);
      end;
      inc(i);
   until i>EventNext;
 END;
{$ENDIF}

{}
{          PLUGIN  DEMO recording/playing procedures                          }
{}
{$IFDEF PLUGIN_DEMO}
CONST DEMID     : string = 'SFX_DEMOv1'; { ID of the SuperFX Demo files      }

VAR DEMleft     : boolean;               { left key is pressed?              }
    DEMright    : boolean;               { right key is pressed?             }
    DEMup       : boolean;               { up key is pressed?                }
    DEMdown     : boolean;               { down key is pressed?              }
    DEMfire     : boolean;               { fire key is pressed?              }
    DEMfire2    : boolean;               { support for 4 joystick buttons    }
    DEMfire3    : boolean;
    DEMfire4    : boolean;
    DEMpress    : longint;               { time the keys are pressed         }

{}
{
        This procedure will create a new DEMO file

        Expects: Filename of the Demo
        Returns: Nothing
}
FUNCTION _NewDemo(filename:string):boolean;
BEGIN
 Halt_Proc:='_NewDemo';
 assign(DEMfile,filename);
 {$I-}
 rewrite(DEMfile,1);
 {$I+}
 if IoResult<>0 then begin
    _NewDemo:=false;
    halt_Error:='Unable to assign demoname ('+filename+')';
    exit;
 end;


 blockwrite(DEMfile,DEMID[1],sizeof(DEMID));    { write DEMO ID }
 blockwrite(DEMfile,MapFile[1],32);             { write map-filename }
 blockwrite(DEMfile,MapLib,1);                  { write map-using lib? }

 DEMleft:=false;        { not pressed,}
 DEMright:=false;       { not pressed neither, }
 DEMup:=false;          { definetly not pressed, }
 DEMdown:=false;        { maybe...NAH not pressed! }
 DEMfire:=false;        { ...don't shoot!, don't shoot! }
 DEMfire2:=false;       { support for 4 joystick buttons }
 DEMFire3:=false;
 DEMfire4:=false;

 DEMpress:=0;           { the pressing-time of the keys    }
 DEMrecord:=true;       { silence please, we're recording! }
 {$IFDEF PLUGIN_SHOWEVENTS}
   _Ucase(Filename);
   _AddEvent('RECORDING DEMO ('+filename+')');
 {$ENDIF}

 _NewDemo:=true;
END;
{}
{
        This procedure will OPEN a DEMO for playing

        Expects: Filename of the Demo
        Returns: Nothing
}
FUNCTION _OpenDemo(filename:string):Boolean;
VAR testID  : string[24];
    tmpFile : string;
BEGIN
 Halt_Proc:='_OpenDemo';
 tmpFile:=filename;
 assign(DEMfile,filename);
 {$I-}
 reset(DEMfile,1);
 {$I+}
 if IoResult<>0 then begin
     _OpenDemo:=false;
     Halt_error:='Couldn''t spawn demo ('+tmpFile+')';
     exit;
 end;

 blockread(DEMfile,testID[1],sizeof(DEMID));
 testID[0]:=DEMid[0];
 if testID<>DEMid then begin
    halt_Error:='Not a valid DEMO file ('+filename+')';
    halt_proc:='_PlayDemo';
    halt;
 end;

 blockread(DEMfile,MapFile[1],32);             { read map-filename }
 blockread(DEMfile,MapLib,1);                  { read map-using lib? }
 LoadMap(mapLib,MapFile);

 DEMpress:=0;
 DEMplay:=true;

 {$IFDEF PLUGIN_SHOWEVENTS}
   _Ucase(tmpFile);
   _AddEvent('PLAYING DEMO ('+tmpFile+')');
 {$ENDIF}
 _OpenDemo:=true;
END;
{}
{
        This will END the DEMO file, and close it...

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE _EndDemo;
BEGIN
  {$I-}
   Close(DEMfile);
  {$I+}
END;
{}
{
        This will handle the recording of key-presses, and save
        it to the DEMO file.

        Expects: all directions, and the fire  presses
        Returns: Nothing
}
PROCEDURE _RecordDemo;

  PROCEDURE _ADDtoDEMObyte(code:byte);
  BEGIN
    blockwrite(DEMfile,code,1);
  END;

  PROCEDURE _ADDtoDEMO(code:longint);
  BEGIN
    blockwrite(DEMfile,code,4);
  END;

BEGIN
  if (joystickleft<>demleft) or (joystickright<>demright) or
     (joystickup<>demup) or (joystickdown<>demdown) or (joystickA<>demfire) or
     (joystickB<>demfire2) or (joystickC<>demfire3) or (joystickD<>demfire4) then begin
         if demleft then _ADDtoDEMObyte(1) else _ADDtoDEMObyte(0);
         if demright then _ADDtoDEMObyte(1) else _ADDtoDEMObyte(0);
         if demup then _ADDtoDEMObyte(1) else _ADDtoDEMObyte(0);
         if demdown then _ADDtoDEMObyte(1) else _ADDtoDEMObyte(0);
         if demfire then _ADDtoDEMObyte(1) else _ADDtoDEMObyte(0);
         if demfire2 then _ADDtoDEMObyte(1) else _ADDtoDEMObyte(0);
         if demfire3 then _ADDtoDEMObyte(1) else _ADDtoDEMObyte(0);
         if demfire4 then _ADDtoDEMObyte(1) else _ADDtoDEMObyte(0);

         _ADDtoDEMO(dempress);

         DEMleft:=joystickleft;
         DEMright:=joystickright;
         DEMup:=joystickup;
         DEMdown:=joystickdown;
         DEMfire:=joystickA;
         DEMfire2:=joystickB;
         DEMfire3:=joystickC;
         DEMfire4:=joystickD;

         DEMpress:=0;
  end else inc(DemPress);
END;
{}
{
        This will handle the PLAYING the demo

        Expects: all directions + fire keys (VARS to be returned)
        Returns: the boolean filled with TRUE or FALSE
}
PROCEDURE _PlayDemo;

VAR i : byte;

  PROCEDURE _GETfromDEMObyte(var code:byte);
  BEGIN
    blockread(DEMfile,code,1);
  END;

  PROCEDURE _GETfromDEMO(var code:longint);
  BEGIN
    blockread(DEMfile,code,4);
  END;

BEGIN
  Joystickleft:=DEMleft;
  JoystickRight:=DEMright;
  JoystickUp:=DEMup;
  JoystickDown:=DEMdown;
  JoystickA:=DEMfire;
  JoystickB:=DEMfire2;
  JoystickC:=DEMfire3;
  JoystickD:=DEMfire4;

  if DemPress>0 then dec(DemPress) else begin
     if eof(DEMfile) then DEMplay:=false else begin
        _GetFromDemoByte(i); if i=1 then DemLeft:=true else DemLeft:=false;
        _GetFromDemoByte(i); if i=1 then DemRight:=true else DemRight:=false;
        _GetFromDemoByte(i); if i=1 then DemUp:=true else DemUp:=false;
        _GetFromDemoByte(i); if i=1 then DemDown:=true else DemDown:=false;
        _GetFromDemoByte(i); if i=1 then DemFire:=true else DemFire:=false;
        _GetFromDemoByte(i); if i=1 then DemFire2:=true else DemFire2:=false;
        _GetFromDemoByte(i); if i=1 then DemFire3:=true else DemFire3:=false;
        _GetFromDemoByte(i); if i=1 then DemFire4:=true else DemFire4:=false;
        _GetFromDemo(DEMpress);
     end;
  end;
END;
{$ENDIF}
{}
{          PLUGIN  RUNTIME DEBUGGING                                          }
{}
{$IFDEF PLUGIN_RUNTIME}
{}
{
        This procedure can be used for debugging...it shows a few variables
        that might come in handy...

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE _SFX_REGISTERS;
VAR s1             : string;
    OldTextSegment : word;
BEGIN
 {=-=-=- Draw the console window -=-=-=}
 ASM
   mov es,vpage_seg  { get screen segment }
   mov di,6740       { x=20, y=20 }

   db $66
   xor ax,ax         { set EAX to  color-black }
   mov dx,ColorWhite { set DX to color-white }

   mov bx,48         { 158 lines to draw black }
  @YLoop:
   mov cx,15         { double-word copying of 280 bytes }
   db $66
   rep stosw          { store blackness }
   mov es:[di],dl     { store white color - right-edge }
   mov es:[di-61],dl  { store white color - left-edge }
   add di,260         { go to next line }
   dec bx             { decrease Y counter }
   jne @YLoop         { not yet 0, so draw next line }

   mov al,colorwhite  { get colorwhite in al... }
   mov ah,al          { and in ah... }
   mov cx,ax          { and remember it in CX }
   db $66
   shl ax,16          { copy AX to EAX }
   mov ax,cx          { get AX back (AH and AL are both colorwhite }

   mov cx,15          { double-word copying of 280 bytes }
   db $66
   rep stosw          { store whiteline at the bottom }
   mov cx,15          { double-word copying of 280 bytes }
   mov di,6420        { Go to the top-line position }
   db $66
   rep stosw          { store the white line at the bottom }
   mov cx,15          { double-word copying of 280 bytes }
   mov di,8980        { Go to the top-line position }
   db $66
   rep stosw          { store the white line at the bottom }
 END;
 OldTextSegment :=TextSeg;
 TextSeg        :=vpage_Seg;

 WText(22,22,'VARIABLE',1);
 {=-=-=-=-= Now we display the variables =-=-=-=-=-=-=}
 str(mapX,s1);            WText(22,30,'M-X:'+s1,1);
 str(mapY,s1);            WText(22,38,'M-Y:'+s1,1);
 str(totalMaxSprites,s1); WText(22,46,'MSP:'+s1,1);
 str(FramePerSecond,s1);  WText(22,54,'FPS:'+s1,1);
 if LowDetail then WText(22,62,'DET:LOW',1) else WText(22,62,'DET:HI',1);

 TextSeg:=OldTextSegment;
END;
{$ENDIF}
{}
{
        Detect for presence of a VGA card

        Expects: Nothing
        Returns: TRUE if detected
}
FUNCTION VGACard: Boolean; ASSEMBLER;
ASM
  mov ah,$1a
  xor al,al
  int 10h
  cmp al,$1a
  jne @NoVGAdetected
  cmp bl,$08
  jne @NoVGAdetected
  mov al,true
  jmp @Exit
@NoVGAdetected:
  mov al,false
@Exit:
END;
{}
{
        Detect for presence of a Windows or DOS

        Expects: Nothing
        Returns: TRUE if running under windows, (not DOS!)
}
FUNCTION OSWindows : boolean;  Assembler;
ASM
  mov    ax,1600h
  int    2Fh
  cmp    al,1
  jbe    @@CheckRealStd
  cmp    al,80h
  jae    @@CheckRealStd
  mov    al,true
  jmp    @@ExitPoint
@@CheckRealStd:
  mov    ax,4680h
  int    2Fh
  or     ax,ax
  jnz    @@notWin
  mov    al,true
  jmp    @@ExitPoint
@@notWin:
  xor    al,al
@@ExitPoint:
END;
{
        Get information about the current file

        Expects: Nothing
        Returns: Nothing
}
FUNCTION GetExecInfo:string;
VAR DirInfo : SearchRec;
    DT       : Datetime;       { used for the date and time           }
    temp     : string;
    temp2    : string;

    {=-=-=-=-=- Used for the TIME/DATE display -=-=-=-=-=-=}
    function LeadingZero(w : Word) : String;
    VAR  s : String;
    BEGIN
       Str(w:0,s);
       if Length(s)=1 then s:='0'+s;
       LeadingZero:=s;
    END;

BEGIN
  GetExecInfo:='Unknown';
  temp:=GetEnv('CMDLINE');
  if pos('.',temp)=0 then temp:=temp+'.exe';
  findfirst(temp,archive,dirinfo);
  if DosError=0 then begin
     unpacktime(DirInfo.time,dt);
     temp2:='';
     
     GetExecInfo:=dirinfo.name;
     with DT do begin
       temp2:=temp2+LeadingZero(day)+'-';
       temp2:=temp2+LeadingZero(month)+'-';
       str(year,temp);   temp2:=temp2+temp;
       VGAWriteln(dirinfo.name+'   BUILD ON:'+temp2);
     end;
  end;

END;
{
        Open the debugfile, for program information etc...
        if compiler-directive DEBUG is active, this is automaticly called.

        Expects: Nothing
        Returns: Nothing
}
PROCEDURE ActivateDebug;
BEGIN
   if debug=false then begin

   assign(DebugFile,'debug.txt');
   rewrite(debugfile);
   writeln(DebugFile,'SuperFX Debugging output');
   writeln(DebugFile,'Projectname:',GetExecInfo);
   writeln(DebugFile,'----------------------------------------------');
   writeln(debugfile);
   writeln(DebugFile,'Conditional Directives:');
   writeln(debugfile);
   writeln(DebugFile,'----------------------------------------------');
   {$IFDEF DEBUG}
    writeln(Debugfile,'$DEBUG');
   {$ENDIF}
   {$IFDEF DEBUG_RETRACE}
    writeln(Debugfile,'$DEBUG_RETRACE');
   {$ENDIF}
   {$IFDEF PLUGIN_SHOWEVENTS}     { this will display DOOM/QUAKE like messages }
    writeln(Debugfile,'$PLUGIN_SHOWEVENTS');
   {$ENDIF}
   {$IFDEF PLUGIN_GCODE}          { make the parser available }
    writeln(Debugfile,'$PLUGIN_GCODE');
   {$ENDIF}
   {$IFDEF PLUGIN_DEMO}           { make the demo-record/playing available     }
    writeln(Debugfile,'$PLUGIN_DEMO');
   {$ENDIF}
   {$IFDEF PLUGIN_RUNTIME}        { for runtime-debugging procedures           }
    writeln(Debugfile,'$PLUGIN_RUNTIME');
   {$ENDIF}
   writeln(DebugFile,'----------------------------------------------');

   debug:=true;
 end;
END;
{}
BEGIN
 {$IFDEF DEBUG}ActivateDebug;{$ENDIF}

 InitBitmap;

 ASM
   mov ax,$13
   int 10h
   call ShowLogo

   mov dx,ds                    { remember DS }

   mov es,vpage_seg             { get screen SEGMENT }
   xor di,di                    { set screen offset to 0 }
   xor si,si                    { set virtual offset to 0 }
   mov ds,sega000               { get virtual segment }

   mov cx,16000                 { draw 64000/4 double words }

   DB $66;
   rep movsw                    { draw all bytes }

   mov ds,dx                    { get DS back }
 END;


 CursX:=0; CursY:=192; VGAtextcolor(15); VGAtextbackground(0);
 _InitDosPalette;

 {$IFDEF SHOWSYSTEMINFO}
    str(fxVersion div 256,halt_Error);
    str(fxversion and $ff,halt_proc);
    VGAtextcolor(15); VGAtextbackground(1);
    VGAWriteln('Powered by SuperFX Engine v'+halt_error+'.'+halt_proc+'          copyright 1996,1997 Just4Fun Productions');
    VGAtextcolor(7); VGAtextbackground(0);

    GetExecInfo;

    ShowBaseMemory;
    VGAwriteln('');
    {$IFDEF PLUGIN_GCODE}
      VGAWriteln('GCode library linked');
    {$ENDIF}

    {$IFDEF DEBUG}
      VGAwriteln('DEBUG MODE');
    {$ENDIF}
    {$IFDEF PLUGIN_RUNTIME}
      VGAwriteln('DEVELOPER MODE');
    {$ENDIF}
 {$ENDIF}

 halt_Error:='';

{

   Initialise Wave FX values

}
 FXSinusPosition := 0;
 FXWave          := false;
 FXLoop          := 1;
 FXOutCount      := 80;
 InitSinus;
{

   Initialise virtual BITMAP

}

{

   Initialise new KeyBoard Interrupt, and new EXIT procedure

}
  ExitSave:=NIL;
  InitInt09;

  oldexit:=ExitProc;     { remember the original exit Procedure    }
  ExitProc:=@NewExit;    { Let's put in our OWN exit procedure     }

  for x:=0 to 83 do FunctionKeys[x]:=0;
{

   See if a JOYSTICK/GAMEPAD is installed

}
 sample;
 JOYinstalled:=(x<>$FFFF);

 {$IFDEF SHOWSYSTEMINFO}
    if JOYinstalled then
       VGAWriteln('Joystick Found')
    else
       VGAwriteln('Joystick Not found');
 {$ENDIF}
{

   Initialise pointer variables

}
  FirstFX:=Nil;
  LastFX:=Nil;
  FirstLight:=Nil;
  LastLight:=Nil;
{

   Set some final values

}
   XtilesAmount:=320 shr TileShiftFactor;
   YtilesAmount:=(200 shr TileShiftFactor)+1;
   SetTEXTsegment(vpage_seg);

   FirstActive:=nil;
   LastActive:=nil;
   FirstShade:=nil;
   LastShade:=nil;
   FirstLight:=nil;
   LastLight:=nil;
   FirstFX:=nil;
   LastFX:=nil;
   LoadImages.data:=Nil;
   LoadOLD:=NIL;
   LIcon_ON:=False;

   {$IFDEF DEBUGGING}
     totalMaxSprites:=0;
     FramePerSecond:=70;
   {$ENDIF}

 if NOT VGAcard then begin
   VGAtextcolor(15);
   VGAwriteln('Error detecting the VGA card');
   VGAtextcolor(7);
   VGAwriteln('The SuperFX system was unable to detect you''r VGA card.');
   VGAwriteln('You can still continue this program, but if your system has no VGA card');
   VGAwriteln('you might not be able to play the game.');
   VGAwriteln('');
   VGAwriteln('press a key.');
   sound(850); Delay(150); NoSound;
   repeat until anypressed;
   {$IFNDEF SHOWSYSTEMINFO}
     VGAClrScr;
   {$ENDIF}
 end;

 IF OSWindows then begin
    VGAtextcolor(15);
    VGAwriteln('');
    VGAwriteln('Warning!');
    VGAtextcolor(7);
    VGAwriteln('Windows is detected, this program was designed to be used');
    VGAwriteln('under the DOS environment (wich is more stable).');
    VGAwriteln('Since you''r running windows, this program might not work correctly');
    VGAwriteln('');
    VGAwriteln('press a key.');
    VGAwriteln('');
    sound(850); Delay(150); NoSound;
    repeat until anypressed;
   {$IFNDEF SHOWSYSTEMINFO}
     VGAClrScr;
   {$ENDIF}

    { Set timer values, for optimal performance under windows }
    TIMEOUT := 14;         { number of interrupts pr frame     }
    TIMESLACK := -10;      { interrupt timer slack}
    OPsystem:=1;
 END else begin
    { Set timer values, for optimal performance under DOS     }
    TIMEOUT :=1;          { number of interrupts pr frame     }
    TIMESLACK :=-150;     { interrupt timer slack}
    OPsystem:=0;
 end;

 SetTimerInterrupt;
 {=-=-=-=-= Look for the autoexec file =-=-=-=-=-=}
 InitJoy;
 _InitDosPalette;
 {$IFDEF PLUGIN_GCODE}
   ConsoleOn:=False;
   _PARSEFILE('autoexec.sfx');
 {$ENDIF}
END.
